{//////////////////////////////////////////////////////////////////////l
//               MicroStar Version 1.00B                             //
//               Module : VARS.MS                                    //
//////////////////////////////////////////////////////////////////////}

Unit Edvar;

Interface

                      { TOOLBOX DECLARATIONS }

  const
    Nofile    = 'NONAME';          { Default filename printed in window }
    DefErrorFile = 'EDITERR.MSG';  { Default error message filename     }
    Line1     : Byte = 1;          { Logical line number 1 }
    Col1      : Byte = 1;          { Logical column number 1 }
    Lex1      = 1;                 { Lexical level 1 }
    Defnorows : Byte = 25;         { Default number of rows/physical screen }
    Defnocols = 80;                { Default number of cols/physical screen }
    Maxlinelength = 255;           { Maximum number of chars/string }
    Defhelplen= 9;                 { Default number of lines in help menu }
    Deftypahd = 500;               { Default number of chars/typeahead buf }
    Notavailable = 255;            { Used to test for input available }
    Maxmarker = 9;                 { Maximum number of text markers }
    HardCR = '';                  { Marker for lines with hard c/r's }
    NonLine = '.';                 { Marker for screen lines w/no text line }

    { The following is the set of ASCII control characters }

    Nul  = 0; Ctrla= 1; Ctrlb= 2; Ctrlc= 3; Ctrld= 4; Ctrle= 5;
    Ctrlf= 6; Ctrlg= 7; Ctrlh= 8; Ctrli= 9; Ctrlj=10; Ctrlk=11;
    Ctrll=12; Ctrlm=13; Ctrln=14; Ctrlo=15; Ctrlp=16; Ctrlq=17;
    Ctrlr=18; Ctrls=19; Ctrlt=20; Ctrlu=21; Ctrlv=22; Ctrlw=23;
    Ctrlx=24; Ctrly=25; Ctrlz=26; Escape=27; Del=127;

    { The following are the ASCII digits 0..9 }

    Zero = 48; One = 49; Two = 50; Three = 51; Four = 52;
    Five = 53; Six = 54; Seven = 55; Eight = 56; Nine = 57;

    { The following are flags to be used in the Linedesc record }

    Inblock = 1;                   { Set: display block in Blockcolor }
    Wrapped = 2;                   { Set: line was wrapped by wordwrap }
    Colored = 4;                   { Set: display line in Usercolor }

    Screenadr : Longint = $B800;   {Address of screen}
    Stwindow  : string [7] = 'Window:';
    Stfile    : string [5] = 'File:';
    Stline    : string [5] = 'Line:';
    Stcol     : string [4] = 'Col:';
    Stww      : string [2] = 'WW';

    { Search Character Categories }

    Alphas       : set of char = ['A'..'Z','a'..'z','0'..'9',''''];
    Separators   : set of char = [' '..'/', ':'..'@','['..'`', '{'..'}'];

  programname = 'MS5';

{ The following strings are the headlines of the pull-down menus. Insert     }
{ only spaces before the section. If you need more than one space after the  }
{ the whole line, change the value of "NoSpaces". The length must match the  }
{ the actual length of the string.                                           }

  st01 : string[10] = '     Block';
  st02 : string[13] = '       Search';
  st03 : string[12] = '       Go to';
  st04 : string[18] = '       Text format';
  st05 : string[10] = '      File';
  st06 : string[17] = '      Program';
  st07 : char       = '@';    { The headline and each submenu are terminated }
                              { by an empty String with length of "1"        }

{ The following strings are the labels for Pull-Down Menu #1- the Block Com- }
{ mands. The first entry must be padded with spaces because the length of    }
{ this string is used to represent the maximum length of a submenu's label.  }

  st11 : string[12] = 'Begin       ';
  st12 : string[03] = 'End';
  st13 : string[04] = 'Copy';
  st14 : string[04] = 'Move';
  st15 : string[04] = 'Read';
  st16 : string[05] = 'Write';
  st17 : string[06] = 'Delete';
  st18 : string[09] = 'Hide/show';
  st1x : char       = '@';

{ Pull-Down Menu #2 - Search Commands                                        }

  st21 : string[13] = 'Find         ';
  st22 : string[12] = 'find/Replace';
  st23 : string[04] = 'Next';
  st2x : char       = '@';

{ Pull-Down Menu #3 - GoTo Commands                                          }

  st31 : string[12] = 'Top of file ';
  st32 : string[11] = 'End of file';
  st33 : string[11] = 'Begin block';
  st34 : string[09] = 'end blocK';
  st35 : string[04] = 'Line';
  st36 : string[06] = 'Column';
  st37 : string[09] = 'Go marker';
  st38 : string[10] = 'Set marker';
  st3x : char       = '@';

{ Pull-Down Menu #4 - Text Format Commands                                   }

   { Note: The text of this menu is saved directly into the .COM file by   }
   {       the procedure "SaveDefault." If this menu is modified in any    }
   {       way, it may be necessary to disable the save feature.           }

  st41 : string[22] = 'Insert             ON ';
  st42 : string[22] = 'Word wrap         OFF ';
  st43 : string[22] = 'Auto indent        ON ';
  st44 : string[22] = 'Left margin:        1 ';
  st45 : string[22] = 'Right margin:      65 ';
  st46 : string[22] = 'Tab size:           8 ';
  st47 : string[22] = 'Undo limit            ';
  st4x : char       = '@';

{ Pull-Down Menu #6 - File Commands                                          }

  st51 : string[11] = 'Open       ';
  st52 : string[05] = 'Close';
  st53 : string[04] = 'Save';
  st54 : string[07] = 'save As';
  st55 : string[09] = 'Directory';
  st56 : string[10] = 'Logged dir';
  st57 : string[05] = 'Print';
  st58 : string[04] = 'copY';
  st59 : string[06] = 'Rename';
  st5A : string[05] = 'Erase';
  st5B : string[04] = 'Quit';
  st5x : char       = '@';

{ Pulldown Menu #7 - Data management Commands }
  st61 : string[22] = 'Create a model        ';
  st62 : string[22] = 'create a Table        ';
  st63 : string[22] = 'Maximum cases    18558';
  st6x : char       = '@';

{ -------------------------------------------------------------------------- }

                        { **** IMPORTANT **** }

  { The following items **** MUST **** remain typed constants, and must    }
  { not be re-ordered without changing the procedure "SaveDefault."        }
  {                                                                        }
  { The procedure "SaveDefault" writes new values for these constants      }
  { DIRECTLY INTO THE .COM FILE, and will destroy other locations if these }
  { constants are re-ordered or changed to variables.                      }

  Insertdef  : boolean = true;
  Wordwpdef  : boolean = false;
  Autoindef  : boolean = true;
  Tabdef     : Integer = 8;
  Undodef    : Integer = 20;
  Lmargindef : integer = 1;
  Rmargindef : integer = 65;
  Windowlines: integer = 10;
  DummySt    : String[10] = '         ';


{ -------------------------------------------------------------------------- }

  UpperLeft  = 201; { '' }
  UpperRight = 185; { '' }
  LowLeft    = 200; { '' }
  LowRight   = 188; { '' }
  Horizontal = 205; { '' }
  Vertical   = 186; { '' }
  TConnect   = 203; { '' }
  RConnect   = 206; { '' }
  LConnect   = 204; { '' }
  LRConnect  = 202; { '' }

  WUpperleft = 201; { '' }
  WUpperright= 187; { '' }
  WLowLeft   = 200; { '' }
  WLowRight  = 188; { '' }
  WHorizontal= 205; { '' }
  WVertical  = 186; { '' }

  CursorLeft  = ^S;
  CursorRight = ^D;
  CursorDown  = ^X;
  CursorUp    = ^E;
  PageUp      = ^R;
  PageDown    = ^C;

  NoSpaces   =  1;                   { Trailing spaces after the headline    }

  MaxSubmenu   = 10;                 { Maximum no. of submenus               }
  MaxSelection = 14;                 { Max no. of selections in a submenu    }
  MaxSave      = 17;                 { Max no. of lines to save under menu   }
  MaxWide      = 30;                 { Maximum width of selection            }

  CursorOff = $2000;

  MaxWindowX   = 80;                 { Maximum columns in window             }
  MaxWindowY   = 20;                 { Maximum lines in window               }

  TargetColumn :Integer = 1;
  TargetLine   :Integer = 1;
  TargetMarker :Integer = 1;
  Printing     :boolean = false;

  FilePrompt   : String[09] = 'Filename:';
  FileMsg      : String[30] = 'Writing the file. Please wait ';

  FileCharFilter: set of char = ['0'..'9','@'..'Z',':','.','-','_','$','\'];
  PrintingCharFilter : set of char = [#32..#127,#156];
  OptCharFilter : set of char = ['G','B','N','U','W','0'..'9'];
  TCaseLimit : integer = 18558;

  type

    Varstring  = string [80];
    String80   = string [80];
    Str50      = string [50];
    Textline   = string [Maxlinelength];
    Strvartype = string [Maxlinelength];
    St6        = string [6];

    Character  = record
                   Ch : char;
                   Color : byte
                 end;

    Plinedesc  = ^ Linedesc;
    Ptextline  = ^ Textline;
    Pwindesc   = ^ Windesc;

    Linedesc   = record                    {A complete text line, with links}
                   Fwdlink  : Plinedesc;   {Ptr to previous line in stream}
                   Backlink : Plinedesc;   {Ptr to next line in stream}
                   Txt      : Ptextline;   {Ptr to line buffer}
                   Flags    : integer;     {Define these in the const section}
                   BuffLen  : integer      {This pads the record to X*4 bytes}
                 end;

    Insflag = (Insert, Typeover);          {Used only in window records}

    Windesc     = record
                   Fwdlink     : Pwindesc;      {Next window down}
                   Backlink    : Pwindesc;      {Next window up}
                   Filename    : String;        {File being edited}
                   Insertflag  : Insflag;       {Insert mode flag}
                   WW          : boolean;       {Wordwrap mode}
                   AI          : boolean;       {Autoindent mode}
                   Firstlineno : integer;       {Physical top line number}
                   Lastlineno  : integer;       {Physical bottom line no}
                   Lmargin     : integer;       {Left margin column number}
                   Rmargin     : integer;       {Right margin column number}
                   Lineno      : integer;       {Last cursor address}
                   Colno       : integer;       {Last cursor address}
                   Clineno     : integer;       {Display only: line in file}
                   Topline     : Plinedesc;     {Ptr to first line in view}
                   Curline     : Plinedesc;     {Ptr to line cursor is On}
                   Stream      : integer;       {Unique text stream id}
                   Leftedge    : integer;       {Leftmost displayed text column}
                 end;

    fstr66 = String[66];
    st40 = String[40];

var

    Physcrrows : integer;    { No. lines/physical screen }
    Physcrcols : integer;    { No. cols/physical line }
    Logscrrows : integer;    { No. lines/logical screen }
    Logscrcols : integer;    { No. cols/logical line }
    Logtopscr  : integer;    { Physical line no. for logical line #1 }
    Retracemode: boolean;    { Set if wait for vertical retrace is needed }
    Linelength : integer;    { Number of chars/textline }

    Bordcolor  : integer;    { Border color from init routine }
    Txtcolor   : integer;    { Text color from init routine }
    Blockcolor : integer;    { Block color from init routine }
    Cmdcolor   : integer;    { Command line color from init routine}
    Usercolor  : integer;    { Special display color -- user programmable }

    Blockfrom  : Plinedesc;  { Points to beginning of block }
    Blockto    : Plinedesc;  { Points to end of block }
    Blockhide  : boolean;    { Set if block is not displayed }

    Curwin     : Pwindesc;   { Pointer to window containing cursor }
    Window1    : Pwindesc;   { Pointer to window at top of screen  }

    Marker     : array [1..Maxmarker] of Plinedesc; {Text markers}

    Rundown    : boolean;    { Determines when scheduler aborts }
    Notfound   : boolean;    { Set by search and replace cmds }
    Replast    : boolean;    { Determines which operation EditFindNext does }
    Abortcmd   : boolean;    { Set by EditAbort to stop EditAskfor }
    Aborting   : boolean;    { Set by EditAbort to stop recursion }
    Typbufovl  : boolean;    { Used by EditPushtbf only!}
    Undocount  : integer;    { Number of lines currently on undo stack }
    Undolimit  : integer;    { Maximum number of lines on undo stack }
    Undostack  : Plinedesc;  { Top of undo stack }
    Undoend    : Plinedesc;  { Pointer to last record on undo stack }
    Searchstr  : Varstring;  { Used by EditSearch, EditSearchReplace }
    Replacestr : Varstring;  { Used by EditSearchReplace }
    Optstr     : Varstring;  { Used by EditFindNext }
    IgnCase    : boolean;    { Used by EditScanFwd and EditScanBack }
    WholeWord  : boolean;    { Used by EditScanFwd and EditScanBack }
    Nextstream : integer;    { Next stream id to be assigned }

    Intrflag   : (Nointrpt,Intrpt);       {Scheduling}
    Updcurflag : boolean;    { Set if we must reposition cursor }
    Tabsize    : integer;    { Distance between tab stops }
    ScreenOld  : array [1..25, 1..80] of Character;
    Circbuf    : array [0..Deftypahd] of char;
    Circin     : integer;    {Pointer to put data into the c.b.}
    Circout    : integer;    {Pointer to take data out of c.b.}
    EditUsercommandInput : integer; {count of chars pushed by UserCommand}
    Winstack   : Pwindesc;   { Ptr to free list of windows }
    EditChangeFlag : boolean;{Indicates changes in text}

                     { MICROSTAR-SPECIFIC DECLARATIONS }

                     { Colors for the pulldown menus                                              }
  PNormColor  : integer;             { Color of non-selected parts           }
  PLowColor   : integer;             { Color of selected parts               }
  PFrameColor : integer;             { Color of frame                        }

                     { Colors for the windows                                                     }
  WNormColor  : integer;             { Color of non-selected parts           }
  WLowColor   : integer;             { Color of selected parts               }
  WFrameColor : integer;             { Color of frame                        }

  NoSubmenus   :Byte;                   { Number of submenus (max. 10)       }
  MenuData     :Array[1..MaxSubmenu] of { Definition of main pull-down menu  }
                  Record
                    MenuChar :Char;     { Significant Character              }
                    Position :Byte;     { Horizontal position on screen      }
                    MenuAddr :word;     { Offset for Address                 }
                    SegAddress:word;    { Segment for Address                }
                    SubStart :word;     { Start of submenu                   }
                    SubSeg   :word;     { Start of submenu segment           }
                  End;

  NoSelection  :Byte;                     { Number of entrys in submenu      }
  SelectionData:Array[1..MaxSelection] of { Definition of submenu            }
                  Record
                    SubChar  :Char;       { Significant character            }
                    SubAddr  :Word;       { Offset for Address               }
                    SubSeg   :Word;       { Segment for Address              }
                  End;
  SaveSubmenu  :array [0..MaxSave] of     { Data structure to save the       }
                array [0..MaxWide] of     { old screen under a submenu       }
                Integer;

  MenuStatus   :Byte;                  { Status of selection                 }
  CurrSubmenu  :Byte;                  { Current submenu                     }
  CurrSelection:Byte;                  { Current selection within submenu    }
  CurrAddress   :Integer;              { Current Address in definition       }
  CurrPosition :Byte;                  { Current horizontal position         }
                                       { on screen                           }
  EndPosition  :Byte;                  { Last character of main line         }
  SubMenuPos   :Byte;                  { Horizontal start of submenu         }
  SubLength    :Byte;                  { Wide of pulldown menu               }
  MenuColor    :Integer;               { Current color                       }
  MemAdr       :Integer;               { Address in memory for next char.    }
                                       { to display                          }
  Counter      :Integer;               { General purpose loop counters       }
  Counter1     :Integer;
  XPosition    :Integer;               { Basic Address of pulldown menu      }
  YPosition    :Integer;
  PdSaveCursor :Integer;               { Cursor mode on entry to pulldowns   }
            { Array to save the screen under a pop-up window }
  WArray        : array[1..3,0..MaxwindowY,0..MaxWindowX] of integer;
  SecondWindow :boolean;               { Indicates if 2nd window is open     }
  CurrWindow   :Byte;                  { Active window                       }
  CharFilter   :Set of char;           { Filter for string input             }
  IOSave       :Byte;                  { Saves IOResult for later use        }
  CurSorOn     :Integer;
  SaveCmdLine  :string[160];           { Saves line 1                        }
  NoWorkfile   :boolean;               { No file opened                      }
  FileExist    :boolean;
  CopySource :  fstr66;
  CopyTarget :  fstr66;
  DirMask    :  fstr66;
  DeleteString: fstr66;
  RenameString: fstr66;
  WorkFilename: fstr66;
  BlockFilename:fstr66;
  WriteFilename:fstr66;
  PrintFilename:fstr66;
  FilePath     :fstr66;
  ErrorFile    :fstr66;
  printbufferptr:integer;
  printbuffer  :array [0..127] of char;
  printfile    :file;
  printcolumn  :integer;
  printstack   :array [1..10] of char;
  printstackindex: integer;
  Bold : boolean;               {Indicates boldface mode in print}
  DoubleSt : boolean;             {Indicates doublestrike mode in print}
  UndScore : boolean;           {Indicates underlining mode in print}
  Subscript : boolean;          {Indicates subscript mode in print}
  Superscript : boolean;        {Indicates superscript mode in print}
  FreeMemory,                   {Current free memory }
  Last_Free_Memory : Longint;   {free memory last time Userstatusline called}

  Above_Text_Area : Boolean;
  Command_Screen_Col,
  Command_Screen_Row : Integer;

  CommandCol,
  CommandRow,
  XPosit,
  YPosit,
  OldX,
  OldY           : integer;
  chosen,
  Word_Highlighted,
  Choices_Made,
  StringFinished,
  Top_Screen_New,
  MouseInst : boolean;
  SavedWord,
  SelStr         : Str50;
  WindowNum      : Byte;
  File_Ary       : Array [1..40] of String[12];
  OpenFiles      : Integer;
  File_Ary_Pos   : Integer;
  PrDrive        : String[2];

implementation

begin
end.
