unit ReadConstits;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Crt, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

const
  max_candidates = 20;

type

  PrecPt    = ^PrecBuf;
  PrecBuf   = Record
                 day   : integer;
                 Name  : String;
                 next  : PrecPt;
                 dup   : Boolean;
                 fname : String;
              end;

  CandPt    = ^CandBuf;
  CandBuf   = Record
                 Vote    : Longint;
                 VotePer : Real;
                 Name    : String;
                 Party   : String;
                 next    : CandPt;
              end;

  CBuf      = Record
                  CandRoot     : CandPt;
                  PrecRoot     : PrecPt;
                  //    The following arrays are intended to store the results
                  //    only of the HTML file with the largest value for the
                  //    Total votes cast variable in the Vote Tally section of
                  //    the HTML file
                  Votes        : array[1..max_candidates] of LongInt;
                  VotePer      : array[1..max_candidates] of Real;
                  Names        : array[1..max_candidates] of String;
                  Party        : array[1..max_candidates] of String;

                  //    The following arrays contain the same data as the arrays
                  //    above but only for precincts with an early RESULTS DATE
                  //    on the HTML file
                  eVotes        : array[1..max_candidates] of LongInt;
                  eVotePer      : array[1..max_candidates] of Real;
                  eNames        : array[1..max_candidates] of String;
                  eParty        : array[1..max_candidates] of String;
                  eTotalVote    : longint;

                  //    The following arrays contain the same data as the arrays
                  //    above but only for precincts with a late RESULTS DATE
                  //    on the HTML file
                  lVotes        : array[1..max_candidates] of LongInt;
                  lVotePer      : array[1..max_candidates] of Real;
                  lNames        : array[1..max_candidates] of String;
                  lParty        : array[1..max_candidates] of String;
                  lTotalVote    : longint;

                  //    The following arrays contain the same data as the arrays
                  //    above but have been calculated by aggregating together
                  //    the precinct files within each congress district
                  aVotes        : array[1..max_candidates] of LongInt;
                  aVotePer      : array[1..max_candidates] of Real;
                  aNames        : array[1..max_candidates] of String;
                  aParty        : array[1..max_candidates] of String;

                  // the following three arrays are used to keep a record
                  // of precinct HTML files manifesting one of these issues
                  // a) 0-1 votes
                  // b) 2-8 votes
                  // c) only partial results (i.e. the percentage congress votes
                  //    do not sum to 100%
                  Zero_Files   : array[1..max_candidates] of String;
                  Smal_Files   : array[1..max_candidates] of String;
                  Falt_Files   : array[1..max_candidates] of String;
                  prec_count   : longint;
                  early_count  : longint;
                  late_count   : longint;
                  smal_precs   : integer;
                  zero_precs   : integer;
                  flty_precs   : integer;
                  early_agg_vote:  longint;
                  late_agg_vote :  longint;
                  TotalVote    : LongInt;
                  Prec_Gap     : real;
                  Time_Gap     : real;
                  Constit_Name : String;
                  Filename     : String;
                  candidate_cnt : integer;
                  agg_vote     : LongInt;
                  early_winner,
                  late_winner,
                  summary_winner,
                  precinct_winner : integer;
              End;
  CPtr      = ^CBuf;

  SeatPtr   = ^SeatRec;
  SeatRec   = Record
                  next       : SeatPtr;
                  prev       : SeatPtr;
                  thisRec    : Cptr;
              End;


var
  Form1: TForm1;
  hConsoleInput: THandle;
  hConsoleOutput: THandle;

  month_array   : Array[1..12] of integer;
  day_array     : Array[1..31] of integer;
  congress_votes: Array[1..300] of CPtr;
  File_Counter: LongInt;
  highest_constit_number  : integer;
  Totvote_root  :   SeatPtr;
  Alpha_root    :   SeatPtr;
  Prec_root     :   SeatPtr;
  Size_root     :   SeatPtr;
  Time_root     :   SeatPtr;
  Location_area :   Boolean;
  Precinct_Flag :   Boolean;
  Early_Flag    :   Boolean;
  Date_Set      :   Boolean;
  endfilename   :   String;
  rfilename     :   String;
  cinx          :   integer;
  glob_bad_html :   longint;
  glob_zero_prec:   longint;
  chinx         :   integer;
  timely_results:   longint;
  late_results  :   longint;
  cnt0,
  cnt1,
  cnt2,
  cnt3,
  cnt4,
  cnt5       : integer;
  running_total : real;
  current_message,
  last_filename,
  last_precinct,
  current_precinct : string;
  current_region : string;
  current_CP : longint;
  early_winner_vote,
  late_winner_vote,
  summary_winner_vote,
  precinct_winner_vote : longint;
  Prec_Final_Digit_Array : Array[0..10] of integer;
  Summ_Final_Digit_Array : Array[0..10] of integer;
  Prec_Final_Digit_Proportions : Array[0..10] of real;
  Summ_Final_Digit_Proportions : Array[0..10] of real;
  Prec_Congress_Votes : longint;
  Summ_Congress_Votes : longint;
  Prec_Adjacent_Digits : longint;
  Summ_Adjacent_Digits : longint;
  Prec_Repeated_Digits : longint;
  Summ_Repeated_Digits : longint;


function ReadKey: char;
Procedure ReadOpen (namestr : string;  var infile :  TEXT);

implementation

{$R *.dfm}


function ReadKey: char;
var
  NumRead: DWORD;
  InputRec: TInputRecord;
begin
  repeat
    repeat
    until KeyPressed;
    ReadConsoleInput(hConsoleInput, InputRec, 1,NumRead);
  until InputRec.Event.KeyEvent.AsciiChar > #0;
  Result := InputRec.Event.KeyEvent.AsciiChar;
end;


Procedure ReadOpen(namestr : string; var infile :  TEXT);
var
     label1     : string;
     label2     : string;
     fullname   : string;
     instring   : string;
     totvotePos : integer;
     constpos   : integer;
     targpos    : integer;
     stlen      : integer;
     res_string : string;
     res_month  : string;
     res_day    : string;
     result_m   : integer;
     result_d   : integer;
     resfile    : TEXT;
     seat_counter : integer;
     tempBuf      : CBuf;
     brackpos     : integer;
     constname    : string;
     percentPos   : integer;
     spanStart,
     spanEnd      : integer;
     candName     : string;
     cand_Counter  : integer;
     thisVote      : Longint;
     code          : integer;
     tdclass       : integer;
     conIdx        : integer;
     thisPer       : real;
     seat_number   : integer;
     display_num,
     display_text  : string;
     locIndex : integer;

     Function Find_Constituency_Number(namestr: string): integer;
     var
         index : integer;
     begin
         index := 1;
         while ((congress_votes[index]^.Constit_Name <> namestr) and
                (congress_votes[index]^.Constit_Name <> 'blank') and
                (index<290))  do
         begin
            index:= index + 1;
         end;
         if (index > highest_constit_number) then
              highest_constit_number:= index;
         Find_Constituency_Number:=index;
     end;

     Procedure Copy_Constituency_Data(idx : integer; tbuf : CBuf; cands: Integer; Prec_Flag : boolean);
     var
         idx2,
         idx3  : integer;
         target,
         cnidx : integer;
         nextPt,
         prevPt,
         candpointer : candPt;
         candHoldPtr,
         tempCand : candPt;
         tempPrecPt,
         prevPrecPt,
         precPointer  : precPt;
         Repeated_Digits,
         Adjacent_Digits_Consecutive : boolean;
         tempString : string;
         digit_array     : Array [0..20] of integer;
     begin
         if (prec_Flag) then
         begin
            precpointer := congress_votes[idx]^.precRoot;
            if (precpointer=nil) then
              begin
                new(congress_votes[idx]^.precRoot);
                congress_votes[idx]^.precRoot^.day:= result_d;
                congress_votes[idx]^.precRoot^.next:= nil;
                congress_votes[idx]^.precRoot^.Name:= current_precinct;
                congress_votes[idx]^.precRoot^.dup:= false;
                congress_votes[idx]^.precRoot^.fname:= endfilename;
              end
            else
              begin
                precpointer:= congress_votes[idx]^.precRoot;
                while ((precPointer<> nil)and(current_precinct > precPointer^.Name)) do
                  begin
                    prevPrecPt:= precPointer;
                    precPointer:= precPointer^.next;
                  end;
                if (precPointer=nil) then
                  begin
                    new(precPointer);
                    precPointer^.Name:= current_precinct;
                    precPointer^.day:= result_d;
                    precPointer^.dup := false;
                    precPointer^.fname := endfilename;
                    PrecPointer^.next:= nil;
                    prevPrecPt^.next := precPointer;
                  end
                else
                  begin
                    prevPrecPt:= precPointer;
                    new(precPointer);
                    precPointer^.Name:= current_precinct;
                    precPointer^.day:= result_d;
                    precPointer^.dup := false;
                    precPointer^.fname := endfilename;
                    PrecPointer^.next:= prevPrecPt^.next;
                    prevPrecPt^.next := precPointer;
                  end;
              end;
         end;
         candpointer := tempBuf.CandRoot;
         while ((candpointer<>nil) and (candpointer.next<> nil)) do
         begin
            tempCand:= candpointer;
            candpointer := candpointer.next;
            dispose(tempCand);
         end;
         new(tempBuf.CandRoot);
         candPointer:= tempBuf.candRoot;
         candpointer.vote   := tempBuf.Votes[1];
         candpointer.voteper := tempBuf.VotePer[1];
         candpointer.Name   := tempBuf.Names[1];
         candpointer.Party  := tempBuf.Party[1];
         candpointer.Next := nil;
         for cnidx:= 2 to cands do
         begin
            tempCand := tempBuf.CandRoot;
            while ((tempBuf.Names[cnidx] > tempCand.Name) and (tempCand.next <> nil)) do
            begin
                prevpt:= tempCand;
                tempCand := tempCand.next;
            end;
            if (tempBuf.Names[cnidx] < tempBuf.CandRoot.Name) then
              begin
                // new record forms the new start of the linked list
                New(candHoldPtr);
                CandHoldPtr.Name := tempBuf.Names[cnidx];
                CandHoldPtr.Party := tempBuf.Party[cnidx];
                CandHoldPtr.Vote := tempBuf.votes[cnidx];
                CandHoldPtr.VotePer := tempBuf.VotePer[cnidx];
                tempCand:= tempBuf.CandRoot;
                tempBuf.CandRoot:= CandHoldPtr;
                tempBuf.CandRoot.next := tempCand;
              end
            else if ((tempBuf.Names[cnidx] > tempCand.Name)and(tempCand.next=nil)) then
              begin
                // new record forms the new end of the linked list
                New(tempCand.next);
                tempCand.next.Name := tempBuf.Names[cnidx];
                tempCand.next.Party := tempBuf.Party[cnidx];
                tempCand.next.Vote := tempBuf.votes[cnidx];
                tempCand.next.VotePer := tempBuf.VotePer[cnidx];
                tempCand.next.next:= nil;
              end
            else
              begin
                // new record goes in the middle of the linked list
                New(candHoldPtr);
                CandHoldPtr.Name := tempBuf.Names[cnidx];
                CandHoldPtr.Party := tempBuf.Party[cnidx];
                CandHoldPtr.Vote := tempBuf.votes[cnidx];
                CandHoldPtr.VotePer := tempBuf.VotePer[cnidx];
                nextPt := tempCand;
                candHoldPtr.next := nextPt;
                prevPt.next := candHoldPtr;
              end;
         end;
         tempCand := tempBuf.CandRoot;
         cnidx:= 1;
         repeat
            tempBuf.Votes[cnidx]:= tempCand.Vote;
            tempBuf.VotePer[cnidx]:= tempCand.VotePer;
            tempBuf.Names[cnidx]:= tempCand.Name;
            tempBuf.Party[cnidx]:= tempCand.Party;
            inc(cnidx);
            tempCand := tempCand.next;
         until tempCand = nil;
         if ((congress_votes[idx]^.constit_name<>'blank')and(congress_votes[idx]^.candidate_cnt<>cands))  then
            begin
            end
         else if (Prec_Flag=false) then
            begin
              congress_votes[idx]^.TotalVote:= tempBuf.TotalVote;
              congress_votes[idx]^.Constit_Name:= tempBuf.Constit_Name;
              congress_votes[idx]^.filename := tempBuf.filename;
              congress_votes[idx]^.candidate_cnt:= cands;
              for idx2:= 1 to cands do
              begin
                congress_votes[idx]^.Votes[idx2]:= tempBuf.Votes[idx2];
                congress_votes[idx]^.VotePer[idx2]:= tempBuf.VotePer[idx2];
                congress_votes[idx]^.Names[idx2]:=tempBuf.Names[idx2];
                congress_votes[idx]^.Party[idx2]:=tempBuf.Party[idx2];
              end;
            end
         else
            begin
              for idx2:= 0 to 20 do
                digit_array[idx2]:= 0;
              for idx2:= 1 to cands do
              begin
                repeated_digits:=false;
                adjacent_digits_consecutive:= false;
                inc(prec_congress_votes);
                str(tempBuf.Votes[idx2], tempString);
                for idx3:= 1 to length(tempString) do
                  begin
                    digit_array[idx3]:= byte(tempString[idx3])-48;
                    if (idx3 > 1) then
                      begin
                        if (digit_array[idx3]=((digit_array[idx3-1])+1)) then
                            adjacent_digits_consecutive:= true
                        else if (digit_array[idx3]=((digit_array[idx3-1])-1)) then
                            adjacent_digits_consecutive:= true;
                        if (digit_array[idx3]=digit_array[idx3-1]) then
                            repeated_digits:= true;
                      end;
                  end;
                if (adjacent_digits_consecutive) then
                  inc(Prec_Adjacent_Digits);
                if (repeated_digits) then
                  inc(Prec_Repeated_Digits);
                stlen:= length(tempString);
                target:= byte(tempString[stlen])-48;
               // if (tempBuf.Votes[idx2] > 99) then
                inc(Prec_Final_Digit_Array[target]);
                inc(congress_votes[idx]^.prec_count);
                congress_votes[idx]^.aVotes[idx2]:= congress_votes[idx]^.aVotes[idx2]+tempBuf.Votes[idx2];
                congress_votes[idx]^.aVotePer[idx2]:=congress_votes[idx]^.aVotePer[idx2]+tempBuf.VotePer[idx2];
                 {
                if ((running_total >= 99.1)and
                    (congress_votes[idx]^.Names[idx2]<>'blank')and
                    (congress_votes[idx]^.Names[idx2]<>tempBuf.Names[idx2])) then
                    begin
                      Showmessage('Contituency ' + tempBuf.constit_name + 'different candidate names on precinct and main file ' + tempBuf.filename
                                + ' local procedure candidate name = ' + tempBuf.Names[idx2]
                                + ' main array candidate name = ' + congress_votes[idx]^.Names[idx2]
                                + ' candidate position = ' + inttostr(idx2)
                                + ' constituency position = ' + inttostr(idx));
                    end;
                if ((running_total> 99.1) and
                    (congress_votes[idx]^.Party[idx2]<>'blank')and
                    (congress_votes[idx]^.Party[idx2]<>tempBuf.Party[idx2])) then
                    begin
                      Showmessage('Contituency ' + tempBuf.constit_name + 'different party names on precinct and main file ' + tempBuf.filename);
                    end; }
                if (Early_Flag) then
                    begin
                      congress_votes[idx]^.early_agg_vote:=
                         congress_votes[idx]^.early_agg_vote+tempBuf.totalvote;
                      inc(congress_votes[idx]^.early_count);
                      congress_votes[idx]^.eVotes[idx2]:= congress_votes[idx]^.eVotes[idx2]+tempBuf.Votes[idx2];
                      congress_votes[idx]^.eVotePer[idx2]:=congress_votes[idx]^.eVotePer[idx2]+tempBuf.VotePer[idx2];
                    end
                else
                    begin
                      congress_votes[idx]^.late_agg_vote:=
                         congress_votes[idx]^.late_agg_vote+tempBuf.totalvote;
                      inc(congress_votes[idx]^.late_count);
                      congress_votes[idx]^.lVotes[idx2]:= congress_votes[idx]^.lVotes[idx2]+tempBuf.Votes[idx2];
                      congress_votes[idx]^.lVotePer[idx2]:=congress_votes[idx]^.lVotePer[idx2]+tempBuf.VotePer[idx2];
                    end;
              end;
            end;
     end;

     procedure read_seat;
     var
         candidx       : integer;
     begin
         running_total := 0;
         for candidx := 1 to max_candidates do
            begin
                 tempBuf.names[candidx]:= '';
                 tempBuf.Party[candidx]:= '';
            end;
         if (constpos > 0) then
              begin
                 seat_number:= seat_number + 1;
                 stlen:= length(res_string);
                 instring:= copy(res_string,(constpos+36),stlen);
                 brackpos := pos('<', instring);
                 constname := copy(instring,1,brackpos-1);
                 TempBuf.Constit_name:= constname;
                 TempBuf.fileName := rfilename;
                 TempBuf.TotalVote:= -1;
                 if ((File_Counter mod 100)=1) then
                 begin
                    Label2 :='Reg = ' + current_region + ' Constit= ' + constname;
                    Form1.Panel1.SetTextBuf(PAnsiChar(Label2));
                    Form1.Repaint;
                 end;
                 readln(resfile, res_string);
                 cand_counter:=1;
                 repeat
                     readln(resfile, res_string);
                     totvotePos:= pos('Total number of Voters who actually voted',res_string);
                     percentPos:= pos('>Percentage</th>',res_string);
                     if (percentPos > 0) then
                     begin
                         readln(resfile, res_string);
                         readln(resfile, res_string);
                         readln(resfile, res_string);
                         readln(resfile, res_string);
                         readln(resfile, res_string);
                         repeat
                           spanStart:= pos('<span>', res_string)+6;
                           stlen := length(res_string);
                           instring:= copy(res_string, spanStart, stlen);
                           spanEnd:= pos('</span>', instring);
                           candName := copy(instring,1,spanEnd-1);
                           TempBuf.Names[cand_counter]:=candName;
                           readln(resfile, res_string);
                           spanStart:= pos('<span>', res_string)+6;
                           stlen := length(res_string);
                           instring:= copy(res_string, spanStart, stlen);
                           spanEnd:= pos('</span>', instring);
                           candName := copy(instring,1,spanEnd-1);
                           TempBuf.Party[cand_counter]:=candName;
                           readln(resfile, res_string);
                           spanStart:= pos('<span>', res_string)+6;
                           stlen := length(res_string);
                           instring:= copy(res_string, spanStart, stlen);
                           spanEnd:= pos('</span>', instring);
                           candName := copy(instring,1,spanEnd-1);
                           val(candName,thisVote,code);
                           TempBuf.Votes[cand_counter]:=thisVote;
                           readln(resfile, res_string);
                           spanStart:= pos('<span>', res_string)+6;
                           stlen := length(res_string);
                           instring:= copy(res_string, spanStart, stlen);
                           spanEnd:= pos('</span>', instring);
                           candName := copy(instring,1,spanEnd-1);
                           val(candName,thisPer,code);
                           if (thisPer> 0) then
                              thisPer := thisPer / 100;
                           running_total:= running_total+thisPer;
                           TempBuf.Voteper[cand_counter]:=thisPer;
                           readln(resfile, res_string);
                           readln(resfile, res_string);
                           readln(resfile, res_string);
                           readln(resfile, res_string);
                           cand_counter:= cand_counter+1;
                           tdclass := pos('td class', res_string);
                           totvotePos:= pos('Total number of Voters who actually voted',res_string);
                         until (tdclass < 1);
                         repeat
                           readln(resfile, res_string);
                           totvotePos:= pos('Total number of Voters who actually voted',res_string);
                           //if (totvotePos <=0) then
                           //   totvotePos:= pos('Vote Tally Statistics',res_string);
                         until ((totvotePos > 0)or (eof(resfile)));
                         cand_counter:= cand_counter-1;
                         if (eof(resfile)=false) then
                          begin
                            readln(resfile, res_string);
                            spanStart:= pos('"right">', res_string)+6;
                            stlen := length(res_string);
                            instring:= copy(res_string, spanStart, stlen);
                            spanEnd:= pos('</td>', instring);
                            candName := copy(instring,3,spanEnd-3);
                            val(candName,thisVote,code);
                          end;
                         //else
                         // thisVote := 0;
                         TempBuf.TotalVote:=thisVote;
                         conIdx:=Find_Constituency_Number(TempBuf.Constit_Name);
                         if ((Precinct_Flag=false)and(thisVote>congress_votes[conIdx]^.TotalVote)) then
                              copy_constituency_data(conIdx, TempBuf, cand_counter, false)
                         else if (Precinct_Flag=true) then
                           begin
                              congress_votes[conIdx]^.agg_vote:=
                                   congress_votes[conIdx]^.agg_vote + TempBuf.TotalVote;
                              copy_constituency_data(conIdx, TempBuf, cand_counter, true);
                              if (TempBuf.TotalVote = 1) then
                                begin
                                  inc(congress_votes[conIdx]^.zero_precs);
                                  cinx := 1;
                                  while ((cinx<max_candidates)and(length(congress_votes[conIdx]^.Zero_Files[cinx])>1)) do
                                    inc(cinx);
                                  congress_votes[conIdx]^.Zero_Files[cinx]:= endfilename;
                                end
                              else if (running_total < 99.9) then
                                begin
                                  inc(congress_votes[conIdx]^.flty_precs);
                                  cinx := 1;
                                  while ((cinx<max_candidates)and(length(congress_votes[conIdx]^.falt_files[cinx])>1)) do
                                    inc(cinx);
                                  congress_votes[conIdx]^.falt_Files[cinx]:= endfilename;
                                end
                              else if (congress_votes[conIdx]^.Constit_Name <> 'blank') then
                                begin
                                  if (congress_votes[conIdx]^.candidate_cnt <> cand_counter) then
                                    begin
                                      Showmessage('Contituency ' + tempBuf.constit_name +' has different numbers of candidates in different files ' +
                                      endfilename);
                                    end;
                                end
                              else if ((TempBuf.TotalVote >= 2)and(TempBuf.TotalVote<=10)) then
                                begin
                                  inc(congress_votes[conIdx]^.smal_precs);
                                  cinx := 1;
                                  while ((cinx<max_candidates)and(length(congress_votes[conIdx]^.smal_Files[cinx])>1)) do
                                    inc(cinx);
                                  congress_votes[conIdx]^.Smal_Files[cinx]:= endfilename;
                                end;
                           end;
                     end;
                 until((totVotePos > 0)or (eof(resfile)));
              end;
     end;

     Procedure Create_Size_List;
     var
        cIdx  : integer;
        temp : SeatPtr;
        newRec : SeatPtr;
        current_rec : Cptr;
     begin
        Size_Root := New(SeatPtr);
        Size_Root^.prev:= nil;
        Size_Root^.next:= nil;
        Size_Root^.thisRec := congress_votes[1];
        for cIdx:= 2 to highest_constit_number do
          begin
              current_rec :=  congress_votes[cIdx];
              // case where current constituency is before the root
              if (congress_votes[cIdx]^.TotalVote < Size_Root^.thisRec^.TotalVote) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.TotalVote < Size_Root^.thisRec^.TotalVote)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.TotalVote > Size_Root^.thisRec^.TotalVote)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= Size_Root;
                  newRec^.next:=nil;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.next:= newRec;
                end
              else if (congress_votes[cIdx]^.TotalVote > Size_Root^.thisRec^.TotalVote) then
                begin
                  temp:= Size_Root;
                  while ((temp^.next<> nil) and
                         (current_rec^.TotalVote > temp^.thisRec^.TotalVote)) do
                         temp:= temp^.next;
                  // if we are at the end of the list
                  if (temp^.next=nil) then
                    begin
                      if (temp^.thisRec^.TotalVote > congress_votes[cIdx]^.TotalVote) then
                        begin
                          // the new record inserted at penultimate position
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp^.prev;
                          newRec^.next:= temp;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.prev^.next:= newRec;
                          temp^.prev:= newRec;
                        end
                      else
                        begin
                          // the new record is inserted at the end
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp;
                          newRec^.next:= nil;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.next:= newRec;
                        end
                    end
                  // or else we are in the middle of the linked list
                  else
                    begin
                      newRec := new(SeatPtr);
                      newRec^.prev:= temp^.prev;
                      newRec^.next:= temp;
                      newRec^.thisRec:= congress_votes[cIdx];
                      temp^.prev^.next:= newRec;
                      temp^.prev:= newRec;
                    end;
                end;
          end;
     end;

     Procedure Create_Gap_List;
     var
        cIdx  : integer;
        temp : SeatPtr;
        newRec : SeatPtr;
        current_rec : Cptr;
     begin
        Size_Root := New(SeatPtr);
        Size_Root^.prev:= nil;
        Size_Root^.next:= nil;
        Size_Root^.thisRec := congress_votes[1];
        for cIdx:= 2 to highest_constit_number do
          begin
              current_rec :=  congress_votes[cIdx];
              // case where current constituency is before the root
              if (congress_votes[cIdx]^.Prec_Gap > Size_Root^.thisRec^.Prec_Gap) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.Prec_Gap > Size_Root^.thisRec^.Prec_Gap)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.Prec_Gap < Size_Root^.thisRec^.Prec_Gap)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= Size_Root;
                  newRec^.next:=nil;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.next:= newRec;
                end
              else if (congress_votes[cIdx]^.Prec_Gap < Size_Root^.thisRec^.Prec_Gap) then
                begin
                  temp:= Size_Root;
                  while ((temp^.next<> nil) and
                         (current_rec^.Prec_Gap < temp^.thisRec^.Prec_Gap)) do
                         temp:= temp^.next;
                  // if we are at the end of the list
                  if (temp^.next=nil) then
                    begin
                      if (temp^.thisRec^.Prec_Gap < congress_votes[cIdx]^.Prec_Gap) then
                        begin
                          // the new record inserted at penultimate position
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp^.prev;
                          newRec^.next:= temp;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.prev^.next:= newRec;
                          temp^.prev:= newRec;
                        end
                      else
                        begin
                          // the new record is inserted at the end
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp;
                          newRec^.next:= nil;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.next:= newRec;
                        end
                    end
                  // or else we are in the middle of the linked list
                  else
                    begin
                      newRec := new(SeatPtr);
                      newRec^.prev:= temp^.prev;
                      newRec^.next:= temp;
                      newRec^.thisRec:= congress_votes[cIdx];
                      temp^.prev^.next:= newRec;
                      temp^.prev:= newRec;
                    end;
                end;
          end;
     end;


     Procedure Create_Time_Gap_List;
     var
        cIdx  : integer;
        temp : SeatPtr;
        newRec : SeatPtr;
        current_rec : Cptr;
     begin
        Size_Root := New(SeatPtr);
        Size_Root^.prev:= nil;
        Size_Root^.next:= nil;
        Size_Root^.thisRec := congress_votes[1];
        for cIdx:= 2 to highest_constit_number do
          begin
              current_rec :=  congress_votes[cIdx];
              // case where current constituency is before the root
              if (congress_votes[cIdx]^.Time_Gap > Size_Root^.thisRec^.Time_Gap) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.Time_Gap > Size_Root^.thisRec^.Time_Gap)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Size_Root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.prev:= newRec;
                  Size_Root:= newRec;
                end
              else if ((Size_Root^.next=nil) and
                       (congress_votes[cIdx]^.Time_Gap < Size_Root^.thisRec^.Time_Gap)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= Size_Root;
                  newRec^.next:=nil;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Size_Root^.next:= newRec;
                end
              else if (congress_votes[cIdx]^.Time_Gap < Size_Root^.thisRec^.Time_Gap) then
                begin
                  temp:= Size_Root;
                  while ((temp^.next<> nil) and
                         (current_rec^.Time_Gap < temp^.thisRec^.Time_Gap)) do
                         temp:= temp^.next;
                  // if we are at the end of the list
                  if (temp^.next=nil) then
                    begin
                      if (temp^.thisRec^.Time_Gap < congress_votes[cIdx]^.Time_Gap) then
                        begin
                          // the new record inserted at penultimate position
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp^.prev;
                          newRec^.next:= temp;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.prev^.next:= newRec;
                          temp^.prev:= newRec;
                        end
                      else
                        begin
                          // the new record is inserted at the end
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp;
                          newRec^.next:= nil;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.next:= newRec;
                        end
                    end
                  // or else we are in the middle of the linked list
                  else
                    begin
                      newRec := new(SeatPtr);
                      newRec^.prev:= temp^.prev;
                      newRec^.next:= temp;
                      newRec^.thisRec:= congress_votes[cIdx];
                      temp^.prev^.next:= newRec;
                      temp^.prev:= newRec;
                    end;
                end;
          end;
     end;

     Procedure Create_Alpha_List;
     var
         cIdx  : integer;
         temp : SeatPtr;
         newRec : SeatPtr;
         current_rec : Cptr;
     begin
        Alpha_root := New(SeatPtr);
        Alpha_root^.prev:= nil;
        Alpha_root^.next:= nil;
        Alpha_root^.thisRec := congress_votes[1];
        for cIdx:= 2 to highest_constit_number do
          begin
              current_rec :=  congress_votes[cIdx];
              // case where current constituency is before the root
              if (congress_votes[cIdx]^.Constit_Name < Alpha_root^.thisRec^.Constit_Name) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Alpha_root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Alpha_root^.prev:= newRec;
                  Alpha_root:= newRec;
                end
              else if ((Alpha_root^.next=nil) and
                       (congress_votes[cIdx]^.Constit_Name < Alpha_root^.thisRec^.Constit_Name)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= nil;
                  newRec^.next:=Alpha_root;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Alpha_root^.prev:= newRec;
                  Alpha_root:= newRec;
                end
              else if ((Alpha_root^.next=nil) and
                       (congress_votes[cIdx]^.Constit_Name > Alpha_root^.thisRec^.Constit_Name)) then
                begin
                  newRec := new(SeatPtr);
                  newRec^.prev:= Alpha_root;
                  newRec^.next:=nil;
                  newRec^.thisRec:= congress_votes[cIdx];
                  Alpha_root^.next:= newRec;
                end
              else if (congress_votes[cIdx]^.Constit_Name > Alpha_root^.thisRec^.Constit_Name) then
                begin
                  temp:= Alpha_root;
                  while ((temp^.next<> nil) and
                         (current_rec^.Constit_Name > temp^.thisRec^.Constit_Name)) do
                         temp:= temp^.next;
                  // if we are at the end of the list
                  if (temp^.next=nil) then
                    begin
                      if (temp^.thisRec^.Constit_Name > congress_votes[cIdx]^.Constit_Name) then
                        begin
                          // the new record inserted at penultimate position
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp^.prev;
                          newRec^.next:= temp;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.prev^.next:= newRec;
                          temp^.prev:= newRec;
                        end
                      else
                        begin
                          // the new record is inserted at the end
                          newRec := new(SeatPtr);
                          newRec^.prev:= temp;
                          newRec^.next:= nil;
                          newRec^.thisRec:= congress_votes[cIdx];
                          temp^.next:= newRec;
                        end
                    end
                  // or else we are in the middle of the linked list
                  else
                    begin
                      newRec := new(SeatPtr);
                      newRec^.prev:= temp^.prev;
                      newRec^.next:= temp;
                      newRec^.thisRec:= congress_votes[cIdx];
                      temp^.prev^.next:= newRec;
                      temp^.prev:= newRec;
                    end;
                end;
          end;
     end;

     Procedure Write_Report;
     var
         target,
         idx,
         idx2,
         idx3       : integer;
         digit_array : Array [0..20] of integer;
         repeated_digits,
         adjacent_digits_consecutive : boolean;
         tempString : string;
         rfilename  : string;
         res_string : string;
         afile,
         resfile    : TEXT;
         band1,
         band2,
         band3,
         band4,
         band5      : real;
         unopposed  : integer;
         margin     : real;
         lakmems,
         libmems,
         nacmems,
         npcmems,
         socmems,
         pmpmems,
         othmems,
         ldpmems,
         indmems    : integer;
         lakcands,
         libcands,
         naccands,
         npccands,
         soccands,
         pmpcands,
         ldpcands,
         indcands   : integer;
         curSeat    : SeatPtr;
         seatNo     : integer;
         candIdx    : integer;
         shortCandidate,
         shortParty  : string;
         summStr,
         precStr  : String;
         lcinx  : integer;
         precPointer : precPt;
     begin
         unopposed:= 0;
         Create_Alpha_List;

         glob_bad_html :=0;
         glob_zero_prec:=0;

         // This block of code is used to calculate the percentage of the
         // vote for each candidate using the aggregated precinct files
         curSeat := alpha_root;
         repeat
            curSeat^.thisRec^.summary_winner:= -1;
            curSeat^.thisRec^.precinct_winner:= -1;
            summary_winner_vote:= -1;
            precinct_winner_vote:=-1;
            running_total:=0;
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
                running_total:= running_total + curSeat^.thisRec^.aVotes[candIdx];
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
              begin
                if ((running_total > 0) and (curSeat^.thisRec^.aVotes[candIdx]>0)) then
                    curSeat^.thisRec^.aVotePer[candIdx]:= (curSeat^.thisRec^.aVotes[candIdx]/ running_total)*100;
                if (curSeat^.thisRec^.aVotes[candIdx]<1) then
                    curSeat^.thisRec^.aVotePer[candidx]:=0;
                if (curSeat^.thisRec^.aVotes[candIdx] > precinct_winner_vote) then
                begin
                  precinct_winner_vote:= curSeat^.thisRec^.aVotes[candIdx];
                  curSeat^.thisRec^.precinct_winner:= candIdx;
                end;
                if (curSeat^.thisRec^.Votes[candIdx] > summary_winner_vote) then
                begin
                  summary_winner_vote:= curSeat^.thisRec^.Votes[candIdx];
                  curSeat^.thisRec^.summary_winner:= candIdx;
                end;
              end;
            curSeat^.thisRec^.prec_gap:= abs(curSeat^.thisRec^.votePer[curSeat^.thisRec^.summary_winner]-
                                    curSeat^.thisRec^.aVotePer[curSeat^.thisRec^.summary_winner]);
            curSeat:= curSeat^.next;
         until (curSeat = nil);


         // This block of code is used to calculate the percentage of the
         // vote for each candidate using the aggregated EARLY precinct files
         curSeat := alpha_root;
         repeat
            running_total:=0;
            curSeat^.thisRec^.eTotalVote:=0;
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
                running_total:= running_total + curSeat^.thisRec^.eVotes[candIdx];
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
              begin
                curSeat^.thisRec^.eTotalVote:= curSeat^.thisRec^.eTotalVote +
                     curSeat^.thisRec^.eVotes[candIdx];
                if ((running_total > 0) and (curSeat^.thisRec^.eVotes[candIdx]>0)) then
                    curSeat^.thisRec^.eVotePer[candIdx]:=
                    (curSeat^.thisRec^.eVotes[candIdx]/ running_total)*100;
                if (curSeat^.thisRec^.eVotes[candIdx]<1) then
                    curSeat^.thisRec^.eVotePer[candidx]:=0;
              end;
            curSeat:= curSeat^.next;
         until (curSeat = nil);
         //  END OF EARLY precinct assignment block
         // This block of code is used to calculate the percentage of the
         // vote for each candidate using the aggregated LATE precinct files
         curSeat := alpha_root;
         repeat
            curSeat^.thisRec^.early_winner:= -1;
            curSeat^.thisRec^.late_winner:= -1;
            early_winner_vote:= -1;
            late_winner_vote:=-1;
            running_total:=0;
            curSeat^.thisRec^.lTotalVote:= 0;
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
                running_total:= running_total + curSeat^.thisRec^.lVotes[candIdx];
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
              begin
                curSeat^.thisRec^.lTotalVote:= curSeat^.thisRec^.lTotalVote +
                     curSeat^.thisRec^.lVotes[candIdx];
                if ((running_total > 0) and (curSeat^.thisRec^.lVotes[candIdx]>0)) then
                    curSeat^.thisRec^.lVotePer[candIdx]:=
                    (curSeat^.thisRec^.lVotes[candIdx]/ running_total)*100;
                if (curSeat^.thisRec^.lVotes[candIdx]<1) then
                    curSeat^.thisRec^.lVotePer[candidx]:=0;
                if (curSeat^.thisRec^.eVotes[candIdx] > early_winner_vote) then
                  begin
                    early_winner_vote:= curSeat^.thisRec^.eVotes[candIdx];
                    curSeat^.thisRec^.early_winner:= candIdx;
                  end;
                if (curSeat^.thisRec^.lVotes[candIdx] > late_winner_vote) then
                  begin
                    late_winner_vote:= curSeat^.thisRec^.lVotes[candIdx];
                    curSeat^.thisRec^.late_winner:= candIdx;
                  end;
              end;
            curSeat^.thisRec^.time_gap:= abs(curSeat^.thisRec^.lvotePer[curSeat^.thisRec^.early_winner]-
                                             curSeat^.thisRec^.eVotePer[curSeat^.thisRec^.late_winner]);
            if ((curSeat^.thisRec^.eTotalVote<1)or(curSeat^.thisRec^.lTotalVote<1)) then
                  curSeat^.thisRec^.time_gap:= 0;
            curSeat:= curSeat^.next;
         until (curSeat = nil);

         // END OF LATE precinct assignment block

         close(afile);
         Create_Gap_List;
         rfilename := 'ALPHABET.REP';
         rfilename:= 'e:\ElectionResults\' + rfilename;
         assign(afile, rfilename);
         rewrite(afile);
         curSeat := alpha_root;
         seatNo:= 1;
         glob_bad_html :=0;
         glob_zero_prec:=0;
         repeat
            glob_bad_html := glob_bad_html + curSeat^.thisRec^.flty_precs;
            glob_zero_prec:= glob_zero_prec + curSeat^.thisRec^.zero_precs;
            writeln(afile,'Constituency Number :', seatNo:3);
            writeln(afile,'             Name   :', curSeat^.thisRec^.constit_name);
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
            begin
               if (pos('CHRISTIAN MUSLIM DEMOCRATS',  curSeat^.thisRec^.Party[candIdx])>0)
                   then  curSeat^.thisRec^.Party[candIdx]:= 'LAKAS CMD';
               writeln(afile,' ',curSeat^.thisRec^.Names[candIdx]:35,
                             '  ', curSeat^.thisRec^.Party[candIdx]:45,
                             '  ', curSeat^.thisRec^.Votes[candIdx]:15,
                             '  ', curSeat^.thisRec^.VotePer[candIdx]:10:1);
            end;
            writeln(afile,'                                                                                          __________ ');
            writeln(afile,'                                                                                          ',
                          curSeat^.thisRec^.totalVote:10);
            writeln(afile,'  ');
            writeln(afile,'  ');
            curSeat:= curSeat^.next;
            inc(seatNo);
         until (curSeat = nil);
         close(afile);


         rfilename := 'SIZE.REP';
         rfilename:= 'e:\ElectionResults\' + rfilename;
         assign(afile, rfilename);
         rewrite(afile);
         writeln(afile,'Total Number of Precincts with zero votes = ',glob_zero_prec);
         writeln(afile,'Total Number of Precincts with bad HTML files = ', glob_bad_html);
         curSeat := size_root;
         seatNo:= 1;
         repeat
            writeln(afile,'Constituency Number :', seatNo:3);
            writeln(afile,'Constituency Name   :', curSeat^.thisRec^.constit_name);
            writeln(afile,'  ');

            if (curSeat^.thisRec^.summary_winner<> curSeat^.thisRec^.precinct_winner) then
            begin
                writeln(afile,'   ');
                writeln(afile,' ALERT - PRECINCT WINNER IS NOT THE SAME AS WINNER ON LEGDIST SUMMARY FILE ');
                writeln(afile,'   ');
            end;
            writeln(afile,'                                                                        Result on the COMELEC        Result from summing');
            writeln(afile,'                                                                        District Summary File        HTML Precinct Files');
            writeln(afile,'                                                                        _____________________        ___________________');
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
            begin
               shortCandidate:= curSeat^.thisRec^.Names[candIdx];
               if (length(shortCandidate)>27) then
                begin
                  shortCandidate:= copy(shortCandidate,1,25);
                  shortCandidate:= shortCandidate + '..';
                end;
               shortParty:= curSeat^.thisRec^.Party[candIdx];
               if (length(shortParty)>27) then
                begin
                  shortParty:= copy(shortParty,1,25);
                  shortParty:= shortParty + '..';
                end;
               if (pos('PARTIDO DEMOKRATIKO PILIPINO LAKAS NG BAYAN', curSeat^.thisRec^.Party[candIdx])>0)
                   then  curSeat^.thisRec^.Party[candIdx]:= 'PDP LABAN';
               if (pos('CHRISTIAN MUSLIM DEMOCRATS',  curSeat^.thisRec^.Party[candIdx])>0)
                   then  curSeat^.thisRec^.Party[candIdx]:= 'LAKAS CMD';
               writeln(afile,' ',shortCandidate:29,
                             '  ', shortParty:29,
                             '  ', curSeat^.thisRec^.Votes[candIdx]:19,
                             '  ', curSeat^.thisRec^.VotePer[candIdx]:9:1,
                             '% ', curSeat^.thisRec^.aVotes[candIdx]:17,
                             '  ', curSeat^.thisRec^.aVotePer[candIdx]:6:1,
                             '%');
            end;
            writeln(afile,'                                                                        __________      _____         __________   _____');
            writeln(afile,'                                                                        ',
                          curSeat^.thisRec^.totalVote:10, '     ',' 100.0%', curSeat^.thisRec^.agg_vote:18,'   100.0%');
            writeln(afile,' ');
            writeln(afile,' ');
            writeln(afile,'                        Difference between summary winning vote percentage & precinct file',
                          curSeat^.thisRec.prec_gap:10:2);
            writeln(afile,'                                                         Number of Precinct Files Analyzed',
                          curSeat^.thisRec^.prec_count:10);
            writeln(afile,'                                                   Number of Precincts with bad HTML files',
                          curSeat^.thisRec^.flty_precs:10);
            writeln(afile,'                                                        Number of Precincts with 0-1 votes',
                          curSeat^.thisRec^.zero_precs:10);
            writeln(afile,'                                                       Number of Precincts with 2-10 votes',
                          curSeat^.thisRec^.smal_precs:10);
            writeln(afile,' ');
            if (curSeat^.thisRec^.flty_precs > 0) then
              begin
                cinx:=1;
                while (length(curSeat^.thisRec^.falt_Files[cinx])>0) do
                  begin
                    writeln(afile,'Name of File of with bad HTML format:',
                          curSeat^.thisRec^.falt_Files[cinx]);
                    inc(cinx);
                  end;
              end;
            if (curSeat^.thisRec^.zero_precs > 0) then
              begin
                cinx:=1;
                while (length(curSeat^.thisRec^.Zero_Files[cinx])>0) do
                  begin
                    writeln(afile,'Name of File of Precinct with 0-1 votes   :',
                          curSeat^.thisRec^.Zero_Files[cinx]);
                    inc(cinx);
                  end;
              end;
             if (curSeat^.thisRec^.smal_precs > 0) then
              begin
                cinx:=1;
                while (length(curSeat^.thisRec^.smal_Files[cinx])>0) do
                  begin
                    writeln(afile,'Name of File of Precinct with 2-10 votes :',
                          curSeat^.thisRec^.smal_Files[cinx]);
                    inc(cinx);
                  end;
              end;
            writeln(afile,'  ');
            {
            writeln(afile,'This precinct analysis is based on data from the following precinct files:');
            precPointer:= curSeat^.thisRec^.precRoot;
            current_precinct:= '';
            last_precinct:= '';

            while (precPointer<> nil) do
            begin
               //if (precPointer^.name = last_precinct) then
               //   current_precinct:= current_precinct + ' *** Duplicate ';
               if (length(current_precinct)<1) then
                  current_precinct:= current_precinct+ precPointer^.name
               else
                  current_precinct:= current_precinct+', ' + precPointer^.name;
               last_precinct:= precPointer^.name;
               precPointer:= precPointer^.next;
               if (length(current_precinct)> 80) then
               begin
                  writeln(afile,current_precinct);
                  current_precinct:= '';
               end;
            end; }
            current_precinct:= '';
            last_precinct:= '';

            precPointer:= curSeat^.thisRec^.precRoot;
            current_precinct:= '';
            last_precinct:= '';
            current_message:= 'PRECINCTS WITH A RESULTS DATE BEFORE MAY 10TH 2010';
            while (precPointer<> nil) do
              begin
                if (precPointer^.day < 10) then
                begin
                  if (length(current_message)>1) then
                  begin
                     writeln(afile,current_message);
                     current_message:= '';
                  end;
                  current_precinct:= precPointer^.name + ' ' + ' HTML file = ' + precPointer^.fname;
                  writeln(afile, current_precinct);
                end;
                precPointer:= precPointer^.next;
              end;

            writeln(afile,'  ');
            writeln(afile,'  ');
            curSeat:= curSeat^.next;
            inc(seatNo);
         until (curSeat = nil);
         close(afile);

         /// TIME COMPARISON BETWEEN EARLY AND LATE RESULTS

         rfilename := 'TIME.REP';
         rfilename:= 'e:\ElectionResults\' + rfilename;
         assign(afile, rfilename);
         rewrite(afile);
         Create_Time_Gap_List;
         curSeat := size_root;
         repeat
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
              begin
                repeated_digits:=false;
                adjacent_digits_consecutive:= false;
                inc(summ_congress_votes);
                str(curSeat^.thisRec^.Votes[candIdx], tempString);
                for idx3:= 1 to length(tempString) do
                  begin
                    digit_array[idx3]:= byte(tempString[idx3])-48;
                    if (idx3 > 1) then
                      begin
                        if (digit_array[idx3]=((digit_array[idx3-1])+1)) then
                            adjacent_digits_consecutive:= true
                        else if (digit_array[idx3]=((digit_array[idx3-1])-1)) then
                            adjacent_digits_consecutive:= true;
                        if (digit_array[idx3]=digit_array[idx3-1]) then
                            repeated_digits:= true;
                      end;
                  end;
                if (adjacent_digits_consecutive) then
                  inc(Summ_Adjacent_Digits);
                if (repeated_digits) then
                  inc(Summ_Repeated_Digits);
                stlen:= length(tempString);
                target:= byte(tempString[stlen])-48;
                //if (curSeat^.thisRec^.Votes[candIdx] > 99) then
                inc(Summ_Final_Digit_Array[target]);
             end;
             curSeat:= curSeat^.next;
             inc(seatNo);
         until (curSeat = nil);

         curSeat := size_root;
         repeat
            writeln(afile,'Constituency Number :', seatNo:3);
            writeln(afile,'Constituency Name   :', curSeat^.thisRec^.constit_name);
            writeln(afile,'  ');

            if (curSeat^.thisRec^.early_winner<> curSeat^.thisRec^.late_winner) then
            begin
                writeln(afile,'   ');
                writeln(afile,' ALERT - LATE WINNER IS NOT THE SAME AS WINNER ON EARLY PRECINCT FILE ');
                writeln(afile,'   ');
            end;
            writeln(afile,'                                                                         Results Based on the        Results Based on the');
            writeln(afile,'                                                                         Early Precinct Files        Later Precincts only');
            writeln(afile,'                                                                         ____________________        ____________________');
            for candIdx := 1 to curSeat^.thisRec^.candidate_cnt do
             begin
               shortCandidate:= curSeat^.thisRec^.Names[candIdx];
               if (length(shortCandidate)>27) then
                 begin
                    shortCandidate:= copy(shortCandidate,1,25);
                    shortCandidate:= shortCandidate + '..';
                 end;
               shortParty:= curSeat^.thisRec^.Party[candIdx];
               if (length(shortParty)>27) then
                 begin
                   shortParty:= copy(shortParty,1,25);
                   shortParty:= shortParty + '..';
                 end;
               if (pos('PARTIDO DEMOKRATIKO PILIPINO LAKAS NG BAYAN', curSeat^.thisRec^.Party[candIdx])>0)
                   then  curSeat^.thisRec^.Party[candIdx]:= 'PDP LABAN';
               if (pos('CHRISTIAN MUSLIM DEMOCRATS',  curSeat^.thisRec^.Party[candIdx])>0)
                   then  curSeat^.thisRec^.Party[candIdx]:= 'LAKAS CMD';
               writeln(afile,' ',shortCandidate:29,
                             '  ', shortParty:29,
                             '  ', curSeat^.thisRec^.eVotes[candIdx]:19,
                             '  ', curSeat^.thisRec^.eVotePer[candIdx]:9:1,
                             '% ', curSeat^.thisRec^.lVotes[candIdx]:17,
                             '  ', curSeat^.thisRec^.lVotePer[candIdx]:6:1,
                             '%');
             end;
             writeln(afile,'                                                                        __________      _____         __________   _____');
             writeln(afile,'                                                                        ',
                          curSeat^.thisRec^.eTotalVote:10, '     ',' 100.0%', curSeat^.thisRec^.lTotalVote:18,'   100.0%');
             writeln(afile,' ');
             writeln(afile,' ');
             running_total:=  (curSeat^.thisRec^.agg_Vote / curSeat^.thisRec^.totalVote) * 100;

             writeln(afile,'                        Difference between % winning vote in early and late precinct files:',
                          curSeat^.thisRec.time_gap:10:1,'%' );
             writeln(afile,'                           Precinct Votes as a Proportion of votes on LEGDIST summary File:',
                          running_total:10:1,'%');
             writeln(afile, '  ');
             writeln(afile,'                                             Total Number of Votes on LEGDIST Summary File:',
                          curSeat^.thisRec^.totalVote:10);
             writeln(afile,'                                              Total Number from summing the Precinct Files:',
                          curSeat^.thisRec^.agg_Vote:10);
             writeln(afile,'  ');
             writeln(afile,'  ');
             curSeat:= curSeat^.next;
             inc(seatNo);
         until (curSeat = nil);
         close(afile);
         for idx:= 0 to 9 do
            begin
                Prec_Final_Digit_Proportions[10]:= 0;
                Summ_Final_Digit_Proportions[10]:= 0;
            end;

         for idx:= 0 to 9 do
            begin
                Prec_Final_Digit_Proportions[10]:= Prec_Final_Digit_Proportions[10] +
                   Prec_Final_Digit_Array[idx];
                Summ_Final_Digit_Proportions[10]:= Summ_Final_Digit_Proportions[10] +
                   Summ_Final_Digit_Array[idx];
            end;
         for idx:= 0 to 9 do
            begin
                Prec_Final_Digit_Proportions[idx]:= Prec_Final_Digit_Array[idx] /
                   Prec_Final_Digit_Proportions[10];
                Summ_Final_Digit_Proportions[idx]:= Summ_Final_Digit_Array[idx] /
                   Summ_Final_Digit_Proportions[10];
            end;
         rfilename := 'SEAT.REP';
         rfilename:= 'e:\ElectionResults\' + rfilename;
         assign(resfile, rfilename);
         rewrite(resfile);
         writeln(resfile,' ');
         writeln(resfile,' ');
         writeln(resfile,' DIGIT BIAS REPORT');
         writeln(resfile,' ');
         writeln(resfile,'                                 Individual     COMELEC');
         writeln(resfile,'                                  Precinct      Summary');
         writeln(resfile,'                                 File Count      Files');
         writeln(resfile,'                                 __________     _______');
         writeln(resfile,'  ');
         for idx:= 0 to 9 do
            begin
               str((Prec_Final_Digit_Proportions[idx]*100):12:2, precStr);
               str((Summ_Final_Digit_Proportions[idx]*100):12:2, summStr);
               writeln(resfile,'   Last Digit of Vote = ',idx:3,
                                   PrecStr, ' %',
                                   SummStr, ' %');
            end;
         writeln(resfile,'   ');
         writeln(resfile,'  ');
         writeln(resfile,' Total number of congress votes in summary files  = ',summ_congress_votes);
         writeln(resfile,' Total number of congress votes in precinct files = ',prec_congress_votes);
         writeln(resfile,'   ');
         writeln(resfile,'   ');

         writeln(resfile,'Votes with repeated identical digits');
         writeln(resfile,'   ');
         writeln(resfile,'                                 Individual        COMELEC');
         writeln(resfile,'                                  Precinct         Summary');
         writeln(resfile,'                                 File Count         Files');
         writeln(resfile,'                                 __________       __________');
         writeln(resfile,'                                 No.     %        No.      % ');
         str(((prec_repeated_digits/prec_congress_votes)*100):7:2, precStr);
         str(((summ_repeated_digits/summ_congress_votes)*100):7:2, summStr);
         writeln(resfile,'   ');
         writeln(resfile,'Number w. adjacent digits  = ',
                                   prec_repeated_digits:7, precStr,'% ',
                                   summ_repeated_digits:7, summStr,'% ');
         writeln(resfile,'  ');

         writeln(resfile,'Votes with adjacent consecutive digits');
         writeln(resfile,'   ');
         writeln(resfile,'                                 Individual        COMELEC');
         writeln(resfile,'                                  Precinct         Summary');
         writeln(resfile,'                                 File Count         Files');
         writeln(resfile,'                                 __________       __________');
         writeln(resfile,'                                 No.     %        No.      % ');
         str(((prec_adjacent_digits/prec_congress_votes)*100):7:2, precStr);
         str(((summ_adjacent_digits/summ_congress_votes)*100):7:2, summStr);
         writeln(resfile,'   ');
         writeln(resfile,'Number w. adjacent digits  = ',
                                   prec_adjacent_digits:7, precStr,'% ',
                                   summ_adjacent_digits:7, summStr,'% ');
         writeln(resfile,'  ');
         writeln(resfile,'RESULT DATE REPORT');
         writeln(resfile,'  Month Number');
         for lcinx:= 1 to 12 do
         begin
             writeln(resfile,'     Number :',inttostr(lcinx), ' = ',inttostr(month_array[lcinx]));
         end;
         writeln(resfile,'Day of Month');
         for lcinx:= 1 to 31 do
         begin
             writeln(resfile,'     Number :',inttostr(lcinx), ' = ',inttostr(day_array[lcinx]));
         end;
         writeln(resfile,' ');
         writeln(resfile,' ');
         writeln(resfile,' CONSTITUENCY REPORT');
         writeln(resfile,' ');
         writeln(resfile,'Number of unopposed elections: ' + inttostr(unopposed));
         writeln(resfile,'Seats where winning candidate margin over 2nd Place candidate was');
         writeln(resfile,'        Over 50% ',cnt5);
         writeln(resfile,'       40% - 49% ',cnt4);
         writeln(resfile,'       30% - 39% ',cnt3);
         writeln(resfile,'       20% - 29% ',cnt2);
         writeln(resfile,'       10% - 19% ',cnt1);
         writeln(resfile,'        0% -  9% ',cnt0);


         band5 := 50;
         band4 := 40;
         band3 := 30;
         band2 := 20;
         band1 := 10;
         cnt0 :=0;
         cnt1 :=0;
         cnt2 :=0;
         cnt3 :=0;
         cnt4 :=0;
         cnt5 :=0;
         lakmems:=0;
         libmems:=0;
         nacmems:=0;
         npcmems:=0;
         socmems:=0;
         pmpmems:=0;
         ldpmems:=0;
         indmems:=0;
         othmems:=0;

         lakcands:=0;
         libcands:=0;
         naccands:=0;
         npccands:=0;
         soccands:=0;
         pmpcands:=0;
         ldpcands:=0;
         indcands:=0;
         unopposed := 0;
         for idx:= 1 to highest_constit_number do
         begin
            for idx2:= 1 to congress_votes[idx]^.candidate_cnt do
            begin
                if (pos('LIBERAL PARTY',congress_votes[idx]^.Party[idx2])>0)
                    then libcands := libcands+1;
                if (pos('CHRISTIAN MUSLIM DEMOCRATS',congress_votes[idx]^.Party[idx2])>0)
                    then lakcands := lakcands+1;
                if (pos('NACIONALISTA',congress_votes[idx]^.Party[idx2])>0)
                    then naccands := naccands+1;
                if (pos('NATIONALIST PEOPLES COALITION',congress_votes[idx]^.Party[idx2])>0)
                    then npccands := npccands+1;
                if (pos('MASANG PILIPINO',congress_votes[idx]^.Party[idx2])>0)
                    then pmpcands := pmpcands+1;
                if (pos('PARTIDO DEMOKRATIKO SOSYALISTA',congress_votes[idx]^.Party[idx2])>0)
                    then soccands := soccands+1;
                if (pos('LABAN NG DEMOKRATIKONG',congress_votes[idx]^.Party[idx2])>0)
                    then ldpcands := ldpcands+1;
                if (pos('INDEPENDENT',congress_votes[idx]^.Party[idx2])>0)
                    then indcands := indcands+1;

                if ((pos('LIBERAL PARTY',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then libmems := libmems+1
                else if ((pos('CHRISTIAN MUSLIM DEMOCRATS',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then lakmems := lakmems+1
                else if ((pos('NACIONALISTA',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then nacmems := nacmems+1
                else if ((pos('NATIONALIST PEOPLES COALITION',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then npcmems := npcmems+1
                else if ((pos('MASANG PILIPINO',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then pmpmems := pmpmems+1
                else if ((pos('PARTIDO DEMOKRATIKO SOSYALISTA',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then socmems := socmems+1
                else if ((pos('LABAN NG DEMOKRATIKONG PILIPINO',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then ldpmems := ldpmems+1
                else if ((pos('INDEPENDENT',congress_votes[idx]^.Party[idx2])>0)and(idx2=1))
                    then ldpmems := ldpmems+1
                else if (idx2=1) then
                   begin
                      othmems := othmems;
                      writeln(resfile,  congress_votes[idx]^.Party[idx2]);
                   end;
            end;
            margin:=0;
            if (congress_votes[idx]^.candidate_cnt=1) then
              unopposed := unopposed + 1
            else
              begin
                margin := congress_votes[idx]^.voteper[1] -
                          congress_votes[idx]^.votePer[2];
              end;
            if (margin > band5) then
              inc(cnt5)
            else if (margin > band4) then
              inc(cnt4)
            else if (margin > band3) then
              inc(cnt3)
            else if (margin > band2) then
              inc(cnt2)
            else if (margin > band1) then
              inc(cnt1)
            else
              inc(cnt0);
         end;

         writeln(resfile,' CONSTITUENCY REPORT');
         writeln(resfile,' ');
         writeln(resfile,'Number of unopposed elections: ' + inttostr(unopposed));
         writeln(resfile,'Seats where winning candidate margin over 2nd Place candidate was');
         writeln(resfile,'        Over 50% ',cnt5);
         writeln(resfile,'       40% - 49% ',cnt4);
         writeln(resfile,'       30% - 39% ',cnt3);
         writeln(resfile,'       20% - 29% ',cnt2);
         writeln(resfile,'       10% - 19% ',cnt1);
         writeln(resfile,'        0% -  9% ',cnt0);
         writeln(resfile,' ');
         writeln(resfile,' ');
         writeln(resfile,'Number of Elected Members');
         writeln(resfile,'   Lakas CMD                      : ',lakmems);
         writeln(resfile,'   Liberal Party                  : ',libmems);
         writeln(resfile,'   Nacionalista                   : ',nacmems);
         writeln(resfile,'   Nationalist Peoples Coalition  : ',npcmems);
         writeln(resfile,'   Partido Demokratika Socyalista : ',socmems);
         writeln(resfile,'   Pwersa ng Masang Pilipino      : ',pmpmems);
         writeln(resfile,'   Laban ng Demokratong Pilipino  : ',ldpmems);
         writeln(resfile,'  ');
         writeln(resfile,'Number of Candidates by Party');
         writeln(resfile,'   Lakas CMD                      : ',lakcands);
         writeln(resfile,'   Liberal Party                  : ',libcands);
         writeln(resfile,'   Nacionalista                   : ',naccands);
         writeln(resfile,'   Nationalist Peoples Coalition  : ',npccands);
         writeln(resfile,'   Partido Demokratika Socyalista : ',soccands);
         writeln(resfile,'   Pwersa ng Masang Pilipino      : ',pmpcands);
         writeln(resfile,'   Laban ng Demokratong Pilipino  : ',ldpcands);
         writeln(resfile,'   Independent Candidates         : ',indcands);
         close(resfile);
     end;


begin
     Prec_Congress_Votes:=0;
     Summ_Congress_Votes:=0;
     Prec_Adjacent_Digits:=0;
     Summ_Adjacent_Digits:=0;
     Prec_Repeated_Digits:=0;
     Summ_Repeated_Digits:=0;
     for seat_counter:= 0 to 10 do
     begin
        Prec_Final_Digit_Array[seat_counter]:= 0;
        Summ_Final_Digit_Array[seat_counter]:= 0;
     end;
     for seat_counter:= 1 to 12 do
        month_array[seat_counter]:= 0;
     for seat_counter:= 1 to 31 do
        day_array[seat_counter]:= 0;
     for seat_counter:= 1 to 299 do
     begin
          New(congress_votes[seat_counter]);
          congress_votes[seat_counter]^.TotalVote:= 0;
          congress_votes[seat_counter]^.Constit_Name:= 'blank';
          congress_votes[seat_counter]^.candidate_cnt:= -1;
          congress_votes[seat_counter]^.early_count:=0;
          congress_votes[seat_counter]^.early_agg_vote:=0;
          congress_votes[seat_counter]^.late_agg_vote:=0;
          congress_votes[seat_counter]^.late_count:=0;
          congress_votes[seat_counter]^.prec_count:= 0;
          congress_votes[seat_counter]^.smal_precs:= 0;
          congress_votes[seat_counter]^.flty_precs:= 0;
          congress_votes[seat_counter]^.zero_precs:= 0;
          congress_votes[seat_counter]^.time_gap:= 0;
          congress_votes[seat_counter]^.prec_gap:= 0;
          for locIndex:= 1 to max_candidates do
            begin
              congress_votes[seat_counter]^.Party[locIndex]:= 'blank';
              congress_votes[seat_counter]^.Names[locIndex]:= 'blank';
              congress_votes[seat_counter]^.Zero_Files[locIndex]:='';
              congress_votes[seat_counter]^.Votes[locIndex]:=0;
              congress_votes[seat_counter]^.VotePer[locIndex]:=0;
              congress_votes[seat_counter]^.aVotes[locIndex]:=0;
              congress_votes[seat_counter]^.aVotePer[locIndex]:=0;
              congress_votes[seat_counter]^.eVotes[locIndex]:=0;
              congress_votes[seat_counter]^.eVotePer[locIndex]:=0;
              congress_votes[seat_counter]^.lVotes[locIndex]:=0;
              congress_votes[seat_counter]^.lVotePer[locIndex]:=0;
              congress_votes[seat_counter]^.candRoot:= nil;
              congress_votes[seat_counter]^.PrecRoot:= nil;
            end;
     end;
     fullname:= 'e:\ElectionResults\electionresults\dir.lst';
     assign(infile, fullname);
     {$I-}
     reset(infile);
     {$I+}
     if (IOresult <> 0) then
       begin
         Showmessage('ERROR : the file - ' + namestr + ' - could not be opened the program will abort press any key to continue');
         halt;
       end;
     repeat
        readln(infile, instring);
        targpos :=  pos('.html',instring);
        If (targpos>0) then
        begin
           File_Counter:= File_Counter + 1;
           if ((File_Counter mod 100)=1)then
           begin
              str(File_Counter:10, Label2);
              Label2 := 'Processing File: ' + Label2;
              Form1.Panel2.SetTextBuf(PAnsiChar(Label2));
              str(highest_constit_number:4, Label2);
              Label2 := 'Highest Constituency No: ' + Label2;
              Form1.Panel3.SetTextBuf(PAnsiChar(Label2));
              str(timely_results:6, Label1);
              str(late_results:6, Label2);
              Label1:= 'Early Precincts = ' + Label1 + ' Late Precincts = '+ Label2;
              Form1.Panel4.SetTextBuf(PAnsiChar(Label1));
              Form1.Repaint;
           end;
           while (instring[targpos]<>' ') do
                targpos:= targpos -1;
           stlen := length(instring);
           targpos:= targpos + 1;
           endfilename := copy(instring,targpos,stlen);
           rfilename:= 'e:\ElectionResults\electionresults\' + endfilename;
           Location_Area:= false;
           Precinct_Flag:= false;
           Early_Flag:= false;
           Date_Set  := false;
           assign(resfile, rfilename);
           {$I-}
           reset(resfile);
           {$I+}
           seat_number:=0;
           repeat
              readln(resfile, res_string);
              for locIndex:= 1 to length(res_string) do
                res_string[locIndex]:= upcase(res_string[locIndex]);
              if (pos('RESULTS DATE',res_string)>0) then
              begin
                  Date_Set:= true;
                  chinx:= pos('RESULTS DATE:',res_string);
                  chinx:= chinx+14;
                  res_month:='';
                  while((res_string[chinx]<>' ')and(chinx<length(res_string))) do
                  begin
                      res_month:=res_month+res_string[chinx];
                      inc(chinx);
                  end;
                  if (res_month='MAY') then
                    result_m:= 5
                  else
                    result_m:= 1;
                  inc(month_array[result_m]);
                  inc(chinx);
                  res_day:='';
                  while((res_string[chinx]<>',')and(chinx<length(res_string))) do
                  begin
                      res_day:=res_day+res_string[chinx];
                      inc(chinx);
                  end;
                  val(res_day,result_d,code);
                  inc(day_array[result_d]);
                  if ((result_d<0) or (result_d > 31))
                    then result_d:= -1;
                  if (result_d <=22) then
                    begin
                      inc(timely_results);
                      early_flag:=true;
                    end
                  else
                    begin
                      early_flag:=false;
                      inc(late_results);
                    end;
              end;
              if (pos('LOCATIONBAR',res_string)>0) then
              begin
                  Location_Area := true;
                  current_precinct:='';
                  current_region:='';
              end;
              if ((Location_Area = true) and (pos('</DIV>',res_string)>0)) then
                Location_Area := false;
                if ((Location_Area=true) and (pos('./RES_REG',res_string)>0) and
                  (pos('>THE PHILIPPINES<',res_string)<1) and
                  (length(current_region)<1)) then
              begin
                stlen:= pos('</A',res_string) - pos('HTML',res_string);
                current_region:= copy(res_string, pos('HTML',res_string)+6, (stlen-6));
              end; 
              if ((Location_Area=true) and (pos('>CP ',res_string)>0)) then
              begin
                Precinct_Flag := true;
                stlen:= length(res_string) - pos('>CP ',res_string);
                current_precinct:= copy(res_string, pos('>CP ',res_string)+1, (stlen-4));
                label1:= copy(current_precinct,4,stlen-7);
                label2:= copy(label1,1,pos(' ',label1)-1);
                current_CP:= strtoint(label2);
              end;
              constpos := pos('MEMBER, HOUSE OF REPRESENTATIVES',res_string);
              stlen:= length(res_string);
              instring:= copy(res_string,(constpos+33),stlen);
              read_seat;
           until (eof(resfile));
           close(resfile);
        end;
     until (eof(infile) or (file_counter>15000));
     close(infile);
     str(File_Counter:10, Label2);
     Label2 := 'Writing Reports';
     Form1.Panel2.SetTextBuf(PAnsiChar(Label2));
     Form1.Repaint;
     Write_Report;
end;

Procedure ReadFileList;
var
     constit_list : TEXT;
begin
     File_Counter:=0;
     timely_results:=0;
     late_results:=0;
     ReadOpen('FILE.LST', constit_list);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
    highest_constit_number:= -1;
    show();
    readFileList;
end;

end.
