{//////////////////////////////////////////////////////////////////////
 //               MicroStar Version 1.00B                             //
 //               Module : SCREEN.MS                                  //
 //////////////////////////////////////////////////////////////////////}
Unit ScreenWP;
(*$WARNINGS OFF*) 
(*$HINTS OFF*)



Interface

Uses
   Crt,
   dos,
   Edvar,
   StatVar,
   mouse,
   Messages,
   Windows,
   SynEdit,
   SysUtils,
   Variants,
   Classes,
   Graphics,
   Controls,
   Forms,
   Dialogs,
   Menus;

var
   SelWinMouseCol,
   SelWinMouseRow   : integer;


procedure MoveToScreen(Var Source,Dest; Length: Word);
procedure MoveFromScreen(Var Source,Dest; Length: Word);
procedure Beep;
procedure SetMemAddress(Col,Line:byte);
procedure WriteChar(ch:byte);
procedure WriteString(Var st);
function ReadChar : char;
function GetCursorMode: integer;
procedure SetCursorMode(Mode : integer);
function GetInteger(var default  : integer; { default value to be displayed }
                         min,max  : integer;
                         col,line : byte;
                         var st; var st1): boolean;
procedure SaveScreen(Var Adr; Num:byte);
procedure RestoreScreen(var Adr; Num:byte);
procedure MakeWindow(col,line,NumOfCols,NumOfLines: byte);
procedure RestoreWindow(col,line,NumOfCols,NumOfLines : byte);
function GetString (Col, line,                { line and column to get input }
                    Maxlen  : byte;           { Maximum length of string     }
                    Default : VarString;      { default value of string      }
                    UpC : Boolean): VarString;{ Uppercase flag               }
function Boolprompt (row: integer; var s): char;
function BoolSimp(row: integer; strng : string): char;
procedure DispESC;
procedure DispF10;

procedure SetOnOff (var c; state: boolean);
Procedure GetFlags;
function EditMessage (Mno : Byte) : Varstring;
procedure EditErrormsg (Msgno : Byte);
function ErrorCheck (ErrorNum: Byte) : boolean;
procedure UserError (var Msgno : Byte);
procedure UserStatusline (Var TWindow:Byte;  Column,line:Integer;
                         Insertflag:Insflag; WW,AI: boolean) ;
procedure EditUpdwinsl (w : Pwindesc);
procedure EditIncline;
procedure EditDecline;
procedure EditDestxtdes  (var Desc : Plinedesc) ;
function EditMaktxtdes  (Ncols : integer) : Plinedesc ;
function EditInsbuf  (Ncols : integer) : boolean ;
function EditSizeline (p : Plinedesc; Ncols : integer) : boolean ;
function EditNewstream: integer ;
function EditCrewindow ( Top : integer; Len : integer; Fn : varstring;
                          Cr  : integer; Cc  : integer):Pwindesc;
procedure EditRealign;
procedure EditOffblock;
procedure EditAutoIndentLine;
Procedure ClearSubMenu(ScreenPosition,Width:integer);
//procedure EditBeginningLine;
//procedure EditEndLine;
Function Interrupted:boolean;
Procedure Wait_Till_Touched;
function Direction : byte;
Procedure ShowMessage(Instring1 : String78; Instring2: String78;
                       Instring3 : String78);
Procedure CloseMessageWindow;
Procedure LexicalError(Instring1 : String78;
                       Instring2 : String78;
                       Instring3 : String78);
Procedure CloseFile(namestr : string;  var infile :  TEXT);
Procedure WriteOpen(var infile: TEXT;  namestr : string);
Procedure ReadOpen (namestr : string;  var infile :  TEXT);
Procedure ChangeDir(Inst : string);

implementation

                 { LOW-LEVEL SCREEN UPDATE ROUTINES }

{ The following routines allow the editor to move data directly to and }
{ from screen memory without causing snow or flicker. They are written }
{ as inline assembly language for speed; the source is included below. }

procedure MoveToScreen(Var Source,Dest; Length: Word);
{  Move memory, as Turbo Move, but assume that the target is in
   video memory; prevent screen flicker based on this assumption,
   unless RetraceMode is false.  Timing is VERY tight: if the code
   were 1 clock cycle slower, it would cause flicker.
}
  Begin
    Move(Source,Dest,Length)
(*    If Not RetraceMode Then Move(Source,Dest,Length)
    Else
     Begin
      Length:=Length Shr 1;
      Inline($1E/$55/$BA/$DA/$03/$C5/$B6/ Source /$C4/$BE/ Dest /$8B/$8E/
             Length /$FC/$AD/$89/$C5/$B4/$09/$EC/$D0/$D8/$72/$FB/$FA/$EC/
             $20/$E0/$74/$FB/$89/$E8/$AB/$FB/$E2/$EA/$5D/$1F);
{
        push    ds              ; Save Turbo's DS
        push    bp              ;   and BP
        mov     dx,3da          ; Point DX to CGA status port
        lds     si,source[bp]   ; Source pointer into DS:SI
        les     di,dest[bp]     ; Dest pointer into ES:DI
        mov     cx,length[bp]   ; Length value into CX
        cld                     ; Set string direction to forward
.0:     lodsw                   ; Grab a video word
        mov     bp,ax           ; Save it in BP
        mov     ah,9            ; Move horiz. + vertical retrace mask to fast
                                ;   storage
.1:     in      al,dx           ; Get 6845 status
        rcr     al,1            ; Check horizontal retrace
        jb      .1              ; Loop if in horizontal retrace: this prevents
                                ;   starting in mid-retrace, since there is
                                ;   exactly enough time for 1 and only 1 STOSW
                                ;   during horizontal retrace
        cli                     ; No ints during critical section
.2:     in      al,dx           ; Get 6845 status
        and     al,ah           ; Check for both kinds of retrace: IF the
                                ;   video board does not report horizontal
                                ;   retrace while in vertical retrace, this
                                ;   will allow several characters to be
                                ;   stuffed in during vertical retrace
        jnz     .2              ; Loop if not equal zero
        mov     ax,bp           ; Get the video word
        stosw                   ; Store the video word
        sti                     ; Allow interrupts
        loop    .0              ; Go do next word
        pop     bp              ; Restore Turbo's BP
        pop     ds              ;   and DS
}
     End; *)
  End;

Procedure MoveFromScreen(Var Source,Dest; Length: Word);
{  Move memory, as Turbo Move, but assume that the source is in
   video memory; prevent screen flicker based on this assumption,
   unless RetraceMode is false.  Timing is VERY tight: if the code
   were 1 clock cycle slower, it would cause flicker.
}
  Begin
    If Not RetraceMode Then Move(Source,Dest,Length)
    Else
     Begin
      Length:=Length Shr 1;
     // JUNE2009
     // Inline($1E/$55/$BA/$DA/$03/$C5/$B6/ Source /$C4/$BE/ Dest /$8B/$8E/
     //        Length /$FC/$EC/$D0/$D8/$72/$FB/$FA/$EC/$D0/$D8/$73/$FB/$AD/
     //        $FB/$AB/$E2/$F0/$5D/$1F);
{
        push    ds              ; Save Turbo's DS
        push    bp              ;   and BP
        mov     dx,3da          ; Point DX to CGA status port
        lds     si,source[bp]   ; Source pointer into DS:SI
        les     di,dest[bp]     ; Dest pointer into ES:DI
        mov     cx,length[bp]   ; Length value into CX
        cld                     ; Set string direction to forward
.0:     in      al,dx           ; Get 6845 status
        rcr     al,1            ; Check horizontal retrace
        jb      .0              ; Loop if in horizontal retrace: this prevents
                                ;   starting in mid-retrace, since there is
                                ;   exactly enough time for 1 and only 1 LODSW
                                ;   during horizontal retrace
        cli                     ; No ints during critical section
.1:     in      al,dx           ; Get 6845 status
        rcr     al,1            ; Check for horizontal retrace: LODSW is 1
                                ;   clock cycle slower than STOSW; because of
                                ;   this, the vertical retrace trick can't be
                                ;   used because it causes flicker!  (RCR AL,1
                                ;   is 1 cycle faster than AND AL,AH)
        jnb     .1              ; Loop if not in retrace
        lodsw                   ; Load the video word
        sti                     ; Allow interrupts
        stosw                   ; Store the video word
        loop    .0              ; Go do next word
        pop     bp              ; Restore Turbo's BP
        pop     ds              ;   and DS
}
     End;
  End;

Procedure Beep;
{  Puts 1/4 second of 440 Hz out on the speaker. }
begin {Beep}
  sound(440);
  delay(125);
  nosound;
end; {Beep}

                    { MICROSTAR-SPECIFIC SCREEN ROUTINES }

Procedure SetMemAddress(Col,Line:byte);
{
1.  Proc. Name
    SetMemAddress -- set the next address in vidoe RAM to be written to.
 
2.  Functional Description
    The global variable MemAdr is assigned the value of the next location
    on the screen to be written to.
}
begin { Procedure SetMemAddress }
  MemAdr := Pred(Line) * 160 + (Pred(Col) * 2);{ get line and column offsets }
end;  { Procedure SetMemAddress }
 
Procedure WriteChar(ch:byte);
{
1.  Proc. Name
    WriteChar -- write a character to the screen
 
2.  Functional Description
    The local variable screenword is used to combine the character and it's
    corresponding video attributes. The integer is then written directly to
    video RAM using the MoveToScreen routine.
}
var
  screenword : integer;
begin { procedure WriteChar }
  screenword := MenuColor + ch;       { add sceen attributes to character    }
  // MoveToScreen(screenword,MemW[ScreenAdr:MemAdr],2);              JUNE2009
  MemAdr := MemAdr + 2;               { increment video RAM location counter }
end;  { procedure WriteChar }
 
Procedure WriteString(Var st);
{
1.  Proc. Name
    WriteString -- writes a string to video RAM
 
2.  Functional Description
    The untyped paramater passed to the routine represents a string. The string
    is copied directly from video RAM uses the length byte (Offset zero) as
    to maximum value of the counter.
}
var
  count : integer;
begin { procedure WriteString }
  //      JUNE2009
  //for count := 1 to Mem[Seg(st):Ofs(st)] do    { for st[1] to st[length(st)] }
  //  WriteChar(Mem[Seg(st):Ofs(st) + count]);   { display the character       }
end;  { procedure WriteString }
 
Function ReadChar : char;
{
1.  Proc. Name
    ReadChar --  read a character from the keyboard.
 
2.  Functional Description
    The character is read directly from the logical device KBD without
    echoing it to the screen. If the key was an arrow-key, the appropriate
    routine is called.
}
var
  ch : char;
begin { function ReadChar }
   Ch := Readkey;                         { read character                     }
  if KeyPressed and (Ch = #27) then     { check for extened scan code        }
  begin
   Ch:= Readkey;                        { read scan code                     }
    case Ch of
      #75:Ch := CursorLeft;             { Left-Arrow Key                     }
      #77:Ch := CursorRight;            { Right-Arrow Key                    }
      #72:Ch := CursorUp;               { Up-Arrow Key                       }
      #80:Ch := CursorDown;             { Down-Arrow Key                     }
      #83:Ch := #127;                   { Delete Key                         }
      #73:Ch := PageUp;                 { Page Up Key                        }
      #81:Ch := PageDown;               { Page Down Key                      }
      #82:Ch := ^V;                     { Ins key                            }
      #59:Ch := ^V;                     { F2 => Ins (for spelling checker)   }
     else
       Ch := #0;                        { invalid key                        }
    end; { case statement }
  end;
  if Ch = ^U then                       { if abort character then map it to  }
    Ch := #27;                          { the escape key                     }
  ReadChar := Ch;
  Circin := Circout;                         { empty Keyboard buffer        }
  EditUsercommandInput := 0;
end;  { function ReadChar }
 
Function GetCursorMode: integer;
{
1.   Proc. Name
     GetCursorMode -- Gets shape of current cursor (if any)

2.   Functional Description
     This function gets the old cursor descriptor. It is important to note
     that while ALL video adapters will turn off the cursor in response to
     the value $0F0F, different values which turn them on make different
     shapes (in particular, the Hercules card behaves differently from the
     IBM mono adapter). To be safe, always put in a value you have retrieved
     previously to turn the cursor on.
}
const
   Video          =  $10;
   GetCurType     = $300;
var
   Regs          : Registers;                  {IBM PC registers}

begin { function GetCursorMode }
   Regs.AX := GetCurType;
   Intr(Video,Regs);
   GetCursorMode := Regs.CX;
end; { function GetCursorMode }

Procedure SetCursorMode(Mode : integer);
{
1.   Proc. Name
     SetCursorMode -- Sets shape of current cursor (if any)
 
2.   Functional Description
     This function sets the cursor mode (see explanation above).
}
const
   Video          =  $10;
   SetCurType     = $100;
var
  Regs         : Registers;              {IBM PC registers}

begin { procedure SetCursorMode }
   exit;
   Regs.AX := SetCurType;
   Regs.CX := Mode;
   Intr(Video,Regs);
end; { procedure SetCursorMode }

Function GetInteger(var default  : integer; { default value to be displayed }
                         min,max  : integer;
                         col,line : byte;
                         var st; var st1): boolean;
{
1.  Proc. Name
    GetInteger -- read an integer from the keyboard

2.  Functional Description
    The default value of the number is displayed on the screen and if an
    integer is entered, a new number is calculated. Because the numbers are
    entered as characters, the number must be built from the characters
    and range checking must performed during this build routine to make sure
    the number is not out of integer range. The number is terminated by
    a carriage return or an escape. The escape resets the value of the
    number to the default value. Finally the number is assigned to the
    un-typed paramater st1 by using TURBO's move command.
}
var
  nst:String[5];
  oldmemadr:integer;
  ch : char;
  num, err,
  curpos : integer;
  newnum:boolean;
  SaveCursor: integer;
begin { procedure GetInteger }
  SaveCursor := GetCursorMode;       { set cursor display on                 }
  SetCursorMode (CursorOn);
  GetInteger := true;
  oldx := wherex;
  oldy := wherey;
  SetMemAddress(col,line);           { set address to on screen to read from }
  MenuColor := WLowColor;            { set display color                     }
  WriteString(st);                   { display the default value             }
  MenuColor := WNormColor;           { set dislpay color                     }
  num := default;
  newnum := true;                    { set flag to indicate that we have just}
  repeat                             { begun to build this number            }
    repeat
      str(num:5,nst);
      curpos := ord(nst[0]);
      oldmemadr := memadr;           { save current address on screen        }
      WriteString(nst);              { display value of number               }
      // gotoxy(col + curpos - 1 + mem[seg(st):ofs(st)],line);        JUNE2009
      memadr := oldmemadr;           { reset original screen address         }
      ch := ReadChar;                { get next character of number          }
      if ch in ['0'..'9'] then
      begin
        if newnum then
          num := 0;
        if num < (maxint div 10) then  { check number of digits in number    }
          num := (num * 10) + (ord(ch) - 48); { get new number  }
      end;
      if ch in [^S,^H] then          { if left-arrow or back-space key then  }
        num := num div 10;           { divide by 10 to decrement the number  }
      newnum := false;               { not a new number now                  }
    until ch in [#13,#27];           { until c/r, ESC                        }
    if (ch = #13) and ((num > max) or (num < min)) then  { c/r on invalid #  }
      begin
      beep;
      ch := #0;
      end;
  until ch in [#13,#27];             { until c/r, ESC                        }
  if ch <> #13 then
  begin
    num := default;
    GetInteger := false;
  end else
    begin
    default := num;
    str(num:5,nst);
    // move(nst[1],mem[seg(st1):ofs(st1) + mem[seg(st1):ofs(st1)] - 5],5);        JUNE2009
    end;
  SetCursorMode(SaveCursor);
  gotoxy(oldx,oldy);
end;  { procedure GetInteger }

Procedure SaveScreen(Var Adr; Num:byte);
{
1.  Proc. Name
    SaveScreen -- Saves area of screen to temporary buffer

2.  Functional Description
    The paramater Adr passed to this routine is used as a temporary buffer
    to hold the next Num characters on the screen.
}
begin { procedure SaveScreen }
  // MoveFromScreen(Mem[ScreenAdr:MemAdr],Adr,Num shl 1); { Num shl 1 = Num * 2 }          JUNE2009
end;  { procedure SaveScreen }

Procedure RestoreScreen(var Adr; Num:byte);
{
1.  Proc. Name
    RestoreScreen -- restore the original contents of the screen

2.  Functional Description
    The screen is restored with the contents of Adr
}
begin { procedure RestoreScreen }
  // MoveFromScreen(Adr,Mem[ScreenAdr:MemAdr],Num shl 1); { Num shl 1 = Num * 2 }         JUNE2009
end;  { procedure RestoreScreen }

Procedure MakeWindow(col,line,NumOfCols,NumOfLines: byte);
{
1.  Proc. Name
    MakeWindow -- makes a window of the specified columns X rows

2.  Functional Description
    The paramaters passed to this routine indicate the starting position
    and size of the window to be displayed. Based on this information, the
    windows frame is displayed and the inside of the wondow is filled with
    spaces.
}
var
  count1, count2 : integer;
begin { procedure MakeWindow }
  SetMemAddress(Col,Line);                         { set start address       }
  SaveScreen(Warray[WindowNum,0,0],NumOfCols);     { save text on screen     }
  MenuColor := WFrameColor;                        { update display color    }
  WriteChar(WUpperleft);                           { display left corner     }
  for count1 := Succ(col) to (col + NumOfCols - 2) do  { display  line       }
    WriteChar(WHorizontal);
  WriteChar(WUpperRight);                          { display right corner    }
  for count1 := (line + 1) to (line + NumOfLines - 2) do
  begin                                            { now draw the middle     }
    SetMemAddress(Col,count1);                     { rows                    }
    SaveScreen(WArray[WindowNum,count1 - line,0],NumOfCols);
                                                   { save text on screen     }
    WriteChar(WVertical);                          { write left border       }
    MenuColor := WFrameColor;                      { update display color    }
    for count2 := Succ(col) to (col + NumOfCols - 2) do
      WriteChar(32);                               { fill window with spaces }
    MenuColor := WFrameColor;                      { update display color    }
    WriteChar(WVertical);                          { write right border      }
  end;
  SetMemAddress(Col,line + NumOfLines - 1);        { set address to display  }
  SaveScreen(WArray[WindowNum,Pred(NumOfLines),0],NumOfCols);
                                                   { save text on screen     }
  WriteChar(WLowleft);                             { write left corner       }
  for count1 := Succ(col) to (col + NumOfCols - 2) do
    WriteChar(WHorizontal);                        { write middle of line    }
  WriteChar(WLowRight);                            { write right corner      }
  Inc(WindowNum);
end;  { procedure MakeWindow }

Procedure RestoreWindow(col,line,NumOfCols,NumOfLines : byte);
{
1.  Proc. Name
    RestoreWindow -- Restore the screen "under" the window

2.  Functional Description
    The indicated position on the screen is restored to its original contents.
}
var
  count : integer;
begin { procedure RestoreWindow }
  Dec(WindowNum);
  for count := (line + Pred(NumOfLines)) downto line do
  begin
    SetMemAddress(Col,count);                    { calculate screen location }
    RestoreScreen(WArray[WindowNum,count - line],NumOfCols);
                                                 { re-display contents     }
  end;
end;  { procedure RestoreWindow }

Function GetString (Col, line,                { line and column to get input }
                    Maxlen  : byte;           { Maximum length of string     }
                    Default : VarString;      { default value of string      }
                    UpC : Boolean): VarString;{ Uppercase flag               }
{
1.  Proc. Name
    GetString -- reads a string from the user

2.  Functional Description
    First the default string is displayed. If the user enters a new string
    length and legal character checking are performed. The string is
    terminated by either a carriage return or an escape.
}

var
  newstr     : Boolean;
  position,
  count,
  SaveCursor : integer;
  Ch         : char;
  SubString  : String[1];
  FrontString,
  BackString,
  AllStr  : String;
  reg     : Registers;

begin { function GetString }
  SaveCursor := getCurSorMode;
  SetCurSorMode (CurSorOn);
  newstr := true;    { set flag to indicate that we are starting new string }
  oldx := whereX;    { save present screen coordinates                      }
  oldy := whereY;
  AllStr := '';   { save default string in local variable                }
  // AllStr[0]:= Chr(0);         JUNE2009
  position := 1;  { set position in string                    }
  col := col - 2;
  ch := #0;
  repeat
    SetMemAddress(col + 1,line);
    WriteString (AllStr);
    //for count := (MaxLen - 1) downto byte(AllStr[0]) do       JUNE2009
    //  WriteChar(32);                                               JUNE2009
    GotoXY(col + position,line); { update cursor  }
    reg.ah := 1;  { invoke the BIOS call that checks for a keystroke }
    Intr ($16,reg);
    if not(Boolean (reg.flags and $40)) then
      begin
        reg.ah := 0; { A keystroke is there; take it out of the BIOS buffer }
        Intr ($16, reg);
        Ch := Char (reg.al);
        if (ch = #8) then
           begin
             if position <> 1 then        { if Back-Space                     }
               begin
                  delete(AllStr,Position - 1,1); { delete last char in string        }
                  position := Pred(position);{ decrement position counter        }
               end;
           end;
        if Byte (Ch) = 0 then  { If a special key was pressed... }
        begin
          case reg.ah of
            //83:if Position <= byte(AllStr[0]) then{ if delete key then delete char  }       JUNE2009
            //      delete(AllStr,Position,1);         { under the cursor                }          JUNE2009
            75 :if position <> 1 then          { non destructive back-space      }
                 position := Pred(position);  { decrement position counter      }
            //78 :if position <= byte(AllStr[0]) + 1 then  { right one character       }          JUNE2009
            //     position := Succ(position);   { increment position counter      }          JUNE2009
          end;
        end;
        if Upc then ch := UpCase(ch);  { if Upper case flag than set the char   }
      //  if (ch in CharFilter) and (byte(AllStr[0]) < Maxlen) then    JUNE2009
        if (ch in CharFilter) and (length(AllStr) < Maxlen) then
        begin                               { check that character is legal   }
          if newstr then
             begin
               AllStr := '';              { re-initialize the string        }
               Position := 1;                  { re-initialize position counter  }
             end;
          SubString:=' ';
          Substring[1]:=Ch;
          FrontString:=Copy (AllStr, 1, position);
          BackString:=Copy (AllStr, position, (Length(AllStr)-position));
          AllStr:= FrontString + SubString + BackString;
          position := Succ(position);       { increment position counter      }
        end;
      end;
    newstr := false;
  until ch in [#27,#13];                  { until carriage return or escape }
  if ch = #27 then
    Allstr := #27;
  GetString := AllStr;
  GotoXY(oldx,oldy);                      { update screen's cursor          }
  SetCurSorMode(SaveCurSor);
end;  { function GetString }


Function Boolprompt (row: integer; var s): char;
const
   hg = 3;
var
   ch:char;
   cl, wd, ln: integer;
   l : byte absolute s;
   prompt: VarString absolute s;
   d : integer;
begin
  cl := 40 - (l shr 1);
  wd := l + 5;
  ln := row;
  d := WhereY - ln;
  if (d >= 0) and (d < 3) then
    ln := Succ(ln) + d;
  MakeWindow(cl,ln,wd,hg);
  MenuColor := WLowColor;
  SetMemAddress(cl + 2, ln + 1);
  WriteString(prompt);
  Repeat ch := Upcase(ReadChar) until ch in ['Y','N',#27];
  RestoreWindow(cl,ln,wd,hg);
  BoolPrompt := ch;
end; {Boolprompt}

Function BoolSimp(row: integer; strng : string): char;
var
   ch:char;
   cl, wd, ln: integer;
   d : integer;
begin
  cl := 40 - ((Length(Strng)+5) div 2);
  wd := length(Strng) + 5;
  ln := row;
  d := WhereY - ln;
  if (d >= 0) and (d < 3) then
    ln := Succ(ln) + d;
  MakeWindow(cl,ln,wd,3);
  MenuColor := WLowColor;
  SetMemAddress(cl + 2, ln + 1);
  WriteString(Strng);
  Repeat ch := Upcase(ReadChar) until ch in ['Y','N',#27];
  RestoreWindow(cl,ln,wd,3);
  BoolSimp:= ch;
end; {BoolSimp}

Procedure DispESC;
{
1.  Proc. Name
    DispESC -- display ESC key prompt

2.  Functional Description
    The routine simply sets the appropriate address on the screen
    and displays the string held in the typed constant.
}
const
  st: string [49] = '    press ESCAPE to exit pulldown menu system   ';
begin { procedure DispESC }
  SetmemAddress(15,1);             { set the appropriate address on the screen }
  MenuColor := PLowColor;        { set display color                         }
  // WriteString (st);               { display the string on the screen          }   JUNE2009
end;  { procedure DispESC }

Procedure DispF10;
{
1.  Proc. Name
    DispF10 -- display ESC key prompt

2.  Functional Description
    The routine simply sets the appropriate address on the screen
    and displays the string held in the typed constant.
}
const
  st: string [49] = '   press F10 Key to enter pulldown menu system  ';
begin { procedure DispF10 }
  SetmemAddress(15,1);             { set the appropriate address on the screen }
  MenuColor := PLowColor;        { set display color                         }
  // WriteString (st);               { display the string on the screen          }  JUNE2009
end;  { procedure DispF10 }

Procedure SetOnOff(var c; state: boolean);
{  The last three characters of the string passed as an untyped parameter
   are set to 'ON' or 'OFF', depending on the value of the parameter
   "state."  This procedure assumes that the string is exactly 21
   characters long.
}
var                           { assign an absolute variable to the location  }
  s : string[22] absolute c;  { of the string being checked                  }
Const
  onoff : array [1..2] of array [1..3] of char = (' ON','OFF');
begin { procedure SetOnOff }
  if state then
    move(onoff[1],s[19],3)    { set to ON  }
  else
    move(onoff[2],s[19],3);   { set to OFF }
end;  { procedure SetOnOff }

Procedure GetFlags;
{  Set the current text formating flags }
begin
  with Curwin^ do
  begin
    //InsertDef := Not boolean (InsertFlag);
    //SetOnOff(st41,InsertDef);
    //  AutoinDef := AI;               JUNE2009
    //  SetOnOff(st43,AutoinDef);      JUNE2009
    //  WordWpdef := WW;               JUNE2009
    //  SetOnOff(st42,WordWpDef);      JUNE2009
  end;
end;

Function EditMessage (Mno : byte) : Varstring;
{  This routine trys to read a error message from the
   file. If not possible, it produces the error no. and
   an additional message instead. The string is returned
   to the caller
}
 
var
  St  : varstring;
  fl  : text;
  i,c : Integer;
 
begin {EditMessage}
  Assign(fl,ErrorFile);             {The error message is read from the file}
  {$I-}
  Reset(fl);
  {$I+}
  c := IOresult;
  if c = 0 then
  begin
    Repeat
      ReadLn(fl,St);
      Val(Copy(St,1,3),i,c);        {Check the error no.}
    until (Mno = i) or eof(fl);
    If eof(fl) then c := 255;
    Delete(St,1,3);
    Close(fl);
  end;
  If c <> 0 then
  begin                             {If something went wrong then display}
    Str(Mno,St);                    {the plain error number}
    St := '  Error ' + St + ' - Message not found';
  end;
  EditMessage := St;
end; {EditMessage}

Procedure UserError {(var Msgno : byte)};
{  This is the user error handler hook }
begin { procedure UserError }
  If ErrorCheck(Msgno) then;
  Msgno := 0;
end;  { procedure UserError }

Procedure EditErrormsg (Msgno : byte);
{  This routine is called by any command module to append an error
   message to the command line, dump the typeahead buffer to a bit
   bucket, then wait for the user to press any key to continue. The
   routine tries to load the message from a file called 'EDITERR.MSG'.
   if it doesn't find the file, then the plain error no. is displayed.
   If you code a UserError routine to trap the error code, you can set
   UserError's argument to any byte value, enabling you to change the
   message to be displayed or to disable display of messages.
}
var
  Mno : byte;
  Ch  : byte;

begin {EditErrormsg}
  Circin := Circout;                {Zap typeahead buffer before read}
  EditUsercommandInput := 0;        {Reset char count for EditClsinp}
  Mno := Msgno;                     {Local copy so user can change its value}
  UserError (Mno);                  {In MicroStar, UserError always handles it}
end; {EditErrormsg}

Function ErrorCheck (ErrorNum:byte) : boolean;
{  If the ErrorNum <> 0 then  there has been some kind of error. The
   appropriate error message is displayed, and the user must press escape
   before the program will resume execution.
}
var
  ch    : char;
  st    : VarString;
  count : byte;
begin { function ErrorCheck }
  IOsave := ErrorNum;                    { assign the error number to the    }
  if IOsave <> 0 then                    { global variable IOsave }
  begin
    MenuColor := PLowColor;              { Update the text color }
    Beep;                                { Beep to get the user's attention }
    SetMemAddress(1,1);                  { set the display coordinates to 1,1}
    st := EditMessage(IOSave);           { Get the appropriate error message }
    st := st + ' - Press ESC ';
    SaveScreen(SaveCmdLine,80);          { save the current command line text}
    WriteString(st);                     { display the error message }
    for count := (EndPosition - 2) downto byte(St[0]) do { pad line w/ spaces}
      WriteChar(32);
    repeat                               { read the keyboard for ESCAPE }
      ch:= Readkey;
    until (ch = #27) and not keypressed;
    SetMemAddress(1,1);                  { set the display coordinates to 1,1}
    RestoreScreen(SaveCmdLine,80);       { restore original text on command  }
  end;                                   { line }
  ErrorCheck := (IOSave <> 0);
end;  { function ErrorCheck }

Procedure EditUpdwinsl (w : Pwindesc) ;
{  This routine updates the status line for the specified window. }
var
  St   : Varstring;
  Whdr : Textline;
  p    : Pwindesc;
  wn   : Byte;

begin {EditUpdwinsl}

  p := Window1;
  wn := 1;
  while p <> w do
    Begin
      p := p^.Fwdlink;
      wn := Succ (wn)
    end;
  { UserStatusLine always handles updating in MicroStar }
  UserStatusline(wn,w^.Colno,w^.Clineno,w^.Insertflag,w^.WW,W^.AI);
end; {EditUpdwinsl}

Procedure EditIncline;
{  This routine increments the current window's line number
   and then displays it on the status line.
}
begin {EditIncline}
  Curwin^.Clineno := Succ (Curwin^.Clineno);
  EditUpdwinsl (Curwin)
end; {EditIncline}

Procedure EditDecline;
{  This routine decrements the current window's line number
   and then displays it on the status line.
}
begin {EditDecline}
  Curwin^.Clineno := Pred (Curwin^.Clineno);
  EditUpdwinsl (Curwin)
end; {EditDecline}

Procedure EditDestxtdes  (var Desc : Plinedesc) ;
{  This routine disposes of a text line descriptor and its associated
   text line buffer.
}
begin {EditDestxtdes}
  Freemem (Desc^.Txt, Succ (Desc^.BuffLen));        {Free text line first}
  Freemem (Desc, 16)                                {Now the linedesc itself}
end; {EditDestxtdes}

Function EditMaktxtdes  (Ncols : integer) : Plinedesc ;
{  This routine allocates a text descriptor and a text buffer from DOS
   and links them together for the caller. The contents of the text buffer
   are reset to spaces, and the length of the buffer is saved in the text
   descriptor.
}
var
  Address     : Plinedesc;
  Linebufsize : integer;

begin {EditMaktxtdes}
  //if (Maxavail > 0) and (Maxavail <= ((Ncols + 32 + 4096) div 16)) then
{! 7. ^USE TURBO3 unit in order for MemAvail,MaxAvail to return paragraphs.}
{! 7. ^USE TURBO3 unit in order for MemAvail,MaxAvail to return paragraphs.}
  //begin                                   {Give a 4k margin for stack}
   // EditMaktxtdes := nil;
   // exit
  //end;
  Getmem (Address, 16);                     {Get linedesc first}
  Linebufsize := ((Ncols+16) div 16) * 16;  {Line includes length byte}
  Getmem (Address^.Txt, Linebufsize);
  Address^.BuffLen := Pred (Linebufsize);     {Don't include length byte in size}
  Fillchar (Address^.Txt^, Linebufsize, ' ');
  Address^.Flags := 0;                      {Not in block or anything else}
  EditMaktxtdes := Address
end; {EditMaktxtdes}

Function EditSizeline (p : Plinedesc; Ncols : integer) : boolean ;
{  This routine examines the length of the allocated line buffer for
   the text descriptor pointed to by p, and if it is smaller than
   Ncols, a new line buffer is allocated for it, and the old one is
   released to free memory. If the line is too large, it is left alone.
}
var
  Buf : Textline;
  q   : Ptextline;
  Len : integer;

begin {EditSizeline}
  if p^.BuffLen >= Ncols then
  begin
    EditSizeline := true;       { line is long enough }
    exit
  end
  else if (Ncols > Maxint - 16) or (Ncols <= 0) then
  begin
    EditSizeline := false;      { Don't make lines larger than Maxint }
    exit
  end;
  Len := ((Ncols+16) div 16) * 16;   { Line includes length byte }
//  if (Maxavail > 0) and (Maxavail <= ((Len + 4096) div 16)) then
{! 8. ^USE TURBO3 unit in order for MemAvail,MaxAvail to return paragraphs.}
{! 8. ^USE TURBO3 unit in order for MemAvail,MaxAvail to return paragraphs.}
//  begin                              { Give a 4k margin for stack }
//    EditSizeline := false;
//    exit
//  end;
  Getmem (q, Len);
  EditSizeline := true;                 { Return success }
  Fillchar (Q^, Len, ' ');              { Blank out line }
  Move (p^.Txt^[1], q^[1], p^.BuffLen); { Copy text }
  Freemem (p^.Txt, Succ (p^.BuffLen));  { deallocate memory }
  p^.Txt := q;
  p^.BuffLen := Pred (Len)              { Don't include length byte in size }
end; {EditSizeline}

Function EditCrewindow ( Top : integer; Len : integer; Fn : varstring;
                         Cr  : integer; Cc  : integer):Pwindesc;
{  This routine is called to create a window data structure. It does
   not integrate the structure into any existing data structures;
   rather, it returns a pointer to the completed window. If no memory
   can be found for the first text line in the text stream, nil is
   returned.
}
var
  p : Pwindesc;
  i : integer;

begin {EditCrewindow}
  p := Winstack;                      { Pop a window off the free list }
  Winstack := Winstack^.Fwdlink;
  with p^ do
  begin
    Fwdlink := nil;
    Backlink := nil;
    Filename := Fn;
    Insertflag := Insert;
    WW := false;
    AI := false;
    Firstlineno := Top;
    Lastlineno := Pred (Top + Len);
    Lmargin := 1;
    Rmargin := Logscrcols;
    Lineno := Cr;
    Colno := Cc;
    Clineno := 0;                   {Absolute line number for display only}
    Topline := EditMaktxtdes (16);  {A good default for the first line}
    Curline := Topline;
    Leftedge := 1;
  end;
  if p^.Topline <> nil then
    with p^ do
    begin
      Topline^.Fwdlink := nil;
      Topline^.Backlink := nil;
      Stream := EditNewstream;
      EditCrewindow := p
    end
  else
    EditCrewindow := nil
end; {EditCrewindow}


Function EditInsbuf  (Ncols : integer) : boolean ;
{  This routine makes a text descriptor and inserts it into the text
   stream for the current window after the current line. If memory
   cannot be acquired for the line, false is returned, else true. Once
   the line is inserted, the current window's Curline pointer is moved
   to point to the new line.
}
var  p : Plinedesc;

begin {EditInsbuf}
  with Curwin^ do
  begin
    p := EditMaktxtdes (Ncols);              {Make new text buffer}
    if p = nil then
    begin
      EditInsbuf := false;
      exit
    end;
    EditInsbuf := true;
    with p^ do
    begin
      p^.Backlink := Curline;
      p^.Fwdlink := Curline^.Fwdlink;
      p^.Flags := 0
    end;
    Curline^.Fwdlink := p;
    if p^.Fwdlink <> nil then
      p^.Fwdlink^.Backlink := p;
    Curline := p;                            {Advance cursor to next line}
    if Lineno = (Lastlineno - Firstlineno) then
      Topline := Topline^.Fwdlink            {Scroll screen up one line}
    else
      Lineno := Succ (Lineno)                {Just increment Lineno}
  end
end; {EditInsbuf}


Function EditNewstream { : integer };
{  This routine generates a new text stream identifier which is
   not in use in the editor at the current time, so that text streams
   in windows may be distinguished from each other.
}
begin {EditNewstream}
  EditNewstream := Nextstream;
  Nextstream := Succ (Nextstream) mod 32767
end; {EditNewstream}

Procedure EditOffblock;
{  This routine is called by block command processors when they
   determine that a block has been made discontiguous or otherwise
   corrupt. It turns off the Inblock bit for every text line in the
   system, so that Markblock can turn the bit on for the correct
   lines in the block.
}
var
  i : integer;
  w : Pwindesc;
  p : Plinedesc;

begin {EditOffblock}
  w := Curwin;                          {Start with current window}
  repeat                                {Do this to every window}
    p := w^.Topline;                    {Clean out lines in window first}
    while p <> nil do
    begin                             {Clear out this window's lines}
      p^.Flags := p^.Flags and (not Inblock);
      p := p^.Fwdlink
    end;
    p := w^.Topline;                    {Now clean out lines above Topline}
    while p <> nil do
    begin
      p^.Flags := p^.Flags and (not Inblock);
      p := p^.Backlink
    end;
    w := w^.Fwdlink
  until w = Curwin;
end; {EditOffblock}

Procedure EditRealign;
{  This procedure is called anytime a text stream is modified by
   either adding lines to it or deleting lines from it. If several
   windows happen to be positioned over the same text area which
   is contracted or expanded, the line number, current line pointer,
   and Topline pointer can be made to be disharmoneous. This procedure
   assumes that Topline and Curline are well defined for each window;
   that is, if you delete text, you must make sure that you do not
   make these pointers point to reclaimed storage. If you delete
   lines in a procedure, call EditDelline; it checks this.
}
var
  p : Pwindesc;
  q : Plinedesc;

begin {EditRealign}
  p := Window1;
  repeat
    with p^ do
    begin                 {Realign this window}
      Lineno := 1;
      q := Topline;       {This should always be defined}
      while q <> Curline do
      begin             {Scan until we find the current line}
        q := q^.Fwdlink;
        if Lineno = (Lastlineno - Firstlineno) then
          Topline := Topline^.Fwdlink
        else
          Lineno := Succ (Lineno)
      end
    end;
    p := p^.Fwdlink
  until p = Window1
end; {EditRealign}

procedure UserStatusline (Var TWindow:Byte;  Column,line:Integer;
                         Insertflag:Insflag; WW,AI: boolean) ;
{ This routine updates the UserStatus line for the current window }
{ This differs from the UserStatusLine procedure within MS.PAS in }
{ that it shows the amount of free memory rather than showing if  }
{ the word-wrap and auto-indent modes are on. N.B. it is possible }
{ to check these one can invoke the editing commands window and   }
{ then enter the "TEXT FORMAT" sub-window }
const
  Statusline :  String[67] =
 'File:                   Line:    1 Col:    1 Insert       ';

  Firststat :  String[23] =   ' Free Memory:         ';
  is_flag   : String[3] = ' ON';
  nn        : String[3] = 'OFF';
  none = ' <None>     ';
var
  st:string[15];

begin { procedure UserStatusLine }
  if TWindow <> 1 then
  begin
    MenuColor:=PLowColor;
   // FreeMemory := MemAvail;
    if (last_free_Memory=0) or (freememory < (last_free_Memory-40)) then
        begin
           last_free_Memory:=FreeMemory;
          // Str(last_free_Memory:6,st);    JUNE2009
          // move(St[1],FirstStat[15],6);   JUNE2009
          // SetMemAddress(1,11);           JUNE2009
          // Writestring(FirstStat);        JUNE2009
        end;
        // JUNE2009
 {   SetMemAddress(23,11);
    Str(Line:6,st);
    move(St[1],Statusline[29],6);
    Str(Column:6,st);
    move(St[1],Statusline[39],6);
    if NoWorkfile then
       begin
         st:= none;
         move(st[1],Statusline[8],11);
       end
    else
        st:=workfilename;
    if Length(WorkFileName)>12 then
        move(st[1],statusline[8],12)
    else
        move(st[1],statusline[8],Length(workfilename));
    if TWindow = CurrWindow then
    begin
      if boolean (Insertflag) then
        st:=nn
      else
        St:=is;
      move(st[1],Statusline[53],3);
    end;
    Writestring(StatusLine);        }
  end;
  TWindow := 0;
end;  { procedure UserStatusLine }



Procedure EditAutoIndentLine;
{  This routine inserts spaces at the beginning of a line so
   that it lines up with the first nonblank character of the
   line above.
}
var
  p: Plinedesc;
  i,j: integer;

begin {EditAutoIndentLine}
with Curwin^ do begin
    p := Curline^.Backlink;
    i := 1;
    while (i < p^.BuffLen) and (p^.Txt^ [i] = ' ') do i := Succ (i);
    if i = p^.BuffLen then i := 1;
    Colno := i;
    j := Curline^.BuffLen;
    if not EditSizeline (Curline, Pred(i) + j) then
    begin
      EditErrormsg (35);
      EditRealign;
      exit
    end;
    if i > 1 then
    begin
      move(Curline^.Txt^ [1], Curline^.Txt^ [i], j);
      fillchar(Curline^.Txt^[1], Pred(i), ' ');
    end;
  end;
end; {EditAutoIndentLine}

Procedure ClearSubMenu(ScreenPosition,Width:integer);
{  The current sub-menu is cleared from the screen and the original text
   is restored to the screen.
}
var
  count : integer;
begin { procedure ClearSubMenu }
  if NoSelection <> 0 then                      { if in pull down menu }
    for count := 0 to (NoSelection + 1) do
    begin
      SetMemAddress(ScreenPosition - 1,count + 3);    { screen address  }
      RestoreScreen(SaveSubmenu[count,0],Width + 2);  { restore display }
    end;
  NoSelection := 0;                             { reset global flag }
end;  { procedure ClearSubMenu }

{
Procedure EditBeginningLine;
begin
  Curwin^.ColNo := 1;
end;  }

Procedure EditEndLineOld;
{  This routine positions the cursor to the right of the last non-
   blank character in the line.
}
var
  ypos : integer;
begin
  {Position after last char}
  {
  with Curwin^, Curline^ do
  begin
    Colno := BuffLen;
    while (Txt^ [Colno] = ' ') and (Colno > 1) do
      Colno := Pred (Colno);
    if Colno < BuffLen then
      if Txt^ [Colno] <> ' ' then
    Colno := Succ (Colno);
  end; }
end;

Function Interrupted:boolean;
   { Check the keyboard to see if a key has been pressed and return }
   { the value true if one has }
var
   reg : Registers;

begin
    Interrupted:=False;
    reg.ah := 1;  { invoke the BIOS call that checks for a keystroke }
    Intr ($16, reg);
    if Boolean (reg.flags and $40) then
         exit   { if no keystroke, give then exit function }
    else
       begin
          reg.ah := 0; { A keystroke is there; take it out of the BIOS buffer }
          Intr ($16, reg);
          if reg.ah = 1 then
               begin
                   Interrupted:=true;
                   Globerr:=True;
               end;
       end;
end;

    Procedure Wait_Till_Touched;
    { This routine checks to see if either the mouse or the keyboard
      has been touched }
    var
       reg : registers;
       tempMouseCol,
       TempMouseRow  : Integer;
       Response      : byte;
       Mouse_Or_KeyBoard_Touched : boolean;

    begin
         Mouse_Or_Keyboard_Touched := false;
         repeat
            If MouseInst then
               begin
                  GetButtonPress(1, ButtonStat, ButCount1, TempMouseCol, TempMouseRow);
                  GetButtonPress(2, ButtonStat, ButCount2, TempMouseCol, TempMouseRow);
                  if ButCount1 > 0 then
                      Mouse_Or_KeyBoard_Touched := True
                  else if ButCount2 > 0 then
                      Mouse_Or_KeyBoard_Touched := True;
                  if (Mouse_Or_Keyboard_Touched) then exit;
               end;
            reg.ah := 1;  { invoke the BIOS call that checks for a keystroke }
            Intr ($16, Reg);
            if not(boolean (reg.flags and $40)) then
               Mouse_Or_KeyBoard_Touched := True
          until Mouse_Or_Keyboard_Touched;
    end;

function Direction : byte;
{ this is somewhat like the Editkeypressed function in Input.ms}
{ but it is simpler in that it only tests for four types of key}
{ up-cursor,down-cursor,return and escape.  The up and down }
{ cursor keys are used to make selections from the pop-op window}
{ return is used to indicate that a final choice has been made}
{ and escape will close the window without making any choice }

var
  Ch  : char;
  reg : Registers;
  MouseColTemp,
  MouseRowTemp,
  Response     : Integer;
begin
  response := 0;
  repeat
    if MouseInst then
       begin
          GetButtonPress(1, ButtonStat, ButCount1, MouseColTemp, MouseRowTemp);
          GetButtonPress(2, ButtonStat, ButCount2, MouseColTemp, MouseRowTemp);
          GetMouse(MouseColTemp, MouseRowTemp, ButtonStat);
          if ButCount1 > 0 then
             Response := 1
          else if ButCount2 > 0 then
             Response := 28
          else if (MouseRowTemp > SelwinMouseRow) then
             begin
                SelwinMouseRow := MouseRowTemp;
                Response   := 80;
             end
          else if (MouseRowTemp < SelwinMouseRow) then
             begin
                SelwinMouseRow := MouseRowTemp;
                Response   := 72;
             end
       end;
    reg.ah := 1;  { invoke the BIOS call that checks for a keystroke }
    Intr ($16, Reg);
    if not(boolean (reg.flags and $40)) then
       begin
          reg.ah := 0; { A keystroke is there; take it out of the BIOS buffer }
          Intr ($16, reg);
          Response := Reg.Ah;
       end;
    SelwinMouseCol := 200;
    SelwinMouseRow := 48;
    SetMouse(SelwinMouseCol, SelwinMouseRow);
  until response in [1,28,72,80,81,73];
  Direction := Response;
end;

Procedure ShowMessage(Instring1 : String78; Instring2: String78;
                       Instring3 : String78);
      { Show a message on the upper half of the screen }
      { centring each line in a temporary pop up window }
var
   Line1,
   TemSt,
   St1    : String78;
   msgString : string;
   Ch : char;
   LeadSpaces : integer;

 {  Procedure Fill_Blank(inst : String78);
   var
      i : integer;
   begin
      For i := 69 downto Length(Inst) do WriteChar(32);
   end;

   Procedure WriteCentredLine(Var Inst : string78);
   var
      i,
      LeadSp : integer;
   begin
      LeadSp:=(72-Length(Inst)) div 2;
      For i:=1 to LeadSp do
         Inst :=  ' ' + Inst;
      WriteString(Inst);
      Fill_Blank(Inst);
   end;    }

Begin
    msgString:= concat(Instring1,'.  ');
    msgString:= concat(msgString, Instring2);  
    msgString:= concat(msgString,'.  ');
    msgString:= concat(msgString, Instring3);
    msgString:= concat(msgString,'.  ');
    MessageDlg(Format(msgString, [name]), mtConfirmation,
          [mbYes], 0);
{   MakeWindow(4,7,72,5);
   MenuColor:=PlowColor;
   SetMemAddress(5,8);
   WriteCentredLine(Instring1);
   SetMemAddress(5,9);
   WriteCentredLine(Instring2);
   SetMemAddress(5,10);
   WriteCentredLine(Instring3);
   MenuColor:=PFrameColor;  }
end;

Procedure CloseMessageWindow;
     { Close the window used for displaying temporary messages }
begin
   RestoreWindow(4,7,72,5);
end;

Procedure LexicalError(Instring1 : String78;
                       Instring2 : String78;
                       Instring3 : String78);
     { This is used when an error has been encountered while parsing }
     { An error message is displayed showing the type of error that }
     { has been found.  Set globerr to true so that the rest of the }
     { program knows that an error has been found.  Delay the execution }
     { of the program until the user has read the message and pressed the }
     { escape key }

var
   ch         : char;

Begin
   If Globerr then exit;  { if an error has already been found exit }
   GlobErr:=true;
   ShowMessage ( Instring1, Instring2, Instring3);
   if (Instring3 = '- Press ESC ') then
     repeat
        ch:= ReadChar;
     until upcase(ch) = #27
   Else
     ch := VertChar;
   CloseMessageWindow;
   MenuColor:=PFrameColor;
   SetCursorMode(CursorOff);
end;

Procedure ReadOpen(namestr : string; var infile :  TEXT);
var
     ch : char;
begin
     assign(infile, namestr);
     {$I-}
     reset(infile);
     {$I+}
     if (IOresult <> 0) then
       begin
         Showmessage('ERROR : the file - ' + namestr + ' - could not be opened',
                     'the program will abort',
                     'press any key to continue');
         ch := readkey;
         halt;
       end
     else
       begin
         Inc(File_Ary_Pos);
         File_Ary[File_Ary_Pos] := namestr;
       end;
end;

Procedure WriteOpen(var infile :  TEXT; namestr : string);
var
     ch : char;
     outString : string;
begin
     {$I-}
     assign(infile, namestr);
     rewrite(infile);
     {$I+}
     if (IOresult < 0) then
       begin
         str(IOresult, outString);
         outString:=concat('Error Result ', outString);
         Showmessage('ERROR : the file - ' + namestr + ' - could not be opened',
                     outString,
                     'press any key to continue');
         ch := readkey;
         halt;
       end
     else
       begin
         Inc(File_Ary_Pos);
         File_Ary[File_Ary_Pos] := namestr;
       end;
end;

Procedure CloseFile(namestr : string;  var infile :  TEXT);
var
     ch : char;
     i  : integer;
begin
     {$I-}
     close(infile);
     {$I+}
     if (IOresult <> 0) then
       begin
         Showmessage('ERROR : the file - ' + namestr + ' - could not be closed',
                     'the program will abort',
                     'press any key to continue');
         ch := readkey;
         halt;
       end
     else
       begin
         i := 1;
         while ((File_Ary[i] <> Namestr) and (i < File_Ary_Pos)) do
            inc(i);
         while (i <= File_Ary_Pos) do
            begin
              File_Ary[i] := File_Ary[i+1];
              inc(i);
            end;
         File_Ary[i] := '';
         Dec(File_Ary_Pos);
       end;
end;


Procedure Abort;
begin
   SetCursorMode(cursoron);
   Halt;
end;

Procedure ChangeDir(Inst : string);
begin
   {$I-}
   Chdir(inst);
   {$I+}
   If (IOresult <> 0) then
      begin
         LexicalError('The Directory '+ Inst,
                   'was not found. Program Aborting','- Press ESC ');
         Abort;
      end;
end;

end.
