Unit StatVar;

Interface


Uses
    Dos,
    EdVar,
    Mouse;


Const
    TotalVars   = 500;
    TotalCats   = 500;
    codelen     = 500;
    false1     = 0;    { so that there is a numerical value for each }
    true1      = 1;    { of the operators to be handled by the parser }
    Individual = 2;    { each of these constants has a string associated }
    Family     = 3;    { with it in the symbol table array }
    Household  = 4;
    rsquare    = 70;
    lsquare    = 71;
    array1     = 73;
    fullStop   = 80;
    comma      = 81;
    to1        = 82;
    quote      = 84;
    semic      = 85;
    colon      = 86;
    CurUserVar = 87;
    UserVar      = 89;
    variable     = 90;
    number       = 91;
    benefit      = 92;
    tax          = 93;
    random       = 94;
    and1         = 100;
    minus        = 101;
    plus         = 102;
    or1          = 103;
    not1         = 104;
    lbrack       = 105;
    rbrack       = 106;
    Rcurly       = 107;
    lcurly       = 108;
    first        = 109;
    count        = 110;
    sum          = 112;
    max          = 113;
    min          = 114;
    grossing_var = 115;
    sort     = 116;
    data     = 117;
    div1     = 118;
    write1   = 119;
    times    = 120;
    divide   = 121;
    modulo   = 122;
    if1      = 123;
    then1    = 124;
    else1    = 125;
    target_data= 126;
    source   = 127;
    caseload_calibration = 129;
    equals   = 140;
    ne       = 141;
    gt       = 142;
    ge       = 143;
    lt       = 144;
    le       = 145;
    eqmv     = 146;
    nemv     = 147;
    range    = 148;
    rband    = 149;
    relse    = 150;
    hi       = 151;
    lo       = 152;
    eof1     = 153;
    WRITEVAR = 160;
    jump     = 161;
    Money    = 162;
    End_Anal_Level = 163;
    Analysis_Level = 164;
    name           = 165;
    varlabel       = 166;
    valuelabel     = 167;
    integer1       = 168;
    real1          = 169;
    money1         = 170;
    boolean1       = 171;
    width          = 172;
    is_flag        = 173;
    Less           = 174;
    Per_Year      = 175;
    RealNumber     = 176;
    FracMult       = 177;
    PerCent        = 178;
    Abs1           = 179;
    to_power_of    = 180;
    Per_Month      = 181;
    exp1           = 182;
    Policy_Status       = 183;
    Start_Policy        = 184;
    End_Policy          = 185;
    Start_Charge        = 186;
    End_Charge          = 187;
    Policy_Target_Data  = 188;
    Unit_Cost           = 189;
    Units               = 190;
    Charge              = 191;
    Policy              = 192;
    Description         = 193;
    Store_Var           = 232;
    Withdrawn_By        = 233;
    End_Of_Pointer      = 234;
    Pointer             = 235;
    Spouses             = 236;
    Head_of_Households  = 237;
    Head_of_Familys     = 238;
    Wifes               = 239;
    Husbands            = 240;
    End_Of_Rule         = 241;
    Total_Family        = 242;
    Total_Household     = 243;
    Number_in_Family    = 244;
    Number_in_HouseHold = 245;
    Any_in_Family       = 246;
    Any_in_HouseHold    = 247;
    Start_Tax           = 248;
    Start_Benefit       = 249;
    End_Tax             = 250;
    End_Benefit         = 251;
    User_Const          = 252;

    SymMax     = 108;

    Missing1    = 2147483645;
    Missing2    = 2147483643;
    Missing3    = 2147483642;
    MaxRaws     = {$I max.def}
    Table_Limit = {$I INDNUM.DEF}

Type
   sym_rec =                    { this is the basic unit of the symbol }
       record                   { table - it consists of a string plus }
           symbol : string[30]; { and integer to represent the symbol }
           tokn   : integer;
       end;
   TypeOfData = (Byte1,LongInt1);  { this is used to indicate whether a }
                                   { specific variable is stored as bytes }
                                   { or as long integers }
   String78 = String[78];
   Str150 = String[150];
   LongPtrType = ^Str150;
   Str45 = String[45];
   Variable_Array = Array[0..TotalVars] of LongPtrType;
   ValuSet  =  Record    { this is an array used to store sets of value }
                    V_Ary  : Variable_Array;                  {labels and the numbers which }
                    N_Ary  : Array [0..TotalCats] of Integer; {go with them }
                End;
   ValSetPtr = ^ValuSet; { this is a pointer to a set of value labels }
   VarRec =  record      { This is a variable record }
                 Assigned : boolean;      { shows if the record is assigned }
                 LongPtr  : LongPtrType;  { points to a long descriptive name }
                 BigPtr   : LongPtrType;  { points to a LongPtr in upper case }
                 DataType : TypeOfData;   { shows if a byte or long integer }
                 ValPtr   : ValSetPtr;    { points to value label set }
                 factor   : real;         { stores an inflation factor }
                 IfValLabs: boolean;      { shows if variable has value labels}
                 IfReal   : boolean;
                 IfBool   : boolean;
                 IfMoney  : boolean;
                 IfDisplay: boolean;
                 VarName  : String[9];
                 varpos   : integer;
                 Level    : Byte;
              end;
   VarPtr   = ^VarRec;           { points to a variable record }
   DataRec  = Array[1..MaxRaws] of LongInt;
   ShortStr = String[40];
   code_rec =             { This is the basic unit of the heap }
       record              { it contains a long integer which may represent}
           i : LongInt;    { either an operand or an operator, and a boolean }
           op: boolean;    { value which is true if the i value is an operator}
       end;
   TokenType = 0..350;


var
  CodeStart : Integer;      { position on heap of current rule start }
  code  : array[1..codelen] of code_rec;  { heap to store commands for }
                                          { the interpreter }
  userfilenum,
  codePtr: integer;                { pointer to current position on heap }
  Array_Array,           {Array to store names of arrays }
  Ind_Array,             {Array to store names of income variables}
  Taxun_Array,           {Array to store names of spending variables}
  Hhold_array,           {Array to store names of non-money variables}
  Ind_Cat_Ary,
  Taxun_Cat_Ary,
  Hhold_Cat_Ary,
  User_Array,
  User_Cat_Ary,
  Value_Label_Ary,
  Value_Label_Set,
  Tot_Var_Ary        : Variable_Array;
  VarArray           : Array [1..TotalVars] of VarPtr;  { Variable Array }
  Files              : Array[1..TotalVars] of integer;
  RawVarMax,
  HighestVar         : Integer;
  DataBuf            : DataRec;
  DataFile           : File of DataRec;
  LastCaseDone,
  Globerr : boolean;
  Anal_Level :array[1..5] of TokenType;
  SymTab : array[1..SymMax]of Sym_rec;  { symbol table }
  PasTab : array[1..SymMax]of Sym_Rec;  { PSL to Pascal conversion table }
  ErrorCol,
  CaseCounter,
  TableCaseLimit : integer;
  Weight_Mode,
  Errorline      : integer;
  Percentage,
  PoundSign,
  Write_Mode     : boolean;
  UpSymbol,
  Symbol : Shortstr;
  TempCh : char;
  TxVarNo,
  HsVarNo : integer;
  IdFile  : TEXT;
  PolicyFile : TEXT;
  Spec_Vars  : Array [1..MaxRaws] of integer;
  MainFact : Real;
  CurDirSt : String;
  Out_Vars   : Array [1..TotalVars] of Integer;
  Out_Vars_Orig : Array [1..TotalVars] of Integer;
  Out_Var_No : integer;


Function VertChar: char;
Function UpCaseNewStr(Instring : str50):str50;
Function FindVarNumber(varn: String): integer;
Function FindOutVarNumber(varn: Str50): integer;

Implementation

Function VertChar: char;
var
  reg           : registers;
  Response      : byte;
  ch            : char;

begin
  response := 0;
  ch       := #0;
  repeat
    if MouseInst then
       begin
          GetButtonPress(1, ButtonStat, ButCount1, MickeyCol, MickeyRow);
          GetButtonPress(2, ButtonStat, ButCount2, MickeyCol, MickeyRow);
          GetMouse(MickeyCol, MickeyRow, ButtonStat);
          if ButCount1 > 0 then
             Response := 1
          else if ButCount2 > 0 then
             Response := 28
          else if (MickeyRow > MouseRow) then
             Response   := 80
          else if (MickeyRow < MouseRow) then
             Response   := 72
       end;
    reg.ah := 1;  { invoke the BIOS call that checks for a keystroke }
    Intr ($16, Reg);
    if not(boolean (reg.flags and $40)) then
       begin
         reg.ah := 0; { A keystroke is there; take it out of the BIOS buffer }
         Intr ($16, reg);
         Ch := Char(Reg.al);
         if ((Byte(Ch) = 0) OR (Reg.Al in [27,13])) then
            Response := Reg.Ah;
       end;
    if response <> 0 then
       begin
          Case Response of
             1 : Ch := #27;
             28: Ch := #13;
             75: Ch := CursorLeft;       { Left-Arrow Key                     }
             77: Ch := CursorRight;      { Right-Arrow Key                    }
             80: Ch := CurSorDown;
             72: Ch := CurSorUp;
             else Ch := #0;
          end;
       end
    else if ch in ['A'..'Z','a'..'z'] then
       Response := Byte(ch);
  Until Response <> 0;
  MouseCol := 312;
  MouseRow := 48;
  SetMouse(MouseCol, MouseRow);
  VertChar := upcase(ch);
end;

Function UpCaseNewStr(Instring : str50):str50;
   { This takes a string supplied to it and returns it all in }
   { capital letters }
var
  outstring : str50;
  i : integer;
begin
   OutString:=Instring;
   for i:=1 to Length(Instring) do Outstring[i]:=Upcase(Instring[i]);
   UpCaseNewStr:=OutString;
end;

Function FindVarNumber(varn: String): integer;
        { This takes a string input as a parameter and finds if }
        { there is a variable in the variable array with the same name }
  var
    stresult,
    i    : integer;
    temp : str50;
  Begin
    stresult := length(Varn);
    if (stresult=0) then
      begin
        FindVarNumber:=0;
        exit;
      end;
    Temp:=UpcaseNewStr(Varn);
    i:=1;
    while((i <= HighestVar) AND (UpcaseNewStr(VarArray[i]^.LongPtr^)<>temp)) do
        i:=i+1;
    if (i>HighestVar) then
        i:= HighestVar;
    if (UpcaseNewStr(VarArray[i]^.LongPtr^)=temp) then
        begin
          FindVarNumber:=i;
          exit;
        end;
    FindVarNumber:=0;
  end;

Function FindOutVarNumber(varn: Str50): integer;
        { This takes a string input as a parameter and finds if }
        { there is a variable in the variable array with the same name }
  var
    bools,
    i    : integer;
    temp : str50;

  Begin
    Temp:=UpcaseNewStr(Varn);
    i:=1;
    bools:= 0;
    while((UpcaseNewStr(VarArray[i]^.LongPtr^)<>temp) AND (i <= HighestVar)) do
       begin
         if (varArray[i]^.ifbool=TRUE) then
           bools:= bools+1;
         if (varArray[i]^.ifreal=TRUE) then
           bools:= bools+1;
         i:=i+1;
       end;
    if (UpcaseNewStr(VarArray[i]^.LongPtr^)=temp) then
        begin
          FindOutVarNumber:=i-bools;
          exit;
        end;
    FindOutVarNumber:=0;
  end;

end.