Unit ToolStat;

Interface

Uses
   Dos,
   Crt,
   EdVar,
   StatVar,
   ScreenWP,
  // EditCom,
   InitDat,
   Mouse;

    Function GetLabel( varpt : varptr; valu : integer;var labl : String78;
                   max : integer): boolean;
    Procedure ShortenLabel( var shortlabel : String78; labl : String78;
                        width : integer);
    Function OpenVarFile (name : str50; var filenum : integer):boolean;
    function GetInt(var default  : integer;
                         min,max  : integer;
                         col,line : byte;
                         MessageStr : string ; st1 : string): boolean;
    Function GetNumber(col, line : integer; prompstr  : String80): Integer;
    Function ShowTheTime:Str50;
    Procedure ShowTimeEstimate(StartTime: LongInt; CaseLim : LongInt);
    Function SecondsToTime(var intime : LongInt): String78;
    Procedure InitialiseTimeDisplay;
    Function CurrentTime: LongInt;
    Procedure Selwin (Vary : Variable_Array; TitleStr : str50;
                 var selstring: Str50);
    Function DeleteVariable (name : str50;
                         var in_array : variable_array): boolean;
    Function InsertVariable (name : str50;
                         var in_array : variable_array): boolean;
    Procedure DeleteUserVar(DeleteVar: Namestr);
    Procedure ReadBuf;
    Function ReadComp (num : byte): LongInt;
    Function UpCaseNewStr(Instring : str50):str50;
    Function UpCaseStr(Instring : string):string;
    Function TokenToSymbol(tok: integer):Shortstr;
//    Procedure FindNextLine;
    Procedure ReadSymbol;
    Function NumStr(InNum : LongInt):String;
    Function StrNum(Instring : ShortStr): Longint;
    Procedure ChangeDir(Inst : string);

Implementation


{ ShortenLabel shortens the label input in shortlabel and if the label }
{ has to truncated in adds '..' to the end }

Procedure ShortenLabel( var shortlabel : String78; labl : String78;
                        width : integer);
begin
    shortlabel:=labl;
    Delete(ShortLabel,width,(Length(Labl)-(width-2)));
    if (Length(labl)> Width) then ShortLabel:=ShortLabel + '..';
end;

{ Given 'Label' copy it to 'shortlabel', truncating it if it is too long
  and adding '..' to indicate truncation }

Function GetLabel( varpt : varptr; valu : integer;var labl : String78;
                   max : integer): boolean;
   { For a specific variable find out whether there is a value label }
   { associated with it.  If there is it is returned in the form of a }
   { string }
var
      i,
      codeinx,
      maxlabs : integer;
      strin   : string[8];

begin
     GetLabel:=false;
     if VarPt^.IfvalLabs then
        begin
           strin:=VarPt^.ValPtr^.V_Ary[0]^;
           val(strin, maxlabs, codeinx);
           i:=0;
           repeat
               i:=i + 1;
           until ((i=MaxLabs) or (VarPt^.ValPtr^.N_Ary[i]=valu));
           if VarPt^.ValPtr^.N_Ary[i]=valu then
             begin
                labl:=Varpt^.ValPtr^.V_Ary[i]^;
                ShortenLabel(labl, labl, max);
                GetLabel:=true;
             end;
        end;
end;

Function OpenVarFile (name : str50;
                                var filenum : integer):boolean;
var
   i,
   Varnumber : integer;

begin
    filenum:=0;
    VarNumber:=FindVarNumber(name);
    if VarNumber = 0 then
      begin
        if (Reserved_Word(name)=TRUE) then
            OpenVarfile:= TRUE
        else
            OpenVarfile := false;
      end
    else
      begin
        OpenVarfile := true;
        for i:= 1 to OpenFiles do
           begin
              If VarNumber = Files[i] then
                 begin
                    filenum := i;
                    exit;
                 end;
           end;
        OpenFiles := OpenFiles + 1;
        Files[OpenFiles] := VarNumber;
        Filenum := OpenFiles;
      end;
end;

Procedure ReadBuf;
begin
   read(DataFile,DataBuf);
   if (eof(DataFile)) then LastCaseDone := True;
end;

Function ReadComp (num : byte): LongInt;
begin
  ReadComp:= DataBuf[Files[num]];
end;

function GetInt(var default  : integer; { default value to be displayed }
                         min,max  : integer;
                         col,line : byte;
                         MessageStr : string ; st1 : string): boolean;
{
1.  Proc. Name
    GetInteger -- read an integer from the keyboard

2.  Functional Description
    The default value of the number is displayed on the screen and if an
    integer is entered, a new number is calculated. Because the numbers are
    entered as characters, the number must be built from the characters
    and range checking must performed during this build routine to make sure
    the number is not out of integer range. The number is terminated by
    a carriage return or an escape. The escape resets the value of the
    number to the default value. Finally the number is assigned to the
    un-typed paramater st1 by using TURBO's move command.
}
var
  nst:String[5];
  oldmemadr:integer;
  ch : char;
  num, err,
  curpos,
  OldNum : integer;
  newnum:boolean;
  SaveCursor: integer;
begin { procedure GetInteger }
  SaveCursor := GetCursorMode;       { set cursor display on                 }
  SetCursorMode (CursorOn);
  GetInt:= true;
  oldx := wherex;
  oldy := wherey;
  SetMemaddress (col, line);
  MenuColor := WLowColor;            { set display color                     }
  WriteString (MessageStr);
  MenuColor := WNormColor;           { set dislpay color                     }
  num := default;
  newnum := true;                    { set flag to indicate that we have just}
  repeat                             { begun to build this number            }
    repeat
      str(num:5,nst);
      curpos := ord(nst[0]);
      oldmemadr := memadr;           { save current address on screen        }
      WriteString(nst);              { display value of number               }
      gotoxy(col + curpos - 1 + (Length(MessageStr)),line);
      memadr := oldmemadr;           { reset original screen address         }
      ch := ReadChar;                { get next character of number          }
      if ch in ['0'..'9'] then
      begin
        if newnum then
          num := 0;
        if num < (maxint div 10) then  { check number of digits in number    }
          num := (num * 10) + (ord(ch) - 48);
      end;
      if ch in [^S,^H] then          { if left-arrow or back-space key then  }
        num := num div 10;           { divide by 10 to decrement the number  }
      newnum := false;               { not a new number now                  }
    until ch in [#13,#27];           { until c/r, ESC                        }
    if (ch = #13) and ((num > max) or (num < min)) then
      begin
         Sound(220);
         Delay(200);
         NoSound;
         ch := #0;
      end;
  until ch in [#13,#27];             { until c/r, ESC                        }
  if ch <> #13 then
   begin
     num := default;
     GetInt:= false;
   end
  else
     default:= num;
  SetCursorMode(SaveCursor);
  gotoxy(oldx,oldy);
end;  { procedure GetInt}

Function GetNumber(col, line : integer;
                               prompstr  : String80): integer;
var
    ColMark,
    Win_Width : Integer;
    defnum    : Integer;
    OK        : Boolean;
    Message   : String[25];
    Prompt    : String80;

begin
   Prompt := PrompStr + '  ';
   Win_Width  := length(prompt) + 12;
   colmark := 40 - ((length(prompt) + 12) div 2);
   MakeWindow(colmark,line,Win_Width,3);
   defnum := 0;
   Message := ' ';
   OK := GetInt(defnum,0,20000, colmark+2, line + 1,prompt,message);
   GetNumber:= defnum;
   RestoreWindow(colmark,line,Win_Width,3);
end;

Function ShowTheTime:Str50;
   { find out the time from the computer's internal clock and then }
   { return the time in the form of a string }
type
   TimeString = string[8];
Var
   OutString : Str50;

   function time: TimeString;

   var
     hourt, mint, sect, sec100t : word;
     hour,min,sec:     string[2];

   begin
       GetTime (hourt, mint, sect, sec100t);
       begin
          str(hourt, hour);                  {convert to string}
          str(mint , min);                       { " }
          str(sect , sec);                       { " }
       end;
       time := hour+':'+min+':'+sec;
   end;

begin
   OutString:=Time;
   ShowTheTime:=OutString;
end;

Function CurrentTime: LongInt;
    { Find the time and then return it as a string }

var
  HourNumFlag,
  MinNumFlag,
  SecNumFlag,
  Sec100NumFlag    : Word;
  HourTot,
  MinTot,
  SecTot,
  Sec100Tot  : longint;

begin
  GetTime (HourNumFlag, MinNumFlag, SecNumFlag, Sec100NumFlag);
  HourTot := HourNumFlag * 360000;
  MinTot  := LongInt(MinNumFlag)  * LongInt(6000);
  SecTot  := SecNumFlag * 100;
  Sec100Tot := Sec100NumFlag;
  CurrentTime := HourTot + MinTot + SecTot + Sec100Tot;
end;

Procedure InitialiseTimeDisplay;
       { Open a message window showing the time that a given procedure }
       { started  }
var
  outstr : string78;
begin
  OutStr:=ShowTheTime;
  OutStr:=OutStr + '  Please wait for an estimate of how';
  ShowMessage('Starting to Process Raw Data Cases at',OutStr,
                    'Long it will take run through all the cases');
end;

Function SecondsToTime(var intime : LongInt): String78;
   { take a quantity in seconds and return it as string }
var
  hr, min, sec : string[2];
  num : LongInt;
begin
  Num := Intime div 360000;
  Str(Num:2, Hr);
  Intime := Intime - (Num * 360000);
  Num := Intime div 6000;
  Str(Num:2, Min);
  Intime := Intime - (Num * 6000);
  Num := Intime div 100;
  Str(Num:2, Sec);
  SecondsToTime := hr + ':' + min + ':' + sec;
end;

Procedure ShowTimeEstimate(StartTime: LongInt; CaseLim : LongInt);
    { show an estimate of how long a given procedure will take to execute}
    { it achieves this by measuring how long it takes to execute the }
    { first 100 cases and then extrapolating to the full data set }
var
   EndTime,
   MidTime : LongInt;
   GapTime : Real;
   Time1,
   Time2  : String78;
   CaseNo : Real;
begin
   MidTime:=CurrentTime;
   if (CaseNo > 18558) then
      CaseNo := 18558
   else
      CaseNo := Int(CaseLim);
   GapTime:=Round((MidTime - StartTime) * (CaseNo / 1000));
   EndTime:=StartTime + Round(GapTime);
   Time1:=SecondsToTime(StartTime);
   Time2:=SecondsToTime(EndTime);
   CloseMessageWindow;
   ShowMessage('Started at ' + Time1 + '  Predicted To End at ' + Time2,
                       'Currently Processing Case  100',
                       'Press ESCAPE to stop');
   Menucolor:=PLowColor;
end;

Procedure Selwin (Vary : Variable_Array; TitleStr : str50;
                 var selstring: Str50);
       { this procedure displays a pop-up menu on the screen and allows }
       { the user to use the mouse or cursor keys to move up and down in}
       { the window through a list of variable names or value labels }
       { If the user presses return or escape then the procedure terminates}
       { The Return key will cause the array item currently highlighted }
       { to be inserted in the text window and the current cursor position }
       { The Escape key will close the window without having any effect on }
       { the text editing window }

const
   EndMark : str50 = '----------- End of List -----------';
   Footer  : str50 = ' RETURN to Choose, ESCAPE to Exit ';
   HighOn  : boolean = true;
   HighOff : boolean = false;
   CurCol  = 19;
   CurRow  = 5;
   Num_of_Cols = 42;
   Up         : Byte = 72;
   Down       : Byte = 80;
   PageUp     : Byte = 73;
   PageDown   : Byte = 81;
   Return     : Byte = 28;
   Escape     : Byte = 1;

var
    Answer : byte;
    OldStart,
    StartPos,
    OldWinPos,
    NewWinPos,
    CurPos,
    OldCurPos,
    Array_Len,
    Win_Len,
    textcol,
    textrow : Integer;

Procedure Find_Array_Length;
     { This finds how many lines the pop up window should take up }
     { based on the length of the array the window is to display }
var
    stringin : str50;
    codeinx     : integer;
begin
    StringIn:=Vary[0]^;
    Val(StringIn, Array_Len, Codeinx);
    if Array_Len<7 then
       Win_Len:=Array_Len
   else
       Win_Len:=7;
end;

Procedure Display(WinPos : Integer; Array_Pos : Integer; HighStat : boolean);
       { This writes an array item at a given position within the window }
       { highlighting it or not as indicated by the parameter Highstat }
var
   cnt : integer;
begin
   If HighStat then MenuColor:=PlowColor;
   SetMemAddress(CurCol+1,CurRow+WinPos);
   WriteString(Vary[Array_Pos]^);
   For cnt:=Length(Vary[Array_Pos]^) to (Num_Of_Cols - 3) do WriteChar(32);
   if HighStat then MenuColor:=PFrameColor;
end;

Procedure SetUpScreen;
    { when selwin is first called this will draw a window of the appropriate }
    { length on the top half of the screen.  It will then fill it with items }
    { from the relevant array of variable names or value labels, and will }
    { highlight the uppermost array item }
var
   Screencnt : integer;
begin
 {  Find_Array_Length;
   MakeWindow(CurCol,CurRow,Num_Of_Cols,(Win_Len + 2));
   setmemaddress(CurCol+((Num_of_Cols-Length(TitleStr))div 2),CurRow);
   MenuColor:=PlowColor;
   WriteString(TitleStr);
   MenuColor:=PframeColor;
   Display(1,1,HighOn);
   ScreenCnt:=2;
   while ((ScreenCnt<=Array_Len) and (ScreenCnt<=Win_Len)) do
      begin
         Display(ScreenCnt,ScreenCnt,HighOff);
         ScreenCnt:=ScreenCnt+1;
      end;
   SetMemAddress(CurCol+((Num_of_Cols-(Length(Footer)))div 2),CurRow+Win_Len+1);
   MenuColor:=PlowColor;
   WriteString(Footer);
   MenuColor:=PframeColor;
   CurPos:=1;
   StartPos:=1;
   NewWinPos:=1;
   Answer:=down;   }
end;

Procedure Fill_Window;
     { This will fill the pop up window with array items according }
     { to which array item is uppermost in the window.  If the user }
     { has pushed the mouse up, for example, this will cause the uppermost}
     { line to display an item nearer to the beginning of the array.  If }
     { it moves past the first item, then the last item is shown. }
var
   win : integer;
begin
   if Answer in [Escape, Return] then exit;
   if StartPos=OldStart then
      begin
         Display(OldWinPos, OldCurPos, HighOff);
         Display(NewWinPos, CurPos, HighOn);
      end
   else
      Begin
         Win:=0;
         repeat
             if (win+1)=NewWinPos then
                 Display((Win+1),(((StartPos+(Win-1)) mod Array_Len)+1),HighOn)
             else
                 Display((Win+1),(((StartPos+(Win-1)) mod Array_Len)+1),HighOff);
             win:=win+1;
         until Win=Win_Len;
      end;
end;

Procedure Find_Start_Position;
   { This procedure finds the first array item to be displayed in the }
   { pop up window, based on which key the user presses.  The cursor }
   { up key will move towards the beginning of the array, cursor down will }
   { move to the end, the return or escape keys will exit from the procedure}

Begin
    Answer:=Direction;
    OldStart:=StartPos;
    OldCurPos:=CurPos;
    OldWinPos:=NewWinPos;
    if Answer in [Escape, Return] then
       exit
    else if Answer = Up then
       begin
           If CurPos = 1  then
              begin
                 if StartPos in [1,Array_Len] then
                    begin
                       NewWinPos:=1;
                       StartPos:=Array_Len-1;
                       CurPos:=Array_Len-1;
                    end
                 else
                    begin
                       NewWinPos:=NewWinPos-2;
                       CurPos:=Array_Len-1;
                    end;
              end
           else if CurPos = StartPos then
              begin
                  StartPos:=StartPos-1;
                  CurPos:=CurPos-1;
              end
           else
              begin
                  CurPos:=CurPos-1;
                  NewWinPos:=NewWinPos-1;
              end;
       end
    else if Answer = Down then
       begin
            If CurPos=(Array_Len-1) then
               CurPos:=1
            Else
               CurPos:=CurPos+1;
            if OldCurPos=(Array_Len - 1) then
               NewWinPos:=NewWinPos+2
            Else
               NewWinPos:=NewWinPos+1;
            If NewWinPos>Win_Len then NewWinPos:=Win_Len;
            If NewWinPos=Win_Len then
              begin
                  If CurPos<Win_Len then
                     StartPos:=(Array_Len - (Win_Len - (CurPos +1)))
                  Else
                     StartPos:=(CurPos - (Win_Len -1));
              end;
       end
    else if Answer = PageUp then
       begin
           If CurPos>Win_Len then
              CurPos:=CurPos - Win_Len
           Else
              begin
                CurPos:=((Array_Len - 1) - (Win_Len - CurPos));
                if CurPos=0 then
                   CurPos:=1;
              end;
           If CurPos - (NewWinPos - 1) >= 1 then
              StartPos:=CurPos - (NewWinPos - 1)
           Else
              StartPos:=Array_Len - (NewWinPos - (CurPos +1));
       end
    else if Answer = PageDown then
       begin
           CurPos:=((CurPos + (Win_Len-1)) Mod (Array_Len - 1))+1;
           If CurPos - (NewWinPos-1) >= 1 then
              StartPos:=CurPos - (NewWinPos - 1)
           Else
              StartPos:=Array_Len - (NewWinPos - (CurPos +1));
       end;
End;

Function InvalidArray : boolean;
begin
   InvalidArray:=false;
   if Vary[0]^='1' then
      begin
          ShowMessage('There are no variables in this',
                             'Category to Display','Press Yes to contine');
          InValidArray:=true;
      end;
end;


Begin                     { Main Block of Selwin Procedure }
    SetCursorMode(CursorOff);
    GetMouse(SelWinMouseCol, SelWinMouseRow, ButtonStat);
    selstring:='';
    If InvalidArray then
       begin
         SetCursorMode(CursorOn);
         exit;
       end;
    SetUpScreen;
    Repeat
       Find_Start_Position;
       Fill_Window;
    Until Answer in [Escape, Return];
    if Answer = Escape then
       selstring:=''
    else
       begin
         selstring:=Vary[Curpos]^;
         if (pos(' ',selstring)<>0) then delete(selstring,pos(' ',selstring),
                              (length(selstring)-pos(' ',selstring))+1);
       end;
    RestoreWindow(CurCol,CurRow,Num_Of_Cols,(Win_Len + 2));
    SetMouse(MouseCol, MouseRow);
    SetCurSorMode(CursorOn);
end;                      { Main Block of Selwin Procedure }


Procedure ChangeDir(Inst : string);
begin
   {$I-}
   Chdir(inst);
   {$I+}
   If (IOresult <> 0) then
      begin
         LexicalError('The Directory '+ Inst,
                   'was not found. Program Aborting','- Press ESC ');
         Halt;
      end;
end;

Function DeleteVariable (name : str50;
                         var in_array : variable_array): boolean;
    { Delete a Variable from the Variable Array }
var
   codeinx,
   endpos,
   curpos,
   Arycnt : integer;
   testvar,
   NewName : str50;
   CurStr  : Str50;
begin
   DeleteVariable:= true;
   Val(In_array[0]^,endpos,codeinx);
   AryCnt:=0;
   NewName:=UpCaseNewStr(Name);
   repeat;
      AryCnt:=succ(AryCnt);
      TestVar := UpCaseNewStr(In_Array[AryCnt]^);
      if (pos(' ',testvar)<>0) then delete
          (testvar,pos(' ',testvar),(length(testvar)-pos(' ',testvar))+1);
   until ((AryCnt >= endpos) or (TestVar=NewName));
   If UpcaseNewStr(In_Array[AryCnt]^) <> NewName then
      begin
         Deletevariable:=false;
         exit;
      end;
   curpos:=AryCnt;
   if endpos >= Curpos then
      begin
          for AryCnt:=curpos to (endpos - 1) do
              In_array[AryCnt]^:=In_array[AryCnt + 1]^;
      end;
   In_array[endpos]^:='JUNK';
   EndPos:=Pred(EndPos);
   Str(endpos, NewName);
   In_array[0]^:=NewName;
end;

Function InsertVariable (name : str50;
                         var in_array : variable_array): boolean;
   { Insert a Variable into the Variable Array }
var
   codeinx,
   curpos,
   endpos,
   cnt : integer;
   NewName : str50;
   CurStr  : Str50;
begin
   InsertVariable:= true;
   Val(In_array[0]^,endpos,codeinx);
   cnt:=0;
   NewName:=UpCaseNewStr(Name);
   repeat;
      cnt:=succ(cnt);
   until ((cnt >= endpos) or (UpCaseNewStr(In_Array[cnt]^) >= NewName));
   If UpcaseNewStr(In_Array[cnt]^) = NewName then
      begin
          insertvariable:=false;
          exit;
      end;
   curpos:=cnt;
   if endpos >= Curpos then
      begin
         If In_array[Endpos + 1]^<>'JUNK' then
            New(In_array[ EndPos + 1]);
         for cnt:=(EndPos + 1) downto (CurPos + 1) do
            In_array[cnt]^:=In_array[cnt - 1]^;
      end;
   codeinx:=findvarnumber(name);
   while (length(name) < 28) do
      name := name + ' ';
   name := name+' | '+VarArray[codeinx]^.Varname;
   if (codeinx=0) then
      name := name + 'CALC'
   else
      name := name + VarArray[codeinx]^.VarName;
   In_array[curpos]^:=Name;
   EndPos:=Succ(EndPos);
   Str(endpos, NewName);
   In_array[0]^:=NewName;
end;

Procedure DeleteUserVar(DeleteVar: Namestr);
   { Delete a user-created variable from the variable array }
   { and rewrite the file of file names without the deleted file name }
var
  dummyOK : boolean;
  filenum : integer;

begin
  filenum:= findvarnumber(DeleteVar);
  dummyOK:=DeleteVariable(DeleteVar, Tot_Var_Ary);
  dummyOK:=DeleteVariable(DeleteVar, User_Array);
  if VarArray[FileNum]^.IfVallabs then
     DummyOK:=DeleteVariable(DeleteVar, Value_Label_Ary);
  Case Anal_Level[1] of
     Household  : begin
                     DummyOK:=DeleteVariable(DeleteVar,Hhold_Array);
                     If VarArray[FileNum]^.IfValLabs then
                        DummyOK:=DeleteVariable (DeleteVar, HHold_Cat_Ary);
                  end;
     Family     : begin
                     DummyOK:=DeleteVariable(DeleteVar, Taxun_Array);
                     If VarArray[FileNum]^.IfValLabs then
                         DummyOK:=DeleteVariable (DeleteVar, Taxun_Cat_Ary);
                  end;
     Individual : begin
                     DummyOK:=DeleteVariable(DeleteVar, Ind_Array);
                     If VarArray[FileNum]^.IfValLabs then
                         DummyOK:=DeleteVariable (DeleteVar, Ind_Cat_Ary);
                  end;
  end;
end;

Function UpCaseNewStr(Instring : str50):str50;
   { This takes a string supplied to it and returns it all in }
   { capital letters }
var
   outstring : str50;
   i : integer;
begin
   OutString:=Instring;
   for i:=1 to Length(Instring) do Outstring[i]:=Upcase(Instring[i]);
   UpCaseNewStr:=OutString;
end;

Function UpCaseStr(Instring : string):string;
   { This takes a string supplied to it and returns it all in }
   { capital letters }
var
  outstring : string;
  i : integer;
begin
   OutString:=Instring;
   for i:=1 to Length(Instring) do Outstring[i]:=Upcase(Instring[i]);
   UpCaseStr:=OutString;
end;

Function TokenToSymbol(tok: integer):Shortstr;
            { convert a numerical token to its corresponding string }
            { so that it can be output on the screen }
var
   i: integer;
   ch : char;
begin
   i:=1;
   if tok<>0 then
     while ((SymTab[i].tokn<>tok) and (SymTab[i].tokn<>eof1)) do
       begin
         i:=i+1;
       end;
   if ((tok<>eof1) and (tok<>0)) then
      TokenToSymbol:=SymTab[i].symbol
   else
    begin
      TokenToSymbol:='UNKNOWN SYMBOL';
      GlobErr:=true;
    end;
end;

procedure Advance;
      { move on character forward }
begin {Advance of ReadSymbol}
    with Curwin^ do
      if (Colno >= Curline^.BuffLen) and (Curline^.Fwdlink <> nil) then
        begin
          Curwin^.Clineno := Succ (Curwin^.Clineno);
          Curline := Curline^.Fwdlink;
          if Lineno = (Lastlineno-Firstlineno) then
            Topline := Topline^.Fwdlink
          else
            Lineno := Succ (Lineno);
          Colno := 1;
          //EditUpdPhyScr;          JUNE2009
        end
      else
        Colno := Succ (Colno)
end; {Advance of ReadSymbol}


function EndOfStream : boolean;
begin {EndOfStream of ReadSymbol}
    with Curwin^ do
      EndOfStream := (Colno >= Curline^.BuffLen) and (Curline^.Fwdlink = nil)
end; {EndOfStream of ReadSymbol}


  {
Procedure FindNextLine;
   var
      st1 : namestr;
      i   : Integer;
   begin
     EditEndLine;
     with Curwin^ do
       begin
         if Colno > Curline^.BuffLen then
           Colno := Curline^.BuffLen;    }
         // if not(Curline^.Txt^ [Colno] in ['!'..'}','']) then
         {  begin
             repeat
               i := Colno;
               while (i <= Curline^.BuffLen) and       }
          //        not(Curline^.Txt^ [i] in ['!'..'}','']) do i := Succ (i);
        {       if (i > Curline^.BuffLen) then
                 begin
                   Colno := Curline^.BuffLen;
                   Advance;
                   if Colno > Curline^.BuffLen then Colno := Curline^.BuffLen;
                 end
               else if (i <= Curline^.BuffLen) then
                 Colno := i;  }
            // until EndofStream or (Curline^.Txt^ [Colno] in ['!'..'}','']);
       {    end;
       end;
       If (EndofStream) then Symbol := 'EOF1';
   end;    }

Procedure ReadSymbol;
{  This routine moves the cursor in the current window right one word. }
var
  i : integer;
  LengthCnt,
  Startclass : integer;

  Procedure FindNextWord;
       { find the beginning of the next word }
   var
      st1 : namestr;
   begin { FindNextWord }
     with Curwin^ do
       begin
         if Colno > Curline^.BuffLen then
           Colno := Curline^.BuffLen;
         if not(Curline^.Txt^ [Colno] in ['!'..'}','']) then
           begin
             repeat
               i := Colno;
               while (i <= Curline^.BuffLen) and
                  not(Curline^.Txt^ [i] in ['!'..'}','']) do i := Succ (i);
               if (i > Curline^.BuffLen) then
                 begin                       {The rest of this line is blank}
                   Colno := Curline^.BuffLen;
                   Advance;
                   if Colno > Curline^.BuffLen then Colno := Curline^.BuffLen;
                 end
               else if (i <= Curline^.BuffLen) then
                 Colno := i;                  {Else, nothing to do}
             until EndofStream or (Curline^.Txt^ [Colno] in ['!'..'}','']);
           end;
       end;
   end;

  function Class_Func : integer;
  var Ch : char;
  begin {Class of ReadSymbol}
    with Curwin^ do
      Ch := Curline^.Txt^ [Colno];
    if not(Ch in ['!'..'}','']) then Class_Func := 1
    else if Ch = '' then Class_Func := 2
    else if Ch in ['A'..'Z','a'..'z'] then Class_Func := 3
    else if Ch in ['0'..'9'] then Class_Func := 4
    else if Ch in ['<','>'] then Class_Func:=5
    else if Ch in ['[',']','.','(',')','%',':','+','=','-','*','/'] then Class_Func := 6;
  end; {Class of ReadSymbol}

  function ReClass : integer;
  var Ch : char;
  begin {Class of ReadSymbol}
    with Curwin^ do
      Ch := Curline^.Txt^ [Colno];
    if not(Ch in ['!'..'}','']) then ReClass := 1
    else if Ch in ['0'..'9'] then
       begin
          if StartClass = 3 then
            Reclass:=3
          else if StartClass = 4 then
            Reclass:=4
       end
    else if Ch in ['A'..'Z','a'..'z','&','','$','_',''''] then ReClass := 3
    else if Ch in ['='] then ReClass:=5
    else ReClass:=7;
  end; {ReClass of ReadSymbol}

  procedure Advance;
      { move on character forward }
  begin {Advance of ReadSymbol}
    with Curwin^ do
      if (Colno >= Curline^.BuffLen) and (Curline^.Fwdlink <> nil) then
        begin
          Curwin^.Clineno := Succ (Curwin^.Clineno);
          Curline := Curline^.Fwdlink;
          if Lineno = (Lastlineno-Firstlineno) then
            Topline := Topline^.Fwdlink
          else
            Lineno := Succ (Lineno);
          Colno := 1;
          // EditUpdPhyScr;   JUNE2009
        end
      else
        Colno := Succ (Colno)
  end; {Advance of ReadSymbol}

  function EndOfStream : boolean;
  begin {EndOfStream of ReadSymbol}
    with Curwin^ do
      EndOfStream := (Colno >= Curline^.BuffLen) and (Curline^.Fwdlink = nil)
  end; {EndOfStream of ReadSymbol}

  procedure Skip_Comment;
  var Ch1 : char;

  begin
    with Curwin^ do
      Ch1 := Curline^.Txt^ [Colno];
    If (ch1 = '{') then
       begin
         repeat
           Advance;
           with Curwin^ do
              Ch1 := Curline^.Txt^ [Colno];
         until ((Ch1 = '}') or EndofStream);
         Advance;
         findnextword;
       end;
  end;

  Procedure SetPushChar;
       { find the first character of the next word and put it in a special }
       { variable "PushChar" }
   begin
     with Curwin^ do
        begin
           if not(Curline^.Txt^ [Colno] in ['!'..'}','']) then
             begin
                while (Colno < Curline^.BuffLen) and not(Curline^.Txt^ [Colno] in ['!'..'}','']) do
                  Advance;
                If ((Colno < Curline^.Bufflen) and (Curline^.Txt^ [Colno] in ['!'..'}',''])) then
                  TempCh:=Curline^.Txt^ [ColNo];
                if (Curline^.Txt^ [Colno] in ['!'..'}','']) then
                   begin
                     while ((Colno > 0) and (Curline^.Txt^ [Colno] in ['!'..'}',''])) do
                        Colno := Pred (Colno);
                     Colno := Succ (Colno);
                     if Colno > Curline^.BuffLen then Colno := Curline^.BuffLen
                   end;
             end;
        end;
   end; { SetPushChar }

   Procedure ReadinSymbol;
       { read in a word from the text stream and store it in the variable }
       { symbol }
   Var
       DecPoint : Boolean;

           Procedure Check_For_Decimal_Point;
              { check to see if a decimal point has been  encountered }
              { within a numeric string }
           Begin
             With Curwin^ do
               begin
                 If ((Curline^.Txt^[ColNo] = '.') AND (StartClass = 4)) then
                  begin
                   if (Curline^.Txt^[Colno + 1] in ['0'..'9']) then
                     begin
                        If DecPoint then LexicalError ('ERROR : You Are only allowed one',
                                        'Decimal Point in the Middle','of A Number');
                        LengthCnt := LengthCnt + 1;
                        Symbol[LengthCnt]:=Curline^.Txt^[Colno];
                        Advance;
                        DecPoint := true;
                     end;
                  end;
               end;
           End;

   Begin
       DecPoint := False;
       with Curwin^ do
          begin
               Skip_Comment;
               Startclass := Class_Func;
               if StartClass > 1 then
                  begin
                     If StartClass = 2 then
                        begin
                           PoundSign := True;
                           Advance;
                           While (Curwin^.Curline^.Txt^[Colno] = ' ') Do
                                Advance;
                           StartClass := Class_Func;
                           If StartClass <> 4 then
                              LexicalError('ERROR A number must always follow a pound sign','','');
                        end;
                     LengthCnt := 1;
                     Symbol[LengthCnt]:=Curline^.Txt^[Colno];
                     Advance;
                     Check_For_Decimal_Point;
                     while (not EndOfStream) and (ReClass = Startclass)
                           and (LengthCnt < 38) do
                        begin
                           LengthCnt:=LengthCnt + 1;
                           Symbol[LengthCnt]:=Curline^.Txt^[Colno];
                           Advance;
                           Check_For_Decimal_Point;
                        end;
                     Symbol[0]:=Char(LengthCnt);
                  end;
               If StartClass = 4 then
                  begin
                     FindNextWord;
                     if Curline^.Txt^[Colno] = '%' then
                        begin
                            PerCentage := True;
                            Colno := Succ(Colno);
                        end;
                  end;
          end;
   End;

   Procedure CheckClass;
      { Check to see what type of character is currently being }
      { read in from the text stream }
   var
      st1  : namestr;
      temp : real;
      code : integer;
   begin
       Case StartClass of
           4 : begin
                 Val(Symbol, temp, Code);
                 if Code<>0 then
                     LexicalError (' A String starting with a number is invalid ','','');
               end;
           5 : begin
                 if not((Symbol ='>')  OR (Symbol ='<')  OR
                     (Symbol ='>=') OR  (Symbol ='<=')) then
                     LexicalError (' A symbol Starting with < OR > must be one of the ',
                                   ' Following : >=, <=, >, < ','');
               end;
           6 : begin
                 if not(Symbol[1] in ['.','(',')','%','',':','+','=','-','*','/','[',']']) then
                     LexicalError(' Only one of the following symbols ',
                                  ' acceptable: ., %, , :, +, =, -, *, / ','');
               end
       end;
   end;

begin
   FindNextWord;
   if (not(Globerr)) then
      begin
        ErrorCol := Curwin^.ColNo;
        ErrorLine := Curwin^.CLineNo;
      end;
   if EndOfStream then
      symbol:='EOF1'
   else
      begin
         ReadInSymbol;
         CheckClass;
         with Curwin^ do
             gotoxy(Succ (Colno-LeftEdge),FirstLineNo+LineNo);
         SetPushChar;
      end;
end;

Function NumStr(InNum : LongInt):String;
var
   NumSt : String;
begin
   Str(InNum,NumSt);
   NumStr:= NumSt;
end;

Function StrNum(Instring : ShortStr): Longint;
var
   valu : Longint;
   code : integer;
begin
   val(Instring,valu,code);
   if code = 0 then
      StrNum := valu
   else
      StrNum := 0;
end;

end.
