unit TranUtil;


Interface

Uses
    Dos,
    Crt,
    Edvar,
    Statvar,
    ScreenWP,
    //  EditCom,         { Editing Commands }
    //  KCMD,
    InitDat,
    ToolStat;

Procedure TrUtils;
Procedure New_Dict;

Implementation

var
   i,
   i2,
   maxreals,
   topval,
   newpos,
   oldhigh : integer;
   longvars: Longint;
   frontstr,
   backstr,
   Intxt   : String;
   LabStr  : String[5];
   infile,
   outfile,
   procfile,
   procdecfile : TEXT;
   levstr   : string[20];

   Procedure Write_Consts(innum : integer);
   var
      ix  : integer;
   begin
      LongVars:=LongVars+3;
      writeopen(outfile,'CONSTANT.DEF');
      writeln(outfile, '   MaxLongs = ', LongVars:4,';');
      if (maxreals > 1) then
         writeln(outfile, '   MaxReals = ', MaxReals:4,';')
      else
         writeln(outfile, '   MaxReals = 1;');
      writeln(outfile, '   MaxTUvars= ', (TxVarno+1):4, ';');
      writeln(outfile, '   HSvarno  = ', (HsVarno+1):4, ';');
      if (Write_Mode = TRUE) then
         writeln(outfile, '   Write_Mode = TRUE;')
      else
         writeln(outfile, '   Write_Mode = FALSE;');
      if (Weight_Mode = Individual) then
         writeln(outfile, '   Start_Weight = 107;')
      else if (Weight_Mode = Family) then
         writeln(outfile, '   Start_Weight = 108;')
      else if (Weight_Mode = Household) then
         writeln(outfile, '   Start_Weight = 109;')
      else
         writeln(outfile, '   Start_Weight = 107;');
      if (innum = 0) then
         writeln(outfile, '   Max_Out = 1;')
      else
         writeln(outfile, '   Max_Out = ',innum,';');
      closefile('CONSTANT.DEF',outfile);
      writeopen(outfile,'OUTREC.DEF');
      writeln(outfile,'Procedure Set_Out_Record;');
      writeln(outfile,'begin');
      for ix := 1 to innum do
        begin
          writeln(outfile,'   outrec[',ix,']:=',out_vars[ix],';');
        end;
      writeln(outfile,'end;');
      closefile('OUTREC.DEF',outfile);
   end;

   Procedure CreVar(invar : str50; lev : byte; vallabs, mony : boolean);
   var
      mess : string78;
   begin
      inc(highestvar);
      if (highestvar>=(totalvars-1)) then
         begin
             mess:= 'You have exceeded ' + Numstr(totalvars) + 'user defined variables';
             LexicalError(mess,'This constant needs to be increased',
                          'before you may continue');
             exit;
         end;
      new(VarArray[highestvar]);
      new(VarArray[highestvar]^.LongPtr);
      VarArray[highestvar]^.LongPtr^ := invar;
      VarArray[highestvar]^.Level := Lev;
      VarArray[highestvar]^.IfBool := false;
      VarArray[highestvar]^.IfVallabs := vallabs;
      VarArray[highestvar]^.IfMoney := mony;
      VarArray[highestvar]^.IfReal := False;
      VarArray[highestvar]^.IfDisplay := TRUE;
      VarArray[highestvar + 1] := Nil;
   end;

   Procedure Create_Vars;
   begin
      CreVar('Total_Taxes',individual, FALSE, TRUE);
      CreVar('Total_Benefits',individual, FALSE, TRUE);
      CreVar('Gross_Income',individual, FALSE,TRUE);
      CreVar('Net_Income_Before',individual, FALSE,TRUE);
      CreVar('Net_Income_After',individual, FALSE,TRUE);
      CreVar('Individual_Gain_or_Loss',individual,FALSE,TRUE);
      CreVar('Family_Gain_or_Loss',family,FALSE,TRUE);
      CreVar('Household_Gain_or_Loss',household,FALSE,TRUE);
      CreVar('Marg_Rate_Before',individual, FALSE,FALSE);
      CreVar('Marg_Rate_After',individual, FALSE,FALSE);
      CreVar('OldNew',individual,TRUE,FALSE);
      CreVar('All',individual,TRUE,FALSE);
      CreVar('Income_Band',individual, TRUE,FALSE);
      CreVar('Household_Type',individual, TRUE,FALSE);
      CreVar('Number_In_House',individual,FALSE,FALSE);
      CreVar('Number_In_Fam',individual,FALSE,FALSE);
      CreVar('Change_In_Income',family,TRUE,FALSE);
      CreVar('Type_of_Family',family,TRUE,FALSE);
      CreVar('Net_Family_Income',family,FALSE,TRUE);
      CreVar('Income_Quintile',family,TRUE,FALSE);
      CreVar('Income_Decile',family,TRUE,FALSE);
      CreVar('AA_Net_HH_Income_Before', household, FALSE, TRUE);
      CreVar('AA_Net_HH_Income_After',  household, FALSE, TRUE);
      CreVar('Range1',individual,FALSE,FALSE);
      CreVar('Range2',individual,FALSE,FALSE);
      CreVar('Range3',individual,FALSE,FALSE);
   end;

   Procedure Release_Vars;
   var
       i : integer;
   begin
       for i := (oldhigh + 1) to highestvar do
          begin
              dispose(VarArray[i]^.LongPtr);
              dispose(VarArray[i]);
          end;
   end;

Procedure UpdateLine;
begin
      for newpos:=1 to length(intxt) do
        intxt[newpos]:=upcase(intxt[newpos]);
      newpos := pos('^.OLDREAL',Intxt);
      if (newpos > 0) then
        begin
          repeat
            FrontStr := copy(intxt,1,(newpos-1));
            Delete(intxt,1,(newpos+8));
            Intxt := frontstr + '^.REALVAL' + intxt;
            newpos := pos('^.OLDREAL',Intxt);
          until (newpos = 0);
        end;
      newpos := pos('^.OLD',Intxt);
      if (newpos > 0) then
        begin
          repeat
            FrontStr := copy(intxt,1,(newpos-1));
            Delete(intxt,1,(newpos+4));
            Intxt := frontstr + '^.valu' + intxt;
            newpos := pos('^.OLD',Intxt);
          until (newpos = 0);
        end;
      newpos := pos('^.CRECIP',Intxt);
      if (newpos > 0) then
        begin
          repeat
            FrontStr := copy(intxt,1,(newpos-1));
            Delete(intxt,1,(newpos+7));
            Intxt := frontstr + '^.NRECIP' + intxt;
            newpos := pos('^.CRECIP',Intxt);
          until (newpos = 0);
        end;
      newpos := pos('MARG_RATE_BEFORE',Intxt);
      if (newpos > 0) then
        begin
          repeat
            FrontStr := copy(intxt,1,(newpos-1));
            Delete(intxt,1,(newpos+16));
            Intxt := frontstr + 'MARG_RATE_AFTER' + intxt;
            newpos := pos('MARG_RATE_BEFORE',Intxt);
          until (newpos = 0);
        end;
end;

Procedure TrUtils;
var
   tbnumber : integer;
   outString : string;
begin
   oldhigh := highestvar;
   create_vars;
   if (paramstr(1) = 'IX') then
      begin
         writeopen(outfile,'INDEXSYS.PAS');
         writeln(outfile, 'Procedure Init_Index;');
         writeln(outfile, 'begin');
         writeln(outfile, '   Mainfact := ',MainFact:4:4,'/ 100;');
         i := 1;
         while (Spec_Vars[i] <> 0) do
            begin
              writeln(outfile, '   Spec_Vars[',i,']:= ',Spec_Vars[i],';');
              i := i + 1;
            end;
         writeln(outfile, '   Spec_Vars[',i,']:= 0;');
         writeln(outfile, 'end;');
         closefile('INDEX.SYS',outfile);
      end;
   writeopen(outfile,'INDLONG.DEF');
   writeln(outfile, ' ');
   for i:= 1 to (RawVarMax - 1) do
         writeln(outfile,'              ',VarArray[i]^.LongPtr^,',');
   writeln(outfile,'              ',
         VarArray[RawVarMax]^.LongPtr^,' : Longint;');
   for i:= (RawVarMax + 1) to HighestVar do
      begin
        if not((VarArray[i]^.IfBool) or (VarArray[i]^.IfReal)) then
          writeln(outfile,'              ',VarArray[i]^.LongPtr^,': Longint;')
      end;
   closefile('INDLONG.DEF',outfile);
   writeopen(outfile,'INDREAL.DEF');
   maxreals := 0;
   for i:= (RawVarMax + 1) to HighestVar do
      begin
        if (VarArray[i]^.IfReal=TRUE) then
           begin
              writeln(outfile,'              ',VarArray[i]^.LongPtr^,': Real;');
              inc(maxreals);
           end;
      end;
   closefile('INDREAL.DEF',outfile);
   writeopen(outfile,'INDBOOL.DEF');
   for i:= (RawVarMax + 1) to HighestVar do
      begin
        if VarArray[i]^.IfBool then
          writeln(outfile,'              ',VarArray[i]^.LongPtr^,': Boolean;')
      end;
   closefile('INDBOOL.DEF',Outfile);
   writeopen(outfile,'TXANVAR.DEF');
   writeln(outfile, ' ');
   for i:= 1 to (TxVarNo - 1) do
         writeln(outfile,'              ','Tx',NumStr(i),',');
   Writeln(outfile,'              ','Tx',NumStr(TxVarno));
   closefile('TXANVAR.DEF',Outfile);
   writeopen(outfile,'ANAL.pas');
   writeln(outfile, ' ');
   readopen('ANAL.D',infile);
   readln(infile,Intxt);
   repeat
      writeln(outfile,Intxt);
      readln(infile,Intxt);
	until ((Copy(intxt,1,8) = '{MARKER}') or (eof(infile)));
   readln(infile,Intxt);
   repeat
      writeln(outfile,Intxt);
		readln(infile,Intxt);
	until (eof(infile));
   CloseFile('ANAL.PRG', outfile);
   writeopen(outfile,'OLDSYS.PAS');
   readopen('OLDSYS.D',infile);
   readln(infile,intxt);
   repeat
      writeln(outfile,intxt);
      readln(infile,Intxt);
   until ((Copy(intxt,1,8) = '{MARKER}') or (eof(infile)));
   closefile('INDIV.PRG',IdFile);
   readopen('INDIV.PRG',Idfile);
   writeopen(procfile,'OLDPROC.PAS');
   writeopen(procdecfile,'OLDDEC.PAS');
   writeln(procfile,'{$O+}');
   writeln(procfile,'Unit OldProc;');
   writeln(procfile,'Interface');
   writeln(procfile,'Uses');
   writeln(procfile,'   Initdat,');
   writeln(procfile,'   Analvars,');
   writeln(procfile,'   Printab;');
   writeln(procfile,' ');
   writeln(procfile,'{$I  OLDDEC.PAS}');
   writeln(procfile,'Implementation');
   tbnumber:=0;
   repeat
      readln(IdFile, InTxt);
      if (pos('START OF PROCEDURE',intxt)<>0) then
         begin
            inc(tbnumber);
            BackStr := copy(intxt,22,length(intxt)-23);
            FrontStr:= '                '+backstr+';';
            writeln(procfile,'Procedure Proc_',backstr,';');
            writeln(procdecfile,'Procedure Proc_',backstr,';');
            writeln(procfile,'Var');
            writeln(procfile,'   fam,');
            writeln(procfile,'   per : integer;');
            writeln(procfile,'Begin');
            writeln(procfile,'   Fam:=1;');
            writeln(procfile,'   Per:=1;');
            writeln(procfile,'   With Hold[fam,per] do');
            writeln(procfile,'     begin');
            readln(idfile,intxt);
            if (tbnumber=1) then
            begin
               writeln(outfile,'          fam:=1;');
               writeln(outfile,'          repeat');
               writeln(outfile,'            per := 1;');
               writeln(outfile,'            repeat');
               writeln(outfile,'               with Hold[fam,per] do');
               writeln(outfile,'               begin');
               writeln(outfile,'                  gross_income := Imputed_Personal_Income;');
               writeln(outfile,'               end;');
               writeln(outfile,'               inc(per);');
               writeln(outfile,'             until Hold[fam,per].age = MaxLint; ');
               writeln(outfile,'             inc(fam);');
               writeln(outfile,'          until Hold[fam,1].age = MaxLint; ');
            end;
            writeln(outfile,'            if (TxBn_Ary[',tbnumber,']^.oldstatus=TRUE) then');
            writeln(outfile,'    ',intxt);
            readln(idfile,intxt);
            while ((pos('END OF PROCEDURE',intxt)=0)and not(eof(idfile))) do
               begin
                   writeln(procfile,intxt);
                   readln(idfile,intxt);
               end;
            writeln(procfile,'     End');
            writeln(procfile,'End;');
            writeln(procfile,' ');
         end
      else
         writeln(OutFile, Intxt);
   until(eof(IdFile));
   CloseFile('INDIV.PRG',idfile);
   writeln(procfile,'End.');
   closefile('OLDPROC.PAS',procfile);
   closefile('OLDDEC.PAS',procdecfile);
   readln(infile,Intxt);
   repeat
      writeln(outfile,Intxt);
      readln(infile,Intxt);
   until (eof(infile));
   writeln(outfile, Intxt);
   CloseFile('OLDSYS.PAS',Outfile);
   ReadOpen('INDIV.PRG',idfile);
   WriteOpen(OutFile,'NEWSYS.PAS');
   CloseFile('OLDSYS.D',Infile);
   readopen('NEWSYS.D',infile);
   readln(infile,Intxt);
   repeat
      writeln(outfile,Intxt);
      readln(infile,Intxt);
   until ((Copy(intxt,1,8) = '{MARKER}') or (eof(infile)));
   writeopen(procfile,'NEWPROC.PAS');
   writeopen(procdecfile,'NEWDEC.PAS');
   writeln(procfile,'{$O+}');
   writeln(procfile,'Unit NewProc;');
   writeln(procfile,'Interface');
   writeln(procfile,'Uses');
   writeln(procfile,'   Initdat,');
   writeln(procfile,'   Analvars,');
   writeln(procfile,'   Printab;');
   writeln(procfile,' ');
   writeln(procfile,'{$I  NEWDEC.PAS}');
   writeln(procfile,'Implementation');
   tbnumber:=0;
   repeat
      readln(IdFile, InTxt);
      if (pos('START OF PROCEDURE',intxt)<>0) then
         begin
            inc(tbnumber);
            BackStr := copy(intxt,22,length(intxt)-23);
            FrontStr:= '                '+backstr+';';
            writeln(procdecfile,'Procedure NewProc_',backstr,';');
            writeln(procfile,'Procedure NewProc_',backstr,';');
            writeln(procfile,'Var');
            writeln(procfile,'   fam,');
            writeln(procfile,'   per : integer;');
            writeln(procfile,'Begin');
            writeln(procfile,'   Fam:=1;');
            writeln(procfile,'   Per:=1;');
            writeln(procfile,'   With Hold[fam,per] do');
            writeln(procfile,'     begin');
            readln(idfile,intxt);
            readln(idfile,intxt);
            if (tbnumber=1) then
              begin
                writeln(outfile,'          fam:=1;');
                writeln(outfile,'          repeat');
                writeln(outfile,'            per := 1;');
                writeln(outfile,'            repeat');
                writeln(outfile,'               with Hold[fam,per] do');
                writeln(outfile,'               begin');
                writeln(outfile,'                  gross_income := Imputed_Personal_Income;');
                writeln(outfile,'               end;');
                writeln(outfile,'               inc(per);');
                writeln(outfile,'             until Hold[fam,per].age = MaxLint; ');
                writeln(outfile,'             inc(fam);');
                writeln(outfile,'          until Hold[fam,1].age = MaxLint; ');
              end;
            writeln(outfile,'            if (TxBn_Ary[',tbnumber,']^.newstatus=TRUE) then');
            Intxt:= '               NewProc_'+backStr+';';
            writeln(outfile,intxt);
            readln(idfile,intxt);
            while ((pos('END OF PROCEDURE',intxt)=0)and not(eof(idfile))) do
               begin
                   UpdateLine;
                   writeln(procfile,intxt);
                   readln(idfile,intxt);
               end;
            writeln(procfile,'     End');
            writeln(procfile,'End;');
            writeln(procfile,' ');
         end
      else
         begin
            UpdateLine;
            writeln(OutFile, Intxt);
         end;
   until(eof(IdFile));
   CloseFile('INDIV.PRG',idfile);
   CloseFIle('POLICY.PRG',PolicyFile);
   writeln(procfile,'End.');
   CloseFile('NEWPROC.PAS',procfile);
   CloseFile('NEWDEC.PAS',procdecfile);
   repeat
      readln(infile,Intxt);
      writeln(outfile,Intxt);
   until (eof(InFile));
   writeln(outfile, Intxt);
   CloseFile('NEWSYS.D',InFile);
   CloseFile('NEWSYS.PAS',Outfile);
   writeopen(outfile,'CASE.DTA');
   i:= 1;
   i2:= 1;
   longvars:= 0;
   while VarArray[i]<> Nil do
      begin
           If VarArray[i]^.level = Household then
              Levstr := '            H'
           else if VarArray[i]^.level = Family then
              LevStr := '            T'
           else
              LevStr := '            I';
           if (VarArray[i]^.IfDisplay=TRUE) then
              LevStr := LevStr+' *';
           If VarArray[i]^.ifVallabs then
              LabStr := 'TRUE '
           Else
              LabStr := 'FALSE';
           if ((VarArray[i]^.IfBool=FALSE) and (VarArray[i]^.IfReal=FALSE)) then
              begin
                 if (VarArray[i]^.IfMoney) then
                    Writeln(outfile,i2:3,VarArray[i]^.LongPtr^:60,'  ',LabStr,'  MONEY',levstr)
                 else
                    Writeln(outfile,i2:3,VarArray[i]^.LongPtr^:60,'  ',LabStr,'  INTEG',levstr);
                 VarArray[i]^.VarPos := i2;
                 inc(i2);
                 inc(longvars);
              end;
           inc(i);
      end;
   i:= 1;
   while VarArray[i]<> Nil do
      begin
           If VarArray[i]^.level = Household then
              Levstr := '            H'
           else if VarArray[i]^.level = Family then
              LevStr := '            T'
           else
              LevStr := '            I';
           If VarArray[i]^.ifVallabs then
              LabStr := 'TRUE '
           Else
              LabStr := 'FALSE';
           if VarArray[i]^.IfReal then
              begin
                 Writeln(outfile,i2:3,VarArray[i]^.LongPtr^:60,'  ',LabStr,'  REAL ',levstr);
                 VarArray[i]^.VarPos := i2;
                 inc(i2);
              end;
           inc(i);
      end;
   i:= 1;
   while VarArray[i]<> Nil do
      begin
           If VarArray[i]^.level = Household then
              Levstr := '            H'
           else if VarArray[i]^.level = Family then
              LevStr := '            T'
           else
              LevStr := '            I';
           If VarArray[i]^.ifVallabs then
              LabStr := 'TRUE '
           Else
              LabStr := 'FALSE';
           if VarArray[i]^.IfBool then
              begin
                 Writeln(outfile,i2:3,VarArray[i]^.LongPtr^:60,'  ',LabStr,'  BOOLE',levstr);
                 VarArray[i]^.VarPos := i2;
                 inc(i2);
              end;
           inc(i);
      end;
   closefile('CASE.DTA',outfile);
   writeopen(outfile,'VALLAB.DTA');
   i:= 1;
   while VarArray[i]<>Nil do
       begin
            If VarArray[i]^.ifVallabs then
              if (VarArray[i]^.LongPtr^='Household_Type') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Single_Person');
                    writeln(outfile,'  2  Single_Parent');
                    writeln(outfile,'  3  Childless_Couple');
                    writeln(outfile,'  4  Nuclear_Family');
                    writeln(outfile,'  5  Single_Senior_Citizen');
                    writeln(outfile,'  6  Senior_Citizen_Couple');
                    writeln(outfile,'  7  Multi_Family_Household');
                    writeln(outfile,'  8  Error');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Income_Band') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Under_5000_PHP');
                    writeln(outfile,'  2  5000_to_10000_PHP');
                    writeln(outfile,'  3  10000_to_25000_PHP');
                    writeln(outfile,'  4  25000_to_50000_PHP');
                    writeln(outfile,'  5  50000_to_75000_PHP');
                    writeln(outfile,'  6  75000_to_100000_PHP');
                    writeln(outfile,'  7  100000_to_200000_PHP');
                    writeln(outfile,'  8  Over_200000_PHP');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Change_In_Income') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Loses  Over 10K PHP');
                    writeln(outfile,'  2  Loses  5K to 10K PHP');
                    writeln(outfile,'  3  Loses  1K to 5K PHP');
                    writeln(outfile,'  4  Loses  0 to 1K PHP');
                    writeln(outfile,'  5  No change in Income');
                    writeln(outfile,'  6  Gains  0 to 1K PHP');
                    writeln(outfile,'  7  Gains  1K to 5K PHP');
                    writeln(outfile,'  8  Gains  5K to 10K PHP');
                    writeln(outfile,'  9  Gains  Over 10K PHP');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Position_In_Family_Unit') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Head');
                    writeln(outfile,'  2  Spouse');
                    writeln(outfile,'  3  Dependent Child');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='All') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  All');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='OldNew') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Old');
                    writeln(outfile,'  2  New');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Type_of_Family') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Single');
                    writeln(outfile,'  2  Lone Parent');
                    writeln(outfile,'  3  Family');
                    writeln(outfile,'  4  Pensioner');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Income_Quintile') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Lowest Fifth');
                    writeln(outfile,'  2  Second Quintile');
                    writeln(outfile,'  3  Third Quintile');
                    writeln(outfile,'  4  Fourth Quintile');
                    writeln(outfile,'  5  Highest Fifth');
                    writeln(outfile,'END of Variable');
                 end
              else if (VarArray[i]^.LongPtr^='Income_Decile') then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    writeln(outfile,'  1  Lowest Tenth');
                    writeln(outfile,'  2  2nd Decile');
                    writeln(outfile,'  3  3rd Decile');
                    writeln(outfile,'  4  4th Decile');
                    writeln(outfile,'  5  5th Decile');
                    writeln(outfile,'  6  6th Decile');
                    writeln(outfile,'  7  7th Decile');
                    writeln(outfile,'  8  8th Decile');
                    writeln(outfile,'  9  9th Decile');
                    writeln(outfile,' 10  Highest Tenth');
                    writeln(outfile,'END of Variable');
                 end
              else
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    outString := VarArray[i]^.LongPtr^;
                    i2 := 1;
                    with VarArray[i]^.ValPtr^ do
                      begin
                        TopVal := StringToInt(V_Ary[0]^);
                        for i2 := 1 to (topval-1) do
                           writeln(outfile,N_Ary[i2]:3,'  ',V_Ary[i2]^);
                        writeln(outfile,'END of Variable');
                      end;
                 end;
            inc(i);
       end;
   closefile('VALLAB.DTA',Outfile);
   Write_Consts(Out_Var_No);
   ChangeDir(CurDirSt);
   release_vars;
   highestvar := oldhigh;
end;

Procedure New_Dict;
var
   outno : integer;
   outstr : string;
   varnstr : string;
begin
   ChangeDir(prdrive + '\POM\DATA');
   writeopen(outfile,'CASEDTA.NEW');
   i:= 0;
   i2:= 1;
   longvars:= 0;
   outno := 1;
   while (out_vars[outno]<> 0) do
      begin
           i := 0;
           repeat
             inc(i);
           until ((i = out_vars_orig[outno]) or (VarArray[i]=Nil));
           inc(outno);
           If VarArray[i]^.level = Household then
              Levstr := 'H'
           else if VarArray[i]^.level = Family then
              LevStr := 'T'
           else
              LevStr := 'I';
           If VarArray[i]^.ifVallabs then
              LabStr := 'TRUE '
           Else
              LabStr := 'FALSE';
           if not(VarArray[i]^.IfBool) then
              begin
                 outstr:= VarArray[i]^.LongPtr^;
                 while (Length(outstr)<39) do
                       outstr:= outstr+' ';
                 varnstr:= VarArray[i]^.Varname;
                 while (Length(varnstr)<8) do
                       varnstr:= varnstr+' ';
                 if (VarArray[i]^.IfMoney) then
                    Writeln(outfile,i2:3,'  ',outstr,'  ',LabStr,'  MONEY',' ',Varnstr,
                         '   ',levstr,'   XXXXXX')
                 else
                    Writeln(outfile,i2:3,'  ',outstr,'  ',LabStr,'  INTEG',' ',VarnStr,
                         '   ',levstr,'   XXXXXX');
                 VarArray[i]^.VarPos := i2;
                 inc(i2);
                 inc(longvars);
              end;
           inc(i);
      end;
   i:= 1;
   closefile('CASE.DTA',outfile);
   writeopen(outfile,'VALLAB.NEW');
   i:= 1;
   outno := 1;
   while (out_vars[outno]<> 0) do
     begin
       i := 0;
       repeat
         inc(i);
       until ((i = out_vars_orig[outno]) or (VarArray[i]=Nil));
       inc(outno);
       begin
            If VarArray[i]^.ifVallabs then
                 begin
                    writeln(outfile,VarArray[i]^.VarPos:3);
                    with VarArray[i]^.ValPtr^ do
                      begin
                        TopVal := StringToInt(V_Ary[0]^);
                        for i2 := 1 to (topval-1) do
                           writeln(outfile,N_Ary[i2]:3,'  ',V_Ary[i2]^);
                        writeln(outfile,'END of Variable');
                      end;
                 end;
            inc(i);
       end;
     end;
   closefile('VALLAB.NEW',Outfile);
   ChangeDir(prdrive + '\POM\NEW');
   writeopen(outfile,'MAXDEF.NEW');
   outno:= outno-1;
   writeln(outfile,outno,';');
   closefile('MAXDEF.NEW',outfile);
   ChangeDir(CurDirSt);
   release_vars;
end;

end.


