unit basec;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Tbaseconv = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Button3: TButton;
    Button4: TButton;
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  baseconv: Tbaseconv;

implementation

{$R *.dfm}

function DecToHex(aValue : LongInt) : String;
var
  w: Array[1..2] of Word absolute aValue;
  St: String;

  function HexByte(b: Byte): String;
  const
    Hex: Array[$0..$F] of Char = '0123456789ABCDEF';
  begin
    HexByte := Hex[b shr 4] + Hex[b and $F];
  end;

  function HexWord(w: Word): String;
  begin
    HexWord := HexByte(Hi(w)) + HexByte(Lo(w));
  end;

begin
  St := HexWord(w[2]) + HexWord(w[1]);
  while (St[1] = '0') and (Length(St) > 1) do
   Delete(St, 1, 1);
  Result := St;
end;

function HexToDec(aValue: String): LongInt;
var
  l: LongInt;
  b: Byte;
begin
  Result := 0;
  if Length(aValue) <> 0 then
   begin
     l := 1;
     b := Length(aValue) + 1;
     repeat
      dec(b);
      if aValue[b] <= '9' then Result := Result + (Byte(aValue[b]) - 48) * l
      else Result := Result + (Byte(aValue[b]) - 55) * l;
      l := l * 16;
     until b = 1;
   end;
end;

function DecToBin(aValue: LongInt): String;
var
  w: Array[1..2] of Word absolute aValue;
  St: String;

  function BinByte(b: Byte): String;
  const
    Bin: array[False..True] of Char = '01';
  begin
    Result := Bin[b and 128 = 128] + Bin[b and 64 = 64] + Bin[b and 32 = 32] + Bin[b and 16 = 16] +
              Bin[b and 8 = 8] + Bin[b and 4 = 4] + Bin[b and 2 = 2] + Bin[b and 1 = 1];
  end;

  function BinWord(w: Word) : String;
  begin
    BinWord := BinByte(Hi(w)) + BinByte(Lo(w));
  end;

begin
  St := BinWord(w[2]) + BinWord(w[1]);
  while (St[1] = '0') and (Length(St) > 1) do
   Delete(St, 1, 1);
  Result := St;
end;

function BinToDec(aValue : String) : LongInt;
var
  l : LongInt;
  b : Byte;
begin
  Result := 0;
  if Length(aValue) = 0
   then Exit;

  l := 1;
  b := Length(aValue) + 1;
  repeat
   dec(b);
   if aValue[b] = '1'
    then Result := Result + l;
   l := l shl 1;
  until b = 1;
end;


procedure Tbaseconv.Button2Click(Sender: TObject);
begin
close;
end;

procedure Tbaseconv.Button1Click(Sender: TObject);
begin
edit2.Text:=DecToBin(strtoint(edit1.Text));
edit3.Text:= DecToHex(strtoint(edit1.Text));
end;

procedure Tbaseconv.Button3Click(Sender: TObject);
var test:longint;
begin
test:=BinToDec(edit2.Text);
edit3.Text:=DecToHex(test);
edit1.Text:=inttostr(test);
end;

procedure Tbaseconv.Button4Click(Sender: TObject);
begin
edit1.Text:=inttostr(HexToDec(edit3.Text));
edit2.text:=DecToBin(strtoint(edit1.Text));
end;

procedure Tbaseconv.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, #48..#57]) then
    key:=#0;
end;

procedure Tbaseconv.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, #48..#49]) then
    key:=#0;

end;

procedure Tbaseconv.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, #48..#57, #65..#70, #97..#102]) then
    key:=#0;
end;

end.
